"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _graphCalculatorHelper = require("./graphCalculatorHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var GraphCalculator = /*#__PURE__*/function (_React$Component) {
  _inherits(GraphCalculator, _React$Component);

  var _super = _createSuper(GraphCalculator);

  function GraphCalculator(props) {
    var _this;

    _classCallCheck(this, GraphCalculator);

    _this = _super.call(this, props);
    _this.oldHighlightingNode = null;
    _this.oldSecondHighlightingNodeID = null;
    _this.oldDictionary = _this.props.dictionary;
    return _this;
  }

  _createClass(GraphCalculator, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.layoutInitialized) {
        (0, _graphCalculatorHelper.calculateGraphLayout)(this.props.dictionary, this.props.countsSearch, this.props.linksSearch).then(function (layoutResult) {
          _this2.props.onGraphLayoutCalculated(layoutResult);

          var legendItems = (0, _graphCalculatorHelper.getAllTypes)(layoutResult.nodes);

          _this2.props.onGraphLegendCalculated(legendItems);
        });
      }
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps) {
      var _this3 = this;

      var newDictionary = nextProps.dictionary;

      if (this.oldDictionary !== newDictionary) {
        this.oldDictionary = newDictionary;
        (0, _graphCalculatorHelper.calculateGraphLayout)(newDictionary, this.props.countsSearch, this.props.linksSearch).then(function (layoutResult) {
          _this3.props.onGraphLayoutCalculated(layoutResult);

          var legendItems = (0, _graphCalculatorHelper.getAllTypes)(layoutResult.nodes);

          _this3.props.onGraphLegendCalculated(legendItems);
        });
      } // if the highlighted node is updated, calculate related highlighted nodes


      var newHighlightingNode = nextProps.highlightingNode;
      var newSecondHighlightingNodeID = nextProps.secondHighlightingNodeID;

      if (this.oldHighlightingNode !== newHighlightingNode) {
        var relatedHighlightedNodeIDs = (0, _graphCalculatorHelper.calculateHighlightRelatedNodeIDs)(newHighlightingNode, this.props.nodes);
        this.props.onHighlightRelatedNodesCalculated(relatedHighlightedNodeIDs);
        var secondHighlightingNodeCandidateIDs = newHighlightingNode ? newHighlightingNode.outLinks : [];
        this.props.onSecondHighlightingNodeCandidateIDsCalculated(secondHighlightingNodeCandidateIDs);
      } // if the second highlighting node is updated, calculate related highlighting nodes


      if (this.oldSecondHighlightingNodeID !== newSecondHighlightingNodeID) {
        var pathRelatedToSecondHighlightingNode = (0, _graphCalculatorHelper.calculatePathRelatedToSecondHighlightingNode)(newHighlightingNode, newSecondHighlightingNodeID, this.props.nodes);
        this.props.onPathRelatedToSecondHighlightingNodeCalculated(pathRelatedToSecondHighlightingNode);
      } // update data model structure if update highlighting/secondHighlighting node


      if (this.oldHighlightingNode !== newHighlightingNode || this.oldSecondHighlightingNodeID !== newSecondHighlightingNodeID) {
        if (newSecondHighlightingNodeID) {
          var _this$getDataModelStr = this.getDataModelStructureForSecondHighlightingNodes(newHighlightingNode, newSecondHighlightingNodeID),
              dataModelStructure = _this$getDataModelStr.dataModelStructure,
              dataModelStructureRelatedNodeIDs = _this$getDataModelStr.dataModelStructureRelatedNodeIDs,
              routesBetweenStartEndNodes = _this$getDataModelStr.routesBetweenStartEndNodes;

          this.props.onDataModelStructureCalculated(dataModelStructure, dataModelStructureRelatedNodeIDs, routesBetweenStartEndNodes);
        } else if (newHighlightingNode) {
          var _this$getDataModelStr2 = this.getDataModelStructureForHighlightedNodes(newHighlightingNode),
              _dataModelStructure = _this$getDataModelStr2.dataModelStructure,
              _dataModelStructureRelatedNodeIDs = _this$getDataModelStr2.dataModelStructureRelatedNodeIDs,
              _routesBetweenStartEndNodes = _this$getDataModelStr2.routesBetweenStartEndNodes;

          this.props.onDataModelStructureCalculated(_dataModelStructure, _dataModelStructureRelatedNodeIDs, _routesBetweenStartEndNodes);
        } else {
          this.props.onDataModelStructureCalculated(null);
        }
      } else {
        this.props.onDataModelStructureCalculated(null);
      }

      this.oldHighlightingNode = newHighlightingNode;
      this.oldSecondHighlightingNodeID = newSecondHighlightingNodeID;
    }
  }, {
    key: "getDataModelStructureForHighlightedNodes",
    value: function getDataModelStructureForHighlightedNodes(newHighlightingNode) {
      var relatedHighlightedNodeIDs = (0, _graphCalculatorHelper.calculateHighlightRelatedNodeIDs)(newHighlightingNode, this.props.nodes); //filter circular/loop relation between nodes

      var targets = [];
      var subgraphEdges = this.props.edges.filter(function (e) {
        return relatedHighlightedNodeIDs.includes(e.source) && relatedHighlightedNodeIDs.includes(e.target);
      }).map(function (e) {
        var index = targets.indexOf(e.source);

        if (index === -1) {
          targets.push(e.target);
          return {
            source: e.source,
            target: e.target
          };
        }
      }).filter(function (e) {
        return e;
      });

      var _calculateDataModelSt = (0, _graphCalculatorHelper.calculateDataModelStructure)(newHighlightingNode, relatedHighlightedNodeIDs, subgraphEdges, this.props.nodes),
          dataModelStructure = _calculateDataModelSt.dataModelStructure,
          routesBetweenStartEndNodes = _calculateDataModelSt.routesBetweenStartEndNodes;

      return {
        dataModelStructure: dataModelStructure,
        dataModelStructureRelatedNodeIDs: relatedHighlightedNodeIDs,
        routesBetweenStartEndNodes: routesBetweenStartEndNodes
      };
    }
  }, {
    key: "getDataModelStructureForSecondHighlightingNodes",
    value: function getDataModelStructureForSecondHighlightingNodes(newHighlightingNode, newSecondHighlightingNodeID) {
      var subgraphNodeIDs = [];
      var pathRelatedToSecondHighlightingNode = (0, _graphCalculatorHelper.calculatePathRelatedToSecondHighlightingNode)(newHighlightingNode, newSecondHighlightingNodeID, this.props.nodes);
      pathRelatedToSecondHighlightingNode.forEach(function (e) {
        if (!subgraphNodeIDs.includes(e.source)) subgraphNodeIDs.push(e.source);
        if (!subgraphNodeIDs.includes(e.target)) subgraphNodeIDs.push(e.target);
      });

      var _calculateDataModelSt2 = (0, _graphCalculatorHelper.calculateDataModelStructure)(newHighlightingNode, subgraphNodeIDs, pathRelatedToSecondHighlightingNode, this.props.nodes),
          dataModelStructure = _calculateDataModelSt2.dataModelStructure,
          routesBetweenStartEndNodes = _calculateDataModelSt2.routesBetweenStartEndNodes;

      return {
        dataModelStructure: dataModelStructure,
        dataModelStructureRelatedNodeIDs: subgraphNodeIDs,
        routesBetweenStartEndNodes: routesBetweenStartEndNodes
      };
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
    }
  }]);

  return GraphCalculator;
}(_react.default.Component);

GraphCalculator.propTypes = {
  dictionary: _propTypes.default.object,
  countsSearch: _propTypes.default.array,
  linksSearch: _propTypes.default.array,
  onGraphLayoutCalculated: _propTypes.default.func,
  onGraphLegendCalculated: _propTypes.default.func,
  nodes: _propTypes.default.arrayOf(_propTypes.default.object),
  edges: _propTypes.default.arrayOf(_propTypes.default.object),
  highlightingNode: _propTypes.default.object,
  onHighlightRelatedNodesCalculated: _propTypes.default.func,
  onSecondHighlightingNodeCandidateIDsCalculated: _propTypes.default.func,
  secondHighlightingNodeID: _propTypes.default.string,
  onPathRelatedToSecondHighlightingNodeCalculated: _propTypes.default.func,
  onDataModelStructureCalculated: _propTypes.default.func,
  layoutInitialized: _propTypes.default.bool
};
GraphCalculator.defaultProps = {
  dictionary: {},
  countsSearch: [],
  linksSearch: [],
  onGraphLayoutCalculated: function onGraphLayoutCalculated() {},
  onGraphLegendCalculated: function onGraphLegendCalculated() {},
  highlightingNode: null,
  nodes: [],
  edges: [],
  onHighlightRelatedNodesCalculated: function onHighlightRelatedNodesCalculated() {},
  secondHighlightingNodeID: null,
  onSecondHighlightingNodeCandidateIDsCalculated: function onSecondHighlightingNodeCandidateIDsCalculated() {},
  onPathRelatedToSecondHighlightingNodeCalculated: function onPathRelatedToSecondHighlightingNodeCalculated() {},
  onDataModelStructureCalculated: function onDataModelStructureCalculated() {},
  layoutInitialized: false
};
var _default = GraphCalculator;
exports.default = _default;