"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helper = require("../../NodeCategories/helper");

var _utils = require("../../utils");

var _highlightHelper = require("../../highlightHelper");

require("./GraphNode.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var GraphNode = /*#__PURE__*/function (_React$Component) {
  _inherits(GraphNode, _React$Component);

  var _super = _createSuper(GraphNode);

  function GraphNode(props) {
    var _this;

    _classCallCheck(this, GraphNode);

    _this = _super.call(this, props);
    _this.svgElement = /*#__PURE__*/_react.default.createRef();
    return _this;
  }

  _createClass(GraphNode, [{
    key: "getSVGElement",
    value: function getSVGElement() {
      return this.svgElement.current;
    }
  }, {
    key: "render",
    value: function render() {
      if (!(this.props.node.id !== undefined && this.props.node.type !== undefined && this.props.node.textPadding !== undefined && this.props.node.topCenterX !== undefined && this.props.node.topCenterY !== undefined && this.props.node.width !== undefined && this.props.node.height !== undefined && this.props.node.color !== undefined && this.props.node.names !== undefined && this.props.node.iconRadius !== undefined) && this.props.node.textLineGap !== undefined && this.props.node.fontSize !== undefined) {
        return null;
      }

      var nodeFadedClassModifier = this.props.isFaded ? 'graph-node--faded' : '';
      var nodeHalfFadedClassModifier = this.props.isHalfFaded ? 'graph-node--half-faded' : '';
      var nodeDashedClassModifier = this.props.isDashed ? 'graph-node--dashed' : '';
      var nodeClickableClassModifier = this.props.isClickable ? 'graph-node--clickable' : 'graph-node--not-clickable';
      var nodeIsCurrentHighlightingClassModifier = this.props.isHighlightingNode ? 'graph-drawer__node--current-highlighting' : '';
      var IconSVG = (0, _helper.getGraphCategoryIconSVG)(this.props.node.type);
      return /*#__PURE__*/_react.default.createElement("g", {
        ref: this.svgElement,
        key: this.props.node.id,
        transform: "translate(".concat(this.props.node.topCenterX, ", ").concat(this.props.node.topCenterY, ") "),
        className: "graph-node \n          ".concat(nodeFadedClassModifier, " \n          ").concat(nodeHalfFadedClassModifier, " \n          ").concat(nodeDashedClassModifier, " \n          ").concat(nodeClickableClassModifier, " \n          ").concat(nodeIsCurrentHighlightingClassModifier),
        onMouseOver: this.props.onMouseOver,
        onMouseOut: this.props.onMouseOut,
        onClick: this.props.onClick,
        id: this.props.node.id
      }, /*#__PURE__*/_react.default.createElement("rect", {
        className: 'graph-node__rect',
        x: -this.props.node.width / 2,
        y: 0,
        width: this.props.node.width,
        height: this.props.node.height,
        rx: 4,
        ry: 4,
        stroke: this.props.node.color
      }), (0, _highlightHelper.getNodeTitleSVGFragment)(this.props.node.names, this.props.matchedNodeNameIndices, this.props.node.fontSize, this.props.node.textPadding, this.props.node.textLineGap), /*#__PURE__*/_react.default.createElement("g", {
        transform: "translate(".concat(-this.props.node.iconRadius, ", ").concat(-this.props.node.iconRadius, ")")
      }, IconSVG ? /*#__PURE__*/_react.default.createElement(IconSVG, null) : /*#__PURE__*/_react.default.createElement("circle", {
        cx: this.props.node.iconRadius,
        cy: this.props.node.iconRadius,
        r: this.props.node.iconRadius,
        fill: this.props.node.color
      })));
    }
  }]);

  return GraphNode;
}(_react.default.Component);

var GraphNodeShape = _propTypes.default.shape({
  id: _propTypes.default.string,
  type: _propTypes.default.string,
  textPadding: _propTypes.default.number,
  topCenterX: _propTypes.default.number,
  topCenterY: _propTypes.default.number,
  width: _propTypes.default.number,
  height: _propTypes.default.number,
  color: _propTypes.default.string,
  names: _propTypes.default.arrayOf(_propTypes.default.string),
  iconRadius: _propTypes.default.number,
  textLineGap: _propTypes.default.number,
  fontSize: _propTypes.default.number
});

GraphNode.propTypes = {
  node: GraphNodeShape.isRequired,
  isHighlightingNode: _propTypes.default.bool.isRequired,
  isFaded: _propTypes.default.bool.isRequired,
  isHalfFaded: _propTypes.default.bool.isRequired,
  isDashed: _propTypes.default.bool.isRequired,
  isClickable: _propTypes.default.bool.isRequired,
  onMouseOver: _propTypes.default.func,
  onMouseOut: _propTypes.default.func,
  onClick: _propTypes.default.func,
  matchedNodeNameIndices: _utils.MatchedIndicesShape
};
GraphNode.defaultProps = {
  onMouseOver: function onMouseOver() {},
  onMouseOut: function onMouseOut() {},
  onClick: function onClick() {},
  matchedNodeNameIndices: []
};
var _default = GraphNode;
exports.default = _default;