"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _helper = require("../../NodeCategories/helper");

var _utils = require("../../../utils");

var _DataDictionaryNode = _interopRequireDefault(require("../DataDictionaryNode"));

var _DataDictionaryCategory = _interopRequireDefault(require("./DataDictionaryCategory.style"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DataDictionaryCategory = /*#__PURE__*/function (_React$Component) {
  _inherits(DataDictionaryCategory, _React$Component);

  var _super = _createSuper(DataDictionaryCategory);

  function DataDictionaryCategory() {
    _classCallCheck(this, DataDictionaryCategory);

    return _super.apply(this, arguments);
  }

  _createClass(DataDictionaryCategory, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          classes = _this$props.classes,
          category = _this$props.category,
          highlightingNodeID = _this$props.highlightingNodeID;
      var IconSVG = (0, _helper.getCategoryIconSVG)(category);
      return /*#__PURE__*/_react.default.createElement("div", {
        className: classes.category
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: classes.categoryHead,
        style: {
          borderLeftColor: (0, _helper.getCategoryColor)(category)
        }
      }, /*#__PURE__*/_react.default.createElement(IconSVG, {
        className: "".concat(classes.categoryIcon, " ").concat(category)
      }), /*#__PURE__*/_react.default.createElement("span", {
        style: {
          color: (0, _helper.getCategoryColor)(category)
        }
      }, (0, _utils.capitalizeFirstLetter)(category))), /*#__PURE__*/_react.default.createElement("div", {
        className: classes.categoryDivider,
        style: {
          borderLeftColor: (0, _helper.getCategoryColor)(category)
        }
      }), this.props.nodes.map(function (node) {
        return /*#__PURE__*/_react.default.createElement(_DataDictionaryNode.default, {
          node: node,
          key: node.id,
          description: node.description,
          pdfDownloadConfig: _this.props.pdfDownloadConfig,
          expanded: highlightingNodeID && highlightingNodeID === node.id,
          onExpandNode: _this.props.onExpandNode
        });
      }));
    }
  }]);

  return DataDictionaryCategory;
}(_react.default.Component);

DataDictionaryCategory.propTypes = {
  category: _propTypes.default.string.isRequired,
  nodes: _propTypes.default.arrayOf(_propTypes.default.shape({
    id: _propTypes.default.string.isRequired,
    description: _propTypes.default.string
  })).isRequired,
  highlightingNodeID: _propTypes.default.string,
  onExpandNode: _propTypes.default.func
};
DataDictionaryCategory.defaultProps = {
  highlightingNodeID: null,
  onExpandNode: function onExpandNode() {}
};

var _default = (0, _core.withStyles)(_DataDictionaryCategory.default)(DataDictionaryCategory);

exports.default = _default;