"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _core = require("@material-ui/core");

var _NodeViewComponent = _interopRequireDefault(require("./NodeViewComponent.style"));

var _utils = require("../../../../utils");

var _icon_download_PDF = _interopRequireDefault(require("../../icons/icon_download_PDF.svg"));

var _icon_download_TSV = _interopRequireDefault(require("../../icons/icon_download_TSV.svg"));

var _DownloadButton = _interopRequireDefault(require("../../../NodePDF/DownloadButton"));

var _fileManifestConfig = require("../../../../../../config/file-manifest-config");

var _highlightHelper = require("../../../highlightHelper");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var NodeViewComponent = function NodeViewComponent(_ref) {
  var classes = _ref.classes,
      node = _ref.node,
      description = _ref.description,
      isSearchMode = _ref.isSearchMode,
      matchedResult = _ref.matchedResult,
      pdfDownloadConfig = _ref.pdfDownloadConfig,
      fileManifestConfig = _ref.fileManifestConfig;
  var csvBtnDownloadConfig = {
    image: _icon_download_TSV.default,
    fileType: 'tsv',
    prefix: 'ICDC_Data_Loading_Template-'
  };
  var isFileManifest = node.id === 'file';
  var isTemplate = node.template === 'Yes';
  var fileManifestDownloadSettings = fileManifestConfig || _fileManifestConfig.fileManifestDownloadSettings;

  var getTitle = function getTitle() {
    if (isSearchMode) {
      var nodeTitleFragment = (0, _highlightHelper.getNodeTitleFragment)(matchedResult.matches, (0, _utils.capitalizeFirstLetter)(node.title), 'data-dictionary-property-table__span');
      return nodeTitleFragment;
    }

    return (0, _utils.capitalizeFirstLetter)(node.title);
  };

  var getDescription = function getDescription(description) {
    if (isSearchMode) {
      var nodeDescriptionFragment = (0, _highlightHelper.getNodeDescriptionFragment)(matchedResult.matches, description, 'data-dictionary-property-table__span');
      return nodeDescriptionFragment;
    }

    return description;
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    container: true
  }, /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    lg: 3,
    md: 3,
    sm: 3,
    xs: 12
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: classes.nodeTitle
  }, getTitle())), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    lg: 9,
    md: 9,
    sm: 9,
    xs: 9,
    className: classes.nodeDescription
  }, /*#__PURE__*/_react.default.createElement("span", null, node.desc ? getDescription(node.desc) : description)), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    lg: 3,
    md: 3,
    sm: 3,
    xs: 12
  }), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    lg: 4,
    md: 4,
    sm: 4,
    xs: 12,
    className: classes.nodeAssignmentGroup
  }, node.assignment && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
    className: classes.nodeLabel
  }, /*#__PURE__*/_react.default.createElement("span", null, "Assignment:"), /*#__PURE__*/_react.default.createElement("span", {
    className: classes.nodeAssignment
  }, (0, _utils.capitalizeFirstLetter)(node.assignment)))), node.class && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
    className: classes.nodeLabel
  }, "Class:", /*#__PURE__*/_react.default.createElement("span", {
    className: classes.nodeClass
  }, (0, _utils.capitalizeFirstLetter)(node.class))))), /*#__PURE__*/_react.default.createElement(_core.Grid, {
    item: true,
    lg: 5,
    md: 5,
    sm: 5,
    xs: 12,
    className: classes.nodeDownloadButtonGroup
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes.buttonWrap
  }, /*#__PURE__*/_react.default.createElement(_DownloadButton.default, {
    config: _objectSpread(_objectSpread({}, pdfDownloadConfig), {}, {
      type: 'single',
      image: _icon_download_PDF.default
    }),
    documentData: node,
    fileName: (0, _utils.createFileName)(node.id, pdfDownloadConfig.prefix)
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: classes.buttonWrap
  }, (isTemplate || isFileManifest) && /*#__PURE__*/_react.default.createElement(_DownloadButton.default, {
    config: csvBtnDownloadConfig,
    documentData: node,
    template: node.template,
    isFileManifest: isFileManifest,
    fileName: isFileManifest ? (0, _utils.createFileName)('', fileManifestDownloadSettings.filename_prefix) : (0, _utils.createFileName)(node.id, csvBtnDownloadConfig.prefix)
  })))));
};

var _default = (0, _core.withStyles)(_NodeViewComponent.default)(NodeViewComponent);

exports.default = _default;