"use strict";

var _axios = _interopRequireDefault(require("axios"));

var _jsYaml = _interopRequireDefault(require("js-yaml"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// import store from '../../store';
// import env from '../../utils/env';
// import ReduxDataDictionary from './DataDictionary/ReduxDataDictionary';
var version = {
  commit: '913161064b02bcef024d072873e77c8c79cc1a68',
  dictionary: {
    commit: '520a25999fd183f6c5b7ddef2980f3e839517da5',
    version: '0.2.1-9-g520a259'
  },
  version: '4.0.0-44-g9131610'
};
var DATA_MODEL = 'https://raw.githubusercontent.com/CBIIT/icdc-model-tool/develop/model-desc/icdc-model.yml';
var DATA_MODEL_PROPS = 'https://raw.githubusercontent.com/CBIIT/icdc-model-tool/develop/model-desc/icdc-model-props.yml';

var getData = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url) {
    var response, data;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _axios.default.get(url);

          case 2:
            response = _context.sent;
            data = _jsYaml.default.safeLoad(response.data);
            return _context.abrupt("return", data);

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getData(_x) {
    return _ref.apply(this, arguments);
  };
}();

function getModelExploreData() {
  return _getModelExploreData.apply(this, arguments);
}

function _getModelExploreData() {
  _getModelExploreData = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var modelUrl,
        modelPropsUrl,
        icdcMData,
        icdcMPData,
        dataList,
        keyMaps,
        _i,
        _Object$entries,
        _value$Tags,
        _value$Tags2,
        _value$Tags3,
        _value$Tags4,
        _value$Tags5,
        _value$Tags6,
        _Object$entries$_i,
        key,
        value,
        item,
        link,
        properties,
        pRequired,
        pPreffered,
        pOptional,
        Yes,
        No,
        i,
        nodeP,
        propertiesItem,
        propertyName,
        property,
        label,
        required,
        _i2,
        linkItem,
        backref,
        name,
        target,
        multiplicity,
        _i3,
        _Object$entries2,
        _Object$entries2$_i,
        _key,
        _value,
        keyMapList,
        _loop,
        _i4,
        _Object$entries3,
        newDataList,
        _args2 = arguments;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            modelUrl = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : DATA_MODEL;
            modelPropsUrl = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : DATA_MODEL_PROPS;
            _context2.next = 4;
            return getData(modelUrl);

          case 4:
            icdcMData = _context2.sent;
            _context2.next = 7;
            return getData(modelPropsUrl);

          case 7:
            icdcMPData = _context2.sent;
            // translate the json file here
            dataList = {};
            keyMaps = new Set(); // using the following code the convert MDF to Gen3 format

            for (_i = 0, _Object$entries = Object.entries(icdcMData.Nodes); _i < _Object$entries.length; _i++) {
              _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2), key = _Object$entries$_i[0], value = _Object$entries$_i[1];
              item = {};
              item.$schema = 'http://json-schema.org/draft-06/schema#';
              item.id = key;
              item.title = key;

              if (value.Tags && 'Category' in value.Tags) {
                item.category = value.Tags.Category;
              } else if ('Category' in value) {
                item.category = value.Category && value.Category.length > 0 ? value.Category : 'Undefined';
              } else {
                item.category = 'Undefined';
              }

              item.program = '*';
              item.project = '*';
              item.additionalProperties = false;
              item.submittable = true;
              item.constraints = null;
              item.type = 'object';
              item.assignment = (_value$Tags = value.Tags) !== null && _value$Tags !== void 0 && _value$Tags.Assignment ? (_value$Tags2 = value.Tags) === null || _value$Tags2 === void 0 ? void 0 : _value$Tags2.Assignment : '';
              item.class = (_value$Tags3 = value.Tags) !== null && _value$Tags3 !== void 0 && _value$Tags3.Class ? (_value$Tags4 = value.Tags) === null || _value$Tags4 === void 0 ? void 0 : _value$Tags4.Class : '';
              item.desc = value !== null && value !== void 0 && value.Desc ? value === null || value === void 0 ? void 0 : value.Desc : '';
              item.description = item.desc;
              item.template = (_value$Tags5 = value.Tags) !== null && _value$Tags5 !== void 0 && _value$Tags5.Template ? (_value$Tags6 = value.Tags) === null || _value$Tags6 === void 0 ? void 0 : _value$Tags6.Template : '';
              link = [];
              properties = {};
              pRequired = [];
              pPreffered = [];
              pOptional = [];
              Yes = [];
              No = [];

              if (icdcMData.Nodes[key].Props != null) {
                for (i = 0; i < icdcMData.Nodes[key].Props.length; i++) {
                  nodeP = icdcMData.Nodes[key].Props[i];
                  propertiesItem = {};

                  for (propertyName in icdcMPData.PropDefinitions) {
                    if (propertyName === nodeP) {
                      if (icdcMPData.PropDefinitions[propertyName].Key) {
                        keyMaps.add({
                          props: propertyName,
                          node: key
                        });
                      }

                      propertiesItem.labeled = icdcMPData.PropDefinitions[propertyName].Tags ? icdcMPData.PropDefinitions[propertyName].Tags.Labeled ? icdcMPData.PropDefinitions[propertyName].Tags.Labeled : undefined : undefined;
                      propertiesItem.category = key;
                      propertiesItem.description = icdcMPData.PropDefinitions[propertyName].Desc;
                      propertiesItem.type = icdcMPData.PropDefinitions[propertyName].Type || icdcMPData.PropDefinitions[propertyName].Enum;
                      propertiesItem.enum = icdcMPData.PropDefinitions[propertyName].Enum || icdcMPData.PropDefinitions[propertyName].Type.Enum;
                      propertiesItem.src = icdcMPData.PropDefinitions[propertyName].Src;
                      propertiesItem.key = icdcMPData.PropDefinitions[propertyName].Key;

                      if (icdcMPData.PropDefinitions[propertyName].Req === 'Yes') {
                        pRequired.push(nodeP);
                        propertiesItem['propertyType'] = 'required';
                      } else if (icdcMPData.PropDefinitions[propertyName].Req === 'Preferred') {
                        pPreffered.push(nodeP);
                        propertiesItem['propertyType'] = 'preferred';
                      } else {
                        pOptional.push(nodeP);
                        propertiesItem['propertyType'] = 'optional';
                      }

                      if (icdcMPData.PropDefinitions[propertyName].Tags && icdcMPData.PropDefinitions[propertyName].Tags.Labeled) {
                        Yes.push(nodeP);
                        propertiesItem['display'] = 'yes';
                      } else {
                        No.push(nodeP);
                        propertiesItem['display'] = 'no';
                      }
                    }
                  }

                  properties[nodeP] = propertiesItem;
                }

                item.properties = properties;
                item.inclusion = {};

                if (pRequired.length > 0) {
                  item.inclusion = _objectSpread(_objectSpread({}, item.inclusion), {}, {
                    required: pRequired
                  });
                }

                if (pOptional.length > 0) {
                  item.inclusion = _objectSpread(_objectSpread({}, item.inclusion), {}, {
                    optional: pOptional
                  });
                }

                if (pPreffered.length > 0) {
                  item.inclusion = _objectSpread(_objectSpread({}, item.inclusion), {}, {
                    preferred: pPreffered
                  });
                }

                if (Yes.length > 0) {
                  item.uiDisplay = _objectSpread(_objectSpread({}, item.uiDisplay), {}, {
                    yes: Yes
                  });
                }

                if (No.length > 0) {
                  item.uiDisplay = _objectSpread(_objectSpread({}, item.uiDisplay), {}, {
                    no: No
                  });
                }

                item.required = pRequired;
                item.preferred = pPreffered;
                item.optional = pOptional;
                item.yes = Yes;
                item.no = No;
              } else {
                item.properties = {};
              }

              for (property in icdcMData.Relationships) {
                item.multiplicity = _lodash.default.startCase(icdcMData.Relationships[property].Mul);
                label = propertyName; // const multiplicity = icdcMData.Relationships[propertyName].Mul;

                required = false;

                for (_i2 = 0; _i2 < icdcMData.Relationships[property].Ends.length; _i2++) {
                  linkItem = {};

                  if (icdcMData.Relationships[property].Ends[_i2].Src === key) {
                    backref = icdcMData.Relationships[property].Ends[_i2].Src;
                    name = icdcMData.Relationships[property].Ends[_i2].Dst;

                    if (name !== backref) {
                      target = icdcMData.Relationships[property].Ends[_i2].Dst;
                      multiplicity = icdcMData.Relationships[property].Ends[_i2].Mul ? icdcMData.Relationships[property].Ends[_i2].Mul : icdcMData.Relationships[property].Mul;
                      linkItem.name = name;
                      linkItem.backref = backref;
                      linkItem.label = label;
                      linkItem.target_type = target;
                      linkItem.required = required;
                      linkItem.multiplicity = multiplicity;
                      link.push(linkItem);
                    }
                  }
                }
              }

              item.links = link;
              dataList[key] = item;
            }

            for (_i3 = 0, _Object$entries2 = Object.entries(dataList); _i3 < _Object$entries2.length; _i3++) {
              _Object$entries2$_i = _slicedToArray(_Object$entries2[_i3], 2), _key = _Object$entries2$_i[0], _value = _Object$entries2$_i[1];

              if (_value.links.length > 0) {
                _value.links.forEach(function (el) {
                  if (el.name) {
                    dataList[el.name].links.push({
                      Dst: el.name,
                      Src: el.backref,
                      multiplicity: el.multiplicity
                    });
                  }
                });
              }
            } // map parent key for the node


            keyMapList = Array.from(keyMaps);

            _loop = function _loop() {
              var _Object$entries3$_i = _slicedToArray(_Object$entries3[_i4], 2),
                  key = _Object$entries3$_i[0],
                  value = _Object$entries3$_i[1];

              if (value.links.length > 0) {
                value.links.forEach(function (c, index) {
                  var targetId = keyMapList.find(function (item) {
                    return item.node === c.target_type;
                  });

                  if (targetId) {
                    value.links[index].targetId = targetId.props;
                    value.links[index].generatedType = icdcMPData.PropDefinitions[targetId.props].Src;
                  }
                });
              }
            };

            for (_i4 = 0, _Object$entries3 = Object.entries(dataList); _i4 < _Object$entries3.length; _i4++) {
              _loop();
            }

            newDataList = dataList;
            return _context2.abrupt("return", {
              data: newDataList,
              version: version
            });

          case 17:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _getModelExploreData.apply(this, arguments);
}

module.exports.getModelExploreData = getModelExploreData;