"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _d3Selection = require("d3-selection");

var _d3Transition = require("d3-transition");

var _d3Ease = require("d3-ease");

var _d3Zoom = require("d3-zoom");

require("./Canvas.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var d3 = {
  select: _d3Selection.select,
  zoom: _d3Zoom.zoom,
  zoomTransform: _d3Zoom.zoomTransform,
  zoomIdentity: _d3Zoom.zoomIdentity,
  transition: _d3Transition.transition,
  easeLinear: _d3Ease.easeLinear,

  get event() {
    return _d3Selection.event;
  } // https://stackoverflow.com/a/40048292


};

var Canvas = /*#__PURE__*/function (_React$Component) {
  _inherits(Canvas, _React$Component);

  var _super = _createSuper(Canvas);

  function Canvas(props) {
    var _this;

    _classCallCheck(this, Canvas);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "handleResize", function () {
      if (_this.props.isGraphView) {
        _this.updateCanvasSize();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleCanvasUpdate", function () {
      var canvasBoundingRect = _this.canvasElement.current.getBoundingClientRect();

      _this.props.onCanvasBoundingBoxUpdate(canvasBoundingRect);
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function () {
      _this.props.onClickBlankSpace();
    });

    _defineProperty(_assertThisInitialized(_this), "zoomAction", function (k) {
      var transform = d3.zoomTransform(_this.zoomCatcher.node()); // if zoomin (k>1), translate toward negative direction, if zoomout, toward positive

      var translateSign = k > 1 ? -1 : +1;

      _this.zoomCatcher.transition(_this.transition).call(_this.zoomBehavior.transform, transform.translate(translateSign * (_this.state.canvasWidth / 2) * Math.abs(k - 1), translateSign * (_this.state.canvasHeight / 2) * Math.abs(k - 1)).scale(k));
    });

    _defineProperty(_assertThisInitialized(_this), "handleZoomIn", function () {
      _this.zoomAction(1.2);
    });

    _defineProperty(_assertThisInitialized(_this), "handleZoomOut", function () {
      _this.zoomAction(0.8);
    });

    _defineProperty(_assertThisInitialized(_this), "handleReset", function () {
      _this.zoomCatcher.transition(_this.transition).call(_this.zoomBehavior.transform, d3.zoomIdentity);
    });

    _this.state = {
      canvasWidth: 0,
      canvasHeight: 0
    };
    _this.canvasElement = /*#__PURE__*/_react.default.createRef();
    _this.svgElement = /*#__PURE__*/_react.default.createRef();
    _this.containerElement = /*#__PURE__*/_react.default.createRef();
    _this.transition = d3.transition().duration(150).ease(d3.easeLinear);
    return _this;
  }

  _createClass(Canvas, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.zoomBehavior = d3.zoom().scaleExtent([this.props.minZoom, this.props.maxZoom]).translateExtent([this.props.topLeftTranslateLimit, this.props.bottomRightTranslateLimit]).on('zoom', function () {
        _this2.zoomTarget.attr('transform', d3.event.transform);

        _this2.handleCanvasUpdate();
      });
      this.zoomTarget = d3.select('.canvas__container');
      this.zoomCatcher = d3.select('.canvas__overlay').style('fill', 'none').style('pointer-events', 'all').call(this.zoomBehavior);
      this.updateCanvasSize();
      window.addEventListener('resize', this.handleResize);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (this.props.needReset) {
        this.handleReset();
        this.props.onResetCanvasFinished();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      d3.select('.canvas__overlay').on('.zoom', null);
      window.removeEventListener('resize', this.handleResize);
    }
  }, {
    key: "updateCanvasSize",
    value: function updateCanvasSize() {
      this.setState({
        canvasWidth: this.canvasElement.current.clientWidth,
        canvasHeight: this.canvasElement.current.clientHeight
      });
      this.handleCanvasUpdate();
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      return /*#__PURE__*/_react.default.createElement("div", {
        className: 'canvas',
        ref: this.canvasElement,
        style: {
          width: '100%',
          height: '100%'
        }
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'canvas__zoom-button-group'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'canvas__zoom-button canvas__zoom-button--reset',
        onClick: this.handleReset,
        onKeyPress: this.handleReset,
        role: 'button',
        tabIndex: -1
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: 'canvas__zoom-icon g3-icon g3-icon--reset'
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: 'canvas__zoom-button canvas__zoom-button--zoom-in',
        onClick: this.handleZoomIn,
        onKeyPress: this.handleZoomIn,
        role: 'button',
        tabIndex: -1
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: 'canvas__zoom-icon g3-icon g3-icon--plus'
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: 'canvas__zoom-button canvas__zoom-button--zoom-out',
        onClick: this.handleZoomOut,
        onKeyPress: this.handleZoomOut,
        role: 'button',
        tabIndex: -1
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: 'canvas__zoom-icon canvas__zoom-icon--zoom-in g3-icon g3-icon--minus'
      }))), /*#__PURE__*/_react.default.createElement("svg", {
        className: 'canvas__svg',
        ref: this.svgElement,
        width: this.state.canvasWidth,
        height: this.state.canvasHeight
      }, /*#__PURE__*/_react.default.createElement("rect", {
        className: 'canvas__overlay',
        width: this.state.canvasWidth,
        height: this.state.canvasHeight,
        onClick: this.handleClick
      }), /*#__PURE__*/_react.default.createElement("g", {
        className: 'canvas__container',
        ref: this.containerElement
      }, _react.default.Children.map(this.props.children, function (child) {
        return /*#__PURE__*/_react.default.cloneElement(child, {
          canvasWidth: _this3.state.canvasWidth,
          canvasHeight: _this3.state.canvasHeight
        });
      }))));
    }
  }]);

  return Canvas;
}(_react.default.Component);

Canvas.propTypes = {
  minZoom: _propTypes.default.number,
  maxZoom: _propTypes.default.number,
  topLeftTranslateLimit: _propTypes.default.arrayOf(_propTypes.default.number),
  bottomRightTranslateLimit: _propTypes.default.arrayOf(_propTypes.default.number),
  children: _propTypes.default.oneOfType([_propTypes.default.arrayOf(_propTypes.default.node), _propTypes.default.node]).isRequired,
  onClickBlankSpace: _propTypes.default.func,
  onCanvasBoundingBoxUpdate: _propTypes.default.func,
  isGraphView: _propTypes.default.bool,
  needReset: _propTypes.default.bool,
  onResetCanvasFinished: _propTypes.default.func
};
Canvas.defaultProps = {
  minZoom: 0.1,
  maxZoom: 10,
  topLeftTranslateLimit: [-Infinity, -Infinity],
  bottomRightTranslateLimit: [+Infinity, +Infinity],
  onClickBlankSpace: function onClickBlankSpace() {},
  onCanvasBoundingBoxUpdate: function onCanvasBoundingBoxUpdate() {},
  isGraphView: true,
  needReset: false,
  onResetCanvasFinished: function onResetCanvasFinished() {}
};
var _default = Canvas;
exports.default = _default;