"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _GraphNode = _interopRequireDefault(require("../GraphNode/GraphNode"));

var _GraphEdge = _interopRequireDefault(require("../GraphEdge/GraphEdge"));

var _utils = require("../../utils");

require("./GraphDrawer.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var GraphDrawer = /*#__PURE__*/function (_React$Component) {
  _inherits(GraphDrawer, _React$Component);

  var _super = _createSuper(GraphDrawer);

  function GraphDrawer(_props) {
    var _this;

    _classCallCheck(this, GraphDrawer);

    _this = _super.call(this, _props);

    _defineProperty(_assertThisInitialized(_this), "updateSVGElementOnGraph", function (props) {
      var graphNodesSVGElements = props.nodes.map(function (node) {
        if (node.id && _this.getNodeRef(node.id).current) {
          return {
            nodeID: node.id,
            svgElement: _this.getNodeRef(node.id).current.getSVGElement()
          };
        }
      }).reduce(function (acc, cur) {
        acc[cur.nodeID] = cur.svgElement;
        return acc;
      }, {});
      _this.nodeSVGElementInitialized = true;

      _this.props.onGraphNodesSVGElementsUpdated(graphNodesSVGElements);
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseOverNode", function (node) {
      _this.props.onHoverNode(node.id);
    });

    _defineProperty(_assertThisInitialized(_this), "onMouseOutNode", function () {
      _this.props.onCancelHoverNode();
    });

    _defineProperty(_assertThisInitialized(_this), "onClickNode", function (node) {
      _this.props.onClickNode(node.id);
    });

    _defineProperty(_assertThisInitialized(_this), "getNodeRef", function (nodeID) {
      if (!_this.graphNodeRefs[nodeID]) {
        _this.graphNodeRefs[nodeID] = /*#__PURE__*/_react.default.createRef();
      }

      return _this.graphNodeRefs[nodeID];
    });

    _this.graphDomRef = /*#__PURE__*/_react.default.createRef();
    _this.graphNodeRefs = [];
    _this.nodeSVGElementInitialized = false;
    return _this;
  }

  _createClass(GraphDrawer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      // check if need update all node's svg elements
      // this only happens once, at the first time graph is rendered
      if (this.props.isGraphView && this.props.layoutInitialized && !this.nodeSVGElementInitialized) {
        this.updateSVGElementOnGraph(this.props);
      }
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate() {
      if (this.props.isGraphView && this.props.layoutInitialized && this.nodeSVGElementInitialized) {
        this.updateSVGElementOnGraph(this.props);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      if (!this.props.layoutInitialized) return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
      var boundingBoxLength = this.props.graphBoundingBox[2][0];
      var fittingScale = Math.min(this.props.canvasWidth, this.props.canvasHeight) / boundingBoxLength;
      var fittingTransX = Math.abs((boundingBoxLength - this.props.canvasWidth / fittingScale) / 2);
      var fittingTransY = Math.abs((boundingBoxLength - this.props.canvasHeight / fittingScale) / 2);
      if (isNaN(fittingTransX) || isNaN(fittingTransY) || isNaN(fittingScale)) return /*#__PURE__*/_react.default.createElement("g", null);
      return /*#__PURE__*/_react.default.createElement("g", {
        className: 'graph-drawer',
        transform: "scale(".concat(fittingScale - 0.13, ") translate(").concat(fittingTransX, ", ").concat(fittingTransY, ")"),
        ref: this.graphDomRef
      }, this.props.edges.map(function (edge, i) {
        var isEdgeFaded = false;
        var isEdgeHalfFaded = false;
        var isEdgeHighlighted = false;

        if (_this2.props.isSearchMode) {
          isEdgeFaded = true;
        } else if (_this2.props.highlightingNode) {
          var isEdgeRelatedToHighlightedNode = _this2.props.relatedNodeIDs.includes(edge.source) && _this2.props.relatedNodeIDs.includes(edge.target);

          if (_this2.props.secondHighlightingNodeID) {
            var isEdgeAlongPathRelatedToSecondHighlightNode = !!_this2.props.pathRelatedToSecondHighlightingNode.find(function (e) {
              return e.source === edge.source && e.target === edge.target;
            });
            isEdgeHalfFaded = isEdgeRelatedToHighlightedNode && !isEdgeAlongPathRelatedToSecondHighlightNode;
            isEdgeFaded = !isEdgeRelatedToHighlightedNode;
            isEdgeHighlighted = isEdgeAlongPathRelatedToSecondHighlightNode;
          } else {
            isEdgeFaded = !isEdgeRelatedToHighlightedNode;
            isEdgeHighlighted = isEdgeRelatedToHighlightedNode;
          }
        }

        return /*#__PURE__*/_react.default.createElement(_GraphEdge.default, {
          key: "".concat(edge.source, "-").concat(edge.target, "-").concat(i),
          edge: edge,
          isRequired: edge.required,
          isFaded: isEdgeFaded,
          isHalfFaded: isEdgeHalfFaded,
          isHighlighted: isEdgeHighlighted
        });
      }), this.props.nodes.map(function (node) {
        var isNodeFaded = false;
        var isNodeClickable = true;
        var isHighlightingNode = false;
        var isNodeHalfFaded = false;
        var isNodeDashed = false;

        if (_this2.props.isSearchMode) {
          isNodeFaded = !_this2.props.matchedNodeIDs.includes(node.id);
          isNodeDashed = _this2.props.matchedNodeIDsInNameAndDescription.length > 0 && !isNodeFaded && !_this2.props.matchedNodeIDsInNameAndDescription.includes(node.id);
          isNodeClickable = !isNodeFaded;
        } else if (_this2.props.highlightingNode) {
          isHighlightingNode = _this2.props.highlightingNode.id === node.id;
          isNodeClickable = _this2.props.highlightingNode.id === node.id || _this2.props.secondHighlightingNodeCandidateIDs.length > 1 && _this2.props.secondHighlightingNodeCandidateIDs.includes(node.id);
          isNodeFaded = !_this2.props.relatedNodeIDs.includes(node.id);

          if (_this2.props.secondHighlightingNodeID) {
            isNodeHalfFaded = !isNodeFaded && !_this2.props.pathRelatedToSecondHighlightingNode.find(function (e) {
              return e.source === node.id || e.target === node.id;
            });
          }
        }

        var matchedNodeNameIndices = [];

        _this2.props.searchResult.forEach(function (item) {
          if (item.item.id === node.id) {
            item.matches.forEach(function (matchItem) {
              if (matchItem.key === 'title') {
                matchedNodeNameIndices = matchItem.indices;
              }
            });
          }
        });

        return /*#__PURE__*/_react.default.createElement(_GraphNode.default, {
          key: node.id,
          node: node,
          isHighlightingNode: isHighlightingNode,
          isFaded: isNodeFaded,
          isHalfFaded: isNodeHalfFaded,
          isDashed: isNodeDashed,
          isClickable: isNodeClickable,
          onMouseOver: function onMouseOver() {
            return _this2.onMouseOverNode(node);
          },
          onMouseOut: _this2.onMouseOutNode,
          onClick: function onClick() {
            return _this2.onClickNode(node);
          },
          ref: _this2.getNodeRef(node.id),
          matchedNodeNameIndices: matchedNodeNameIndices
        });
      }));
    }
  }]);

  return GraphDrawer;
}(_react.default.Component);

GraphDrawer.propTypes = {
  nodes: _propTypes.default.arrayOf(_propTypes.default.object),
  edges: _propTypes.default.arrayOf(_propTypes.default.object),
  graphBoundingBox: _propTypes.default.array,
  layoutInitialized: _propTypes.default.bool,
  canvasWidth: _propTypes.default.number,
  canvasHeight: _propTypes.default.number,
  onHoverNode: _propTypes.default.func,
  onCancelHoverNode: _propTypes.default.func,
  onClickNode: _propTypes.default.func,
  highlightingNode: _propTypes.default.object,
  relatedNodeIDs: _propTypes.default.array,
  secondHighlightingNodeID: _propTypes.default.string,
  secondHighlightingNodeCandidateIDs: _propTypes.default.arrayOf(_propTypes.default.string),
  pathRelatedToSecondHighlightingNode: _propTypes.default.arrayOf(_propTypes.default.object),
  isGraphView: _propTypes.default.bool,
  isSearchMode: _propTypes.default.bool,
  matchedNodeIDs: _propTypes.default.arrayOf(_propTypes.default.string),
  matchedNodeIDsInNameAndDescription: _propTypes.default.arrayOf(_propTypes.default.string),
  onGraphNodesSVGElementsUpdated: _propTypes.default.func,
  searchResult: _propTypes.default.arrayOf(_utils.SearchResultItemShape)
};
GraphDrawer.defaultProps = {
  nodes: [],
  edges: [],
  graphBoundingBox: [[0, 0], [0, 1], [1, 1], [1, 0]],
  layoutInitialized: false,
  canvasWidth: 1000,
  canvasHeight: 1000,
  onHoverNode: function onHoverNode() {},
  onCancelHoverNode: function onCancelHoverNode() {},
  onClickNode: function onClickNode() {},
  highlightingNode: null,
  relatedNodeIDs: [],
  secondHighlightingNodeID: null,
  secondHighlightingNodeCandidateIDs: [],
  pathRelatedToSecondHighlightingNode: [],
  isGraphView: true,
  isSearchMode: false,
  matchedNodeIDs: [],
  matchedNodeIDsInNameAndDescription: [],
  onGraphNodesSVGElementsUpdated: function onGraphNodesSVGElementsUpdated() {},
  searchResult: []
};
var _default = GraphDrawer;
exports.default = _default;