
export default {"_definitions":{"UUID":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"data_bundle_state":{"default":"submitted","description":"State of a data bundle.","enum":["submitted","validated","error","released","suppressed","redacted"]},"data_file_error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"data_file_properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"file_format":{"term":{"$ref":"_terms.yaml#/file_format"},"type":"string"},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"foreign_key":{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"foreign_key_project":{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"id":"_definitions","md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"parent_uuids":{"items":{"$ref":"#/UUID"},"minItems":1,"type":"array","uniqueItems":true},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"qc_metrics_state":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"release_state":{"default":"unreleased","description":"Release state of an entity.","enum":["unreleased","released","redacted"]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"to_many":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"to_many_project":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"}]},"to_one":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"to_one_project":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"}]},"ubiquitous_properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"workflow_properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_end_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_link":{"description":"Link to Github hash for the CWL workflow used.","type":"string"},"workflow_start_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_version":{"description":"Major version for a GDC workflow.","type":"string"}}},"_settings":{"_dict_commit":"520a25999fd183f6c5b7ddef2980f3e839517da5","_dict_version":"0.2.1-9-g520a259","enable_case_cache":false},"_terms":{"28s_16s_ribosomal_rna_ratio":{"description":"The 28S/18S ribosomal RNA band ratio used to assess the quality of total RNA.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"28s/18s Ribosomal RNA Ratio","term_url":null}},"RIN":{"description":"A numerical assessment of the integrity of RNA based on the entire electrophoretic trace of the RNA sample including the presence or absence of degradation products.\n","termDef":{"cde_id":5278775,"cde_version":1.0,"source":"caDSR","term":"Biospecimen RNA Integrity Number Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5278775&version=1.0"}},"UUID":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"a260_a280_ratio":{"description":"Numeric value that represents the sample ratio of nucleic acid absorbance at 260 nm and 280 nm, used to determine a measure of DNA purity.\n","termDef":{"cde_id":5432595,"cde_version":1.0,"source":"caDSR","term":"Nucleic Acid Absorbance at 260 And Absorbance at 280 DNA Purity Ratio Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432595&version=1.0"}},"aa_change":{"description":"Alphanumeric value used to describe the amino acid change for a specific genetic variant. Example: R116Q.\n","termDef":{"cde_id":6142508,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Amino Acid Change Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142508&version=1.0"}},"absolute_neutrophil":{"description":"The value, in 1000/uL, for the medical procedure that involves testing a sample of blood for the absolute neutrophil count, the real number of white blood cells (WBCs) that are neutrophils and is derived by multiplying the WBC count times the percent of neutrophils in the differential WBC count; the percent of neutrophils consists of the segmented (fully mature neutrophils) &#43; the bands (almost mature neutrophils).\n","termDef":{"cde_id":2597287,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Absolute Neutrophil Count Result Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2597287&version=1.0"}},"adapter_name":{"description":"Name of the sequencing adapter.\n"},"adapter_sequence":{"description":"Base sequence of the sequencing adapter.\n"},"adverse_event":{"description":"Text that represents the Common Terminology Criteria for Adverse Events low level term name for an adverse event.\n","termDef":{"cde_id":3125302,"cde_version":1.1,"source":"caDSR","term":"Common Terminology Criteria for Adverse Events Version 4.0 Low Level Term Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3125302&version=1.1"}},"age_at_diagnosis":{"description":"Age at the time of diagnosis expressed in number of days since birth. If the age is greater than 32,872 days (89 years) see 'age_at_diagnosis_gt89'.\n","termDef":{"cde_id":3225640,"cde_version":2.0,"source":"caDSR","term":"Patient Diagnosis Age Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3225640&version=2.0"}},"age_at_diagnosis_gt89":{"description":"Indicate whether the 'Age at the time of diagnosis expressed in number of days since birth' is greater than 32,872 days (89 years).\n","termDef":{"cde_id":3225640,"cde_version":2.0,"source":"caDSR","term":"Patient Diagnosis Age Day Value Greater than 89","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3225640&version=2.0"}},"age_at_index":{"description":"The patient's age (in years) on the reference or anchor date date used during date obfuscation. If the age is greater than 89 years, see 'age_at_index_gt89'.\n","termDef":{"cde_id":6028530,"cde_version":1.0,"source":"caDSR","term":"Patient Age at Index","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6028530&version=1.0"}},"age_at_index_gt89":{"description":"Indicate whether 'The patient's age (in years) on the reference or anchor date date used during date obfuscation' is greater than 89 years.\n","termDef":{"cde_id":6028530,"cde_version":1.0,"source":"caDSR","term":"Patient Age at Index Greater than 89","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6028530&version=1.0"}},"ajcc_clinical_m":{"description":"Extent of the distant metastasis for the cancer based on evidence obtained from clinical assessment parameters determined prior to treatment.\n","termDef":{"cde_id":3440331,"cde_version":1.0,"source":"caDSR","term":"Neoplasm American Joint Committee on Cancer Clinical Distant Metastasis M Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440331&version=1.0"}},"ajcc_clinical_n":{"description":"Extent of the regional lymph node involvement for the cancer based on evidence obtained from clinical assessment parameters determined prior to treatment.\n","termDef":{"cde_id":3440330,"cde_version":1.0,"source":"caDSR","term":"Neoplasm American Joint Committee on Cancer Clinical Regional Lymph Node N Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440330&version=1.0"}},"ajcc_clinical_stage":{"description":"Stage group determined from clinical information on the tumor (T), regional node (N) and metastases (M) and by grouping cases with similar prognosis for cancer.\n","termDef":{"cde_id":3440332,"cde_version":1.0,"source":"caDSR","term":"Neoplasm American Joint Committee on Cancer Clinical Group Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440332&version=1.0"}},"ajcc_clinical_t":{"description":"Extent of the primary cancer based on evidence obtained from clinical assessment parameters determined prior to treatment.\n","termDef":{"cde_id":3440328,"cde_version":1.0,"source":"caDSR","term":"Neoplasm American Joint Committee on Cancer Clinical Primary Tumor T Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440328&version=1.0"}},"ajcc_pathologic_m":{"description":"Code to represent the defined absence or presence of distant spread or metastases (M) to locations via vascular channels or lymphatics beyond the regional lymph nodes, using criteria established by the American Joint Committee on Cancer (AJCC).\n","termDef":{"cde_id":3045439,"cde_version":1.0,"source":"caDSR","term":"American Joint Committee on Cancer Metastasis Stage Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3045439&version=1.0"}},"ajcc_pathologic_n":{"description":"The codes that represent the stage of cancer based on the nodes present (N stage) according to criteria based on multiple editions of the AJCC's Cancer Staging Manual.\n","termDef":{"cde_id":3203106,"cde_version":1.0,"source":"caDSR","term":"Neoplasm Disease Lymph Node Stage American Joint Committee on Cancer Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3203106&version=1.0"}},"ajcc_pathologic_stage":{"description":"The extent of a cancer, especially whether the disease has spread from the original site to other parts of the body based on AJCC staging criteria.\n","termDef":{"cde_id":3203222,"cde_version":1.0,"source":"caDSR","term":"Neoplasm Disease Stage American Joint Committee on Cancer Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3203222&version=1.0"}},"ajcc_pathologic_t":{"description":"Code of pathological T (primary tumor) to define the size or contiguous extension of the primary tumor (T), using staging criteria from the American Joint Committee on Cancer (AJCC).\n","termDef":{"cde_id":3045435,"cde_version":1.0,"source":"caDSR","term":"American Joint Committee on Cancer Tumor Stage Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3045435&version=1.0"}},"ajcc_staging_system_edition":{"description":"The text term used to describe the version or edition of the American Joint Committee on Cancer Staging Handbooks, a publication by the group formed for the purpose of developing a system of staging for cancer that is acceptable to the American medical profession and is compatible with other accepted classifications.\n","termDef":{"cde_id":2722309,"cde_version":1.0,"source":"caDSR","term":"American Joint Committee on Cancer Publication Version Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2722309&version=1.0"}},"albumin":{"description":"The value of a lab test used to determine the albumin level in the blood.\n","termDef":{"cde_id":58274,"cde_version":4.0,"source":"caDSR","term":"Laboratory Procedure Albumin Result Specified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=58274&version=4.0"}},"alcohol_days_per_week":{"description":"Numeric value used to describe the average number of days each week that a person consumes an alcoholic beverage.\n","termDef":{"cde_id":3114013,"cde_version":1.0,"source":"caDSR","term":"Alcohol Consumption Weekly Days Usage Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3114013&version=1.0"}},"alcohol_drinks_per_day":{"description":"Numeric value used to describe the average number of alcoholic beverages  a person consumes per day.\n","termDef":{"cde_id":3124961,"cde_version":1.0,"source":"caDSR","term":"Person Daily Alcohol Consumption Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3124961&version=1.0"}},"alcohol_history":{"description":"A response to a question that asks whether the participant has consumed at least 12 drinks of any kind of alcoholic beverage in their lifetime.\n","termDef":{"cde_id":2201918,"cde_version":1.0,"source":"caDSR","term":"Alcohol Lifetime History Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2201918&version=1.0"}},"alcohol_intensity":{"description":"Category to describe the patient's current level of alcohol use as self-reported by the patient.\n","termDef":{"cde_id":3457767,"cde_version":1.0,"source":"caDSR","term":"Person Self-Report Alcoholic Beverage Exposure Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3457767&version=1.0"}},"aliquot_quantity":{"description":"The quantity in micrograms (ug) of the aliquot(s) derived from the analyte(s) shipped for sequencing and characterization.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Aliquot Quantity","term_url":null}},"aliquot_volume":{"description":"The volume in microliters (ml) of the aliquot(s) derived from the analyte(s) shipped for sequencing and characterization.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Aliquot Volume","term_url":null}},"amount":{"description":"Weight in grams or volume in mL.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Aliquot Amount","term_url":null}},"analyte_quantity":{"description":"The quantity in micrograms (ug) of the analyte(s) derived from the analyte(s) shipped for sequencing and characterization.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Analyte Quantity","term_url":null}},"analyte_type":{"description":"Text term that represents the kind of molecular specimen analyte.\n","termDef":{"cde_id":2513915,"cde_version":2.0,"source":"caDSR","term":"Molecular Specimen Type Text Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2513915&version=2.0"}},"analyte_type_id":{"description":"A single letter code used to identify a type of molecular analyte.\n","termDef":{"cde_id":5432508,"cde_version":1.0,"source":"caDSR","term":"Molecular Analyte Identification Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432508&version=1.0"}},"analyte_volume":{"description":"The volume in microliters (ml) of the analyte(s) derived from the analyte(s) shipped for sequencing and characterization.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Analyte Volume","term_url":null}},"anaplasia_present":{"description":"Yes/no/unknown/not reported indicator used to describe whether anaplasia was present at the time of diagnosis.\n","termDef":{"cde_id":6059599,"cde_version":1.0,"source":"caDSR","term":"Anaplastic Lesion Present Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6059599&version=1.0"}},"anaplasia_present_type":{"description":"The text term used to describe the morphologic findings indicating the presence of a malignant cellular infiltrate characterized by the presence of large pleomorphic cells, necrosis, and high mitotic activity in a tissue sample.\n","termDef":{"cde_id":4925534,"cde_version":1.0,"source":"caDSR","term":"Anaplastic Lesion Classification Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4925534&version=1.0"}},"ann_arbor_b_symptoms":{"description":"Text term to signify whether lymphoma B-symptoms are present as noted in the patient's medical record.\n","termDef":{"cde_id":2902402,"cde_version":1.0,"source":"caDSR","term":"Lymphoma B-Symptoms Medical Record Documented Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2902402&version=1.0"}},"ann_arbor_clinical_stage":{"description":"The text term used to describe the clinical classification of lymphoma, as defined by the Ann Arbor Lymphoma Staging System.\n","termDef":{"cde_id":5615604,"cde_version":1.0,"source":"caDSR","term":"Ann Arbor Clinical Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5615604&version=1.0"}},"ann_arbor_extranodal_involvement":{"description":"Indicator that identifies whether a patient with malignant lymphoma has lymphomatous involvement of an extranodal site.\n","termDef":{"cde_id":3364582,"cde_version":1.0,"source":"caDSR","term":"Lymphomatous Extranodal Site Involvement Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3364582&version=1.0"}},"ann_arbor_pathologic_stage":{"description":"The text term used to describe the pathologic classification of lymphoma, as defined by the Ann Arbor Lymphoma Staging System.\n","termDef":{"cde_id":5615605,"cde_version":1.0,"source":"caDSR","term":"Ann Arbor Pathologic Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5615605&version=1.0"}},"ann_arbor_tumor_stage":{"description":"The classification of the anatomic disease extent of lymphoma (Hodgkin's and Non-Hodgkins) based on the Ann Arbor Staging System.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Ann Arbor Tumor Stage","term_url":null}},"antigen":{"description":"The text term used to describe an antigen included in molecular testing.\n","termDef":{"cde_id":6142523,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Antigen Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142523&version=1.0"}},"barretts_esophagus_goblet_cells_present":{"description":"The yes/no/unknown indicator used to describe whether goblet cells were determined to be present in a patient diagnosed with Barrett's esophagus.\n","termDef":{"cde_id":3440216,"cde_version":1.0,"source":"caDSR","term":"Barrett's Esophagus Diagnosis Goblet Cell Present Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440216&version=1.0"}},"base_caller_name":{"description":"Name of the base caller.\n"},"base_caller_version":{"description":"Version of the base caller.\n"},"best_overall_response":{"description":"The best improvement achieved throughout the entire course of protocol treatment.\n","termDef":{"cde_id":2003324,"cde_version":4.0,"source":"caDSR","term":"Best Response Assessment Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2003324&version=4.0"}},"beta_2_microglobulin":{"description":"A numerical quantity measured or assigned or computed for the beta-2-microglobulin protein (119 aa, ~14 kDa) is encoded by the human B2M gene in the clear portion of the blood that remains after the removal of the blood cells and the clotting proteins.\n","termDef":{"cde_id":2958039,"cde_version":1.0,"source":"caDSR","term":"Serum Beta-2-Microglobulin Protein Laboratory Procedure Performance Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2958039&version=1.0"}},"biomarker_name":{"description":"The name of the biomarker being tested for this specimen and set of test results.\n","termDef":{"cde_id":5473,"cde_version":11.0,"source":"caDSR","term":"Biomarker Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5473&version=2.31"}},"biomarker_result":{"description":"Text term to define the results of genetic testing.\n","termDef":{"cde_id":3234680,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Genetic Abnormality Test Result Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3234680&version=1.0"}},"biomarker_test_method":{"description":"Text descriptor of a molecular analysis method used for an individual.\n","termDef":{"cde_id":3121575,"cde_version":1.0,"source":"caDSR","term":"Disease Detection Molecular Analysis Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3121575&version=1.0"}},"biospecimen_anatomic_site":{"description":"Text term that represents the name of the primary disease site of the submitted tumor sample.\n","termDef":{"cde_id":4742851,"cde_version":1.0,"source":"caDSR","term":"Submitted Tumor Sample Primary Anatomic Site","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4742851&version=1.0"}},"biospecimen_laterality":{"description":"For tumors in paired organs, designates the side on which the specimen was obtained.\n","termDef":{"cde_id":2007875,"cde_version":1.0,"source":"caDSR","term":"Specimen Laterality","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2007875&version=1.0"}},"blood_test":{"description":"Text term used to describe a specific blood test.\n","termDef":{"cde_id":6142767,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Blood Test Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142767&version=1.0"}},"blood_test_normal_range_lower":{"description":"Numeric value used to describe the lower limit of the normal range used to describe a healthy individual at the institution where the test was completed.\n","termDef":{"cde_id":6142571,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Lower Limit of Normal Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142571&version=1.0"}},"blood_test_normal_range_upper":{"description":"Numeric value used to describe the upper limit of the normal range used to describe a healthy individual at the institution where the test was completed.\n","termDef":{"cde_id":6142535,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Upper Limit of Normal Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142535&version=1.0"}},"bmi":{"description":"A calculated numerical quantity that represents an individual's weight to height ratio.\n","termDef":{"cde_id":2006410,"cde_version":3.0,"source":"caDSR","term":"Body Mass Index Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2006410&version=3.0"}},"bun":{"description":"The laboratory value (units of measure unspecified) for a renal lab test for blood urea nitrogen.\n","termDef":{"cde_id":58317,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure Blood Urea Nitrogen Result Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=58317&version=3.0"}},"burkitt_lymphoma_clinical_variant":{"description":"Burkitt's lymphoma categorization based on clinical features that differ from other forms of the same disease.\n","termDef":{"cde_id":3770421,"cde_version":1.0,"source":"caDSR","term":"Burkitt Lymphoma Clinical Variant Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3770421&version=1.0"}},"calcium":{"description":"The laboratory value related to the quantity of calcium present in peripheral blood serum measured by laboratory test.\n","termDef":{"cde_id":2630716,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Calcium Electrolytes Outcome Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2630716&version=1.0"}},"case_submitter_id":{"description":"The submitter_id of the case (study subject) of a file (of any type). Used for associating a data_file with a particular case.\n"},"catalog_reference":{"description":"HCMI catalog reference number for cancer model.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"cause_of_death":{"description":"Text term to identify the cause of death for a patient.\n","termDef":{"cde_id":2554674,"cde_version":3.0,"source":"caDSR","term":"Patient Death Reason","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2554674&version=3.0"}},"cause_of_response":{"description":"A specific regimen or line of therapy responsible for the patient's observed improvement achieved at a certain point in time during a patient's treatment protocol.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"cea_level":{"description":"The value for carcinoembryonic antigen, a substance that is sometimes found in an increased amount in the blood of people with certain cancers.\n","termDef":{"cde_id":2752,"cde_version":2.31,"source":"caDSR","term":"Laboratory Procedure Carcinoembryonic Antigen Outcome Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2752&version=2.31"}},"cea_level_preoperative":{"description":"Numeric value of the Carcinoembryonic antigen or CEA at the time before surgery. [Manually- curated]\n","termDef":{"cde_id":2716510,"cde_version":1.0,"source":"caDSR","term":"Preoperative Carcinoembryonic Antigen Result Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2716510&version=1.0"}},"cell_count":{"description":"Numeric value used to describe the number of cells used for molecular testing.\n","termDef":{"cde_id":6142528,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Cell Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142528&version=1.0"}},"child_pugh_classification":{"description":"The text term used to describe the classification used in the prognosis of chronic liver disease, mainly cirrhosis.\n","termDef":{"cde_id":2931791,"cde_version":1.0,"source":"caDSR","term":"Child-Pugh Classification Grade","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2931791&version=1.0"}},"chromosome":{"description":"The text term used to describe a chromosome targeted or included in molecular testing. If a specific genetic variant is being reported, this property can be used to capture the chromosome where that variant is located.\n","termDef":{"cde_id":6142404,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Chromosome Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142404&version=1.0"}},"cigarettes_per_day":{"description":"The average number of cigarettes smoked per day.\n","termDef":{"cde_id":2001716,"cde_version":4.0,"source":"caDSR","term":"Smoking Use Average Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2001716&version=4.0"}},"circumferential_resection_margin":{"description":"A value in millimeters indicating the measured length between a malignant lesion of the colon or rectum and the nearest radial (or circumferential) border of tissue removed during cancer surgery.\n","termDef":{"cde_id":64202,"cde_version":3.0,"source":"caDSR","term":"Colorectal Surgical Margin Circumferential Distance Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64202&version=3.0"}},"classification_of_tumor":{"description":"Text that describes the kind of disease present in the tumor specimen as related to a specific timepoint.\n","termDef":{"cde_id":3288124,"cde_version":1.0,"source":"caDSR","term":"Tumor Tissue Disease Description Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3288124&version=1.0"}},"cog_liver_stage":{"description":"The text term used to describe the staging classification of liver tumors, as defined by the Children's Oncology Group (COG). This staging system specifically describes the extent of the primary tumor prior to treatment.\n","termDef":{"cde_id":6013618,"cde_version":1.0,"source":"caDSR","term":"PRETEXT Staging System Primary Childhood Malignant Liver Tumor Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6013618&version=1.0"}},"cog_neuroblastoma_risk_group":{"description":"Text term that represents the categorization of patients on the basis of prognostic factors per a system developed by Children's Oncology Group (COG). Risk level is used to assign treatment intensity.\n","termDef":{"cde_id":4616452,"cde_version":1.0,"source":"caDSR","term":"Children's Oncology Group Neuroblastoma Risk Group Assignment Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4616452&version=1.0"}},"cog_renal_stage":{"description":"The text term used to describe the staging classification of renal tumors, as defined by the Children's Oncology Group (COG).\n","termDef":{"cde_id":6013641,"cde_version":1.0,"source":"caDSR","term":"SIOP/COG/NWTSG Staging System Wilms Tumor Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6013641&version=1.0"}},"cog_rhabdomyosarcoma_risk_group":{"description":"Text term used to describe the classification of rhabdomyosarcoma, as defined by the Children's Oncology Group (COG).\n","termDef":{"cde_id":6133604,"cde_version":1.0,"source":"caDSR","term":"Rhabdomyosarcoma Children's Oncology Group Risk Assessment Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133604&version=1.0"}},"colon_polyps_history":{"description":"Yes/No indicator to describe if the subject had a previous history of colon polyps as noted in the history/physical or previous endoscopic report (s).\n","termDef":{"cde_id":3107197,"cde_version":1.0,"source":"caDSR","term":"Colon Carcinoma Polyp Occurrence Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3107197&version=1.0"}},"comorbidity":{"description":"The text term used ot describe the method used to diagnose the patient's comorbidity disease.\n","termDef":{"cde_id":2970715,"cde_version":1.0,"source":"caDSR","term":"Person Comorbidity Condition Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2970715&version=1.0"}},"comorbidity_method_of_diagnosis":{"description":"The text term used to describe the method used to diagnose the patient's comorbidity disease.\n","termDef":{"cde_id":6142386,"cde_version":1.0,"source":"caDSR","term":"Comorbidity Disease Diagnosis Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142386&version=1.0"}},"composition":{"description":"Text term that represents the cellular composition of the sample.\n","termDef":{"cde_id":5432591,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Cellular Composition Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432591&version=1.0"}},"concentration":{"description":"Numeric value that represents the concentration of an analyte or aliquot extracted from the sample or sample portion, measured in milligrams per milliliter.\n","termDef":{"cde_id":5432594,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Analyte or Aliquot Extracted Concentration Milligram per Milliliter Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432594&version=1.0"}},"copy_number":{"description":"Numeric value used to describe the number of times a section of the genome is repeated or copied within an insertion, duplication or deletion variant.\n","termDef":{"cde_id":6142519,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Copy Number Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142519&version=1.0"}},"creatinine":{"description":"The value, in mg/dL, for the medical procedure that involves testing a sample of blood for creatinine, the breakdown product of creatine, a constituent of muscle tissue, that is excreted by the kidney and whose serum level is used to evaluate kidney function.\n","termDef":{"cde_id":58318,"cde_version":3.1,"source":"caDSR","term":"Laboratory Procedure Creatinine Result Specified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=58318&version=3.1"}},"creation_datetime":{"description":"The datetime of portion creation encoded as seconds from epoch.\n","termDef":{"cde_id":5432592,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Portion Creation Seconds Date/Time","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432592&version=1.0"}},"crp":{"description":"The value the result of the medical procedure that involves testing a sample of blood for C-reactive protein, encoded by the CRP gene this protein is cleaved during biological activation and is associated with host defense mechanisms and inflammatory responses.\n","termDef":{"cde_id":2181510,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure C-Reactive Protein Result Specified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2181510&version=1.0"}},"current_weight":{"description":"Numeric value that represents the current weight of the sample, measured  in milligrams.\n","termDef":{"cde_id":5432606,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Current Weight Milligram Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432606&version=1.0"}},"cytoband":{"description":"Alphanumeric value used to describe the cytoband or chromosomal location targeted or included in molecular analysis. If a specific genetic variant is being reported, this property can be used to capture the cytoband where the variant is located. Format: [chromosome][chromosome arm].[band+sub-bands]. Example: 17p13.1.\n","termDef":{"cde_id":6142405,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Cytoband Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142405&version=1.0"}},"data_category":{"description":"Broad categorization of the contents of the data file.\n"},"data_file_error_type":{"description":"Type of error for the data file object.\n"},"data_format":{"description":"Format of the data files.\n"},"data_type":{"description":"Specific content type of the data file.\n"},"datetime":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"},"days_to_adverse_event":{"description":"Number of days between the date used for index and the date the patient had an adverse event.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_best_overall_response":{"description":"Number of days between the date used for index and the date of the patient's best overall response.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_birth":{"description":"Time interval from a person's date of birth to the date of initial pathologic diagnosis, represented as a calculated negative number of days.\n","termDef":{"cde_id":3008233,"cde_version":1.0,"source":"caDSR","term":"Person Birth Date Less Initial Pathologic Diagnosis Date Calculated Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3008233&version=1.0"}},"days_to_collection":{"description":"Time interval from the date of biospecimen collection to the date of initial pathologic diagnosis, represented as a calculated number of days.\n","termDef":{"cde_id":3008340,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Collection Date Less Initial Pathologic Diagnosis Date Calculated Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3008340&version=1.0"}},"days_to_comorbidity":{"description":"Number of days between the date used for index and the date the patient was diagnosed with a comorbidity.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_death":{"description":"Time interval from a person's date of death to the date of initial pathologic diagnosis, represented as a calculated number of days.\n","termDef":{"cde_id":3165475,"cde_version":1.0,"source":"caDSR","term":"Death Less Initial Pathologic Diagnosis Date Calculated Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3165475&version=1.0"}},"days_to_diagnosis":{"description":"Number of days between the date used for index and the date of diagnosis.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_followup":{"description":"Number of days between the date used for index and the date the patient was seen or contacted at follow-up.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_hiv_diagnosis":{"description":"Time interval from the date of the initial pathologic diagnosis to the date of human immunodeficiency diagnosis, represented as a calculated number of days.\n","termDef":{"cde_id":4618491,"cde_version":1.0,"source":"caDSR","term":"Human Immunodeficiency Virus Diagnosis Subtract Initial Pathologic Diagnosis Time Duration Day Calculation Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4618491&version=1.0"}},"days_to_last_followup":{"description":"Time interval from the date of last follow up to the date of initial pathologic diagnosis, represented as a calculated number of days.\n","termDef":{"cde_id":3008273,"cde_version":1.0,"source":"caDSR","term":"Last Communication Contact Less Initial Pathologic Diagnosis Date Calculated Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3008273&version=1.0"}},"days_to_last_known_disease_status":{"description":"Time interval from the date of last follow up to the date of initial pathologic diagnosis, represented as a calculated number of days.\n","termDef":{"cde_id":3008273,"cde_version":1.0,"source":"caDSR","term":"Last Communication Contact Less Initial Pathologic Diagnosis Date Calculated Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3008273&version=1.0"}},"days_to_lost_to_followup":{"description":"The number of days between the date used for index and to the date the patient was lost to follow-up.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_new_event":{"description":"Time interval from the date of new tumor event including progression, recurrence and new primary malignacies to the date of initial pathologic diagnosis, represented as a calculated number of days.\n","termDef":{"cde_id":3392464,"cde_version":1.0,"source":"caDSR","term":"New Tumor Event Less Initial Pathologic Diagnosis Date Calculated Day Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3392464&version=1.0"}},"days_to_progression":{"description":"Number of days between the date used for index and the date the patient was diagnosed with progression of disease.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_recurrence":{"description":"Number of days between the date used for index and the date the patient was diagnosed with a recurrent malignancy.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"days_to_sample_procurement":{"description":"The number of days from the date the patient was diagnosed to the date of the procedure that produced the sample.\n"},"days_to_treatment":{"description":"Number of days from date of initial pathologic diagnosis that treatment began.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Days to Treatment Start","term_url":null}},"days_to_treatment_end":{"description":"Time interval from the date of the initial pathologic diagnosis to the date of treatment end, represented as a calculated number of days.\n","termDef":{"cde_id":5102431,"cde_version":1.0,"source":"caDSR","term":"Treatment End Subtract First Pathologic Diagnosis Day Calculation Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5102431&version=1.0"}},"days_to_treatment_start":{"description":"Time interval from the date of the initial pathologic diagnosis to the start of treatment, represented as a calculated number of days.\n","termDef":{"cde_id":5102411,"cde_version":1.0,"source":"caDSR","term":"Treatment Start Subtract First Pathologic Diagnosis Time Day Calculation Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5102411&version=1.0"}},"diabetes_treatment_type":{"description":"Text term used to describe the types of treatment used to manage diabetes.\n","termDef":{"cde_id":3587247,"cde_version":1.0,"source":"caDSR","term":"Diabetes Mellitus Treatment Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3587247&version=1.0"}},"diagnosis_pathologically_confirmed":{"description":"The histologic description of tissue or cells confirmed by a pathology review of frozen or formalin fixed slide(s) completed after the diagnostic pathology review of the tumor sample used to extract analyte(s).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Post-Diagnostic Pathology Review Confirmation","term_url":null}},"disease_response":{"description":"The observed improvement achieved at a certain point in time during a patient's treatment protocol.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"disease_type":{"description":"The text term used to describe the type of malignant disease, as categorized by the World Health Organization's (WHO) International Classification of Diseases for Oncology (ICD-O).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Disease Type","term_url":null}},"distance_normal_to_tumor":{"description":"Text term to signify the distance between the tumor tissue and the normal control tissue that was procured for matching normal DNA.\n","termDef":{"cde_id":3088708,"cde_version":1.0,"source":"caDSR","term":"Tumor To Normal Control Tissue DNA Distance Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3088708&version=1.0"}},"distributor_reference":{"description":"Distributor reference number for cancer model.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"dlco_ref_predictive_percent":{"description":"The value, as a percentage of predicted lung volume, measuring the amount of carbon monoxide detected in a patient's lungs.\n","termDef":{"cde_id":2180255,"cde_version":1.0,"source":"caDSR","term":"Lung Carbon Monoxide Diffusing Capability Test Assessment Predictive Value Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2180255&version=1.0"}},"dna_change":{"description":"Alphanumeric value used to describe the dna change for a specific genetic variant. Example: c.347C>A.\n","termDef":{"cde_id":6142507,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure DNA Change Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142507&version=1.0"}},"ecog_performance_status":{"description":"The ECOG functional performance status of the patient/participant.\n","termDef":{"cde_id":88,"cde_version":5.1,"source":"caDSR","term":"Performance Status Assessment Eastern Cooperative Oncology Group Scale","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=88&version=5.1"}},"encoding":{"description":"Version of ASCII encoding of quality values found in the file.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"Encoding","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/1%20Basic%20Statistics.html"}},"enneking_msts_grade":{"description":"The text term used to describe the surgical grade of the musculoskeletal sarcoma, using the Enneking staging system approved by the Musculoskeletal Tumor Society (MSTS).\n","termDef":{"cde_id":6003955,"cde_version":2.0,"source":"caDSR","term":"Enneking Musculoskeletal Tumor Society System Surgical Grade","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6003955&version=2.0"}},"enneking_msts_metastasis":{"description":"Text term and code that represents the metastatic stage of the musculoskeletal sarcoma, using the Enneking staging system approved by the Musculoskeletal Tumor Society (MSTS).\n","termDef":{"cde_id":6003958,"cde_version":1.0,"source":"caDSR","term":"Enneking Musculoskeletal Tumor Society Staging System Metastasis Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6003958&version=1.0"}},"enneking_msts_stage":{"description":"Text term used to describe the stage of the musculoskeletal sarcoma, using the Enneking staging system approved by the Musculoskeletal Tumor Society (MSTS).\n","termDef":{"cde_id":6060045,"cde_version":1.0,"source":"caDSR","term":"Enneking Musculoskeletal Tumor Society Staging System Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6060045&version=1.0"}},"enneking_msts_tumor_site":{"description":"Text term and code that represents the tumor site of the musculoskeletal sarcoma, using the Enneking staging system approved by the Musculoskeletal Tumor Society (MSTS).\n","termDef":{"cde_id":6003957,"cde_version":1.0,"source":"caDSR","term":"Enneking Musculoskeletal Tumor Society Staging System Tumor Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6003957&version=1.0"}},"esophageal_columnar_dysplasia_degree":{"description":"Text term to describe the amount of dysplasia found within the benign esophageal columnar mucosa.\n","termDef":{"cde_id":3440917,"cde_version":1.0,"source":"caDSR","term":"Non-cancerous Esophageal Columnar Mucosa Dysplasia Grade Result","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440917&version=1.0"}},"esophageal_columnar_metaplasia_present":{"description":"The yes/no/unknown indicator used to describe whether esophageal columnar metaplasia was determined to be present.\n","termDef":{"cde_id":3440218,"cde_version":1.0,"source":"caDSR","term":"Esophageal Columnar Metaplasia Present Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440218&version=1.0"}},"estrogen_receptor_percent_positive_ihc":{"description":"Classification to represent ER Positive results expressed as a percentage value.\n","termDef":{"cde_id":3128341,"cde_version":1.0,"source":"caDSR","term":"ER Level Cell Percentage Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3128341&version=1.0"}},"estrogen_receptor_result_ihc":{"description":"Text term to represent the overall result of Estrogen Receptor (ER) testing.\n","termDef":{"cde_id":2957359,"cde_version":2.0,"source":"caDSR","term":"Breast Carcinoma Estrogen Receptor Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2957359&version=2.0"}},"ethnicity":{"description":"An individual's self-described social and cultural grouping, specifically whether an individual describes themselves as Hispanic or Latino. The provided values are based on the categories defined by the U.S. Office of Management and Business and used by the U.S. Census Bureau.\n","termDef":{"cde_id":2192217,"cde_version":2.0,"source":"caDSR","term":"Ethnic Group Category Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2192217&version=2.0"}},"exon":{"description":"Exon number targeted or included in a molecular analysis. If a specific genetic variant is being reported, this property can be used to capture the exon where that variant is located.\n","termDef":{"cde_id":6142411,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Exon Identification Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142411&version=1.0"}},"experiment_name":{"description":"Submitter-defined name for the experiment.\n"},"experimental_strategy":{"description":"The sequencing strategy used to generate the data file.\n"},"fastq_name":{"description":"Names of FASTQs.\n"},"fev1_fvc_post_bronch_percent":{"description":"Percentage value to represent result of Forced Expiratory Volume in 1 second (FEV1) divided by the Forced Vital Capacity (FVC) post-bronchodilator.\n","termDef":{"cde_id":3302956,"cde_version":1.0,"source":"caDSR","term":"Post Bronchodilator FEV1/FVC Percent Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3302956&version=1.0"}},"fev1_fvc_pre_bronch_percent":{"description":"Percentage value to represent result of Forced Expiratory Volume in 1 second (FEV1) divided by the Forced Vital Capacity (FVC) pre-bronchodilator.\n","termDef":{"cde_id":3302955,"cde_version":1.0,"source":"caDSR","term":"Pre Bronchodilator FEV1/FVC Percent Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3302955&version=1.0"}},"fev1_ref_post_bronch_percent":{"description":"The percentage comparison to a normal value reference range of the volume of air that a patient can forcibly exhale from the lungs in one second post-bronchodilator.\n","termDef":{"cde_id":3302948,"cde_version":1.0,"source":"caDSR","term":"Post Bronchodilator Lung Forced Expiratory Volume 1 Test Lab Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3302948&version=1.0"}},"fev1_ref_pre_bronch_percent":{"description":"The percentage comparison to a normal value reference range of the volume of air that a patient can forcibly exhale from the lungs in one second pre-bronchodilator.\n","termDef":{"cde_id":3302947,"cde_version":1.0,"source":"caDSR","term":"Pre Bronchodilator Lung Forced Expiratory Volume 1 Test Lab Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3302947&version=1.0"}},"figo_stage":{"description":"The extent of a cervical or endometrial cancer within the body, especially whether the disease has spread from the original site to other parts of the body, as described by the International Federation of Gynecology and Obstetrics (FIGO) stages.\n","termDef":{"cde_id":3225684,"cde_version":1.0,"source":"caDSR","term":"Gynecologic Tumor Grouping Cervical Endometrial FIGO 2009 Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3225684&version=1.0"}},"file_name":{"description":"The name (or part of a name) of a file (of any type).\n"},"file_size":{"description":"The size of the data file (object) in bytes.\n"},"file_state":{"description":"The current state of the data file object.\n"},"first_symptom_prior_to_diagnosis":{"description":"Text term used to describe the patient's first symptom experienced prior to diagnosis and thought to be related to the disease.\n","termDef":{"cde_id":6133605,"cde_version":1.0,"source":"caDSR","term":"DiseaseFirst Symptom Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133605&version=1.0"}},"flow_cell_barcode":{"description":"Flow cell barcode. Wrong or missing information may affect analysis results.\n"},"fragment_maximum_length":{"description":"Maximum length of the sequenced fragments (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"fragment_mean_length":{"description":"Mean length of the sequenced fragments (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"fragment_minimum_length":{"description":"Minimum length of the sequenced fragments (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"fragment_standard_deviation_length":{"description":"Standard deviation of the sequenced fragments length (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"freezing_method":{"description":"Text term that represents the method used for freezing the sample.\n","termDef":{"cde_id":5432607,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Freezing Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432607&version=1.0"}},"gastric_esophageal_junction_involvement":{"description":"The yes/no/unknown/not reported indicator used to describe whether the tumor is located across the gastroesophageal junction.\n","termDef":{"cde_id":6059632,"cde_version":1.0,"source":"caDSR","term":"Esophageal Tumor Across Gastroesophageal Junction Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6059632&version=1.0"}},"gender":{"description":"Text designations that identify gender. Gender is described as the assemblage of properties that distinguish people on the basis of their societal roles. [Explanatory Comment 1: Identification of gender is based upon self-report and may come from a form, questionnaire, interview, etc.]\n","termDef":{"cde_id":2200604,"cde_version":3.0,"source":"caDSR","term":"Person Gender Text Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2200604&version=3.0"}},"gene_symbol":{"description":"The text term used to describe a gene targeted or included in molecular analysis. For rearrangements, this is shold be used to represent the reference gene.\n","termDef":{"cde_id":6142392,"cde_version":1.0,"source":"caDSR","term":"Molecular Analysis Gene Symbol Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142392&version=1.0"}},"glucose":{"description":"The numeric value for the amount of glucose found in blood serum.\n","termDef":{"cde_id":2004319,"cde_version":4.0,"source":"caDSR","term":"Laboratory Procedure Glucose Electrolytes Outcome Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2004319&version=4.0"}},"goblet_cells_columnar_mucosa_present":{"description":"The yes/no/unknown indicator used to describe whether goblet cells were determined to be present in the esophageal columnar mucosa.\n","termDef":{"cde_id":3440219,"cde_version":1.0,"source":"caDSR","term":"Esophageal Columnar Mucosa Goblet Cell Present Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440219&version=1.0"}},"gross_tumor_weight":{"description":"Numeric value used to describe the gross pathologic tumor weight, measured in grams.\n","termDef":{"cde_id":6133606,"cde_version":1.0,"source":"caDSR","term":"Tumor Tissue Weight Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133606&version=1.0"}},"growth_rate":{"description":"Rate at which the model grows, measured as hours to time to split.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"height":{"description":"The height of the patient in centimeters.\n","termDef":{"cde_id":649,"cde_version":4.1,"source":"caDSR","term":"Patient Height Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=649&version=4.1"}},"hemoglobin":{"description":"The value (g/dL) for a medical procedure that involves testing a sample of blood for hemoglobin, red respiratory protein of erythrocytes, to help determine a diagnosis, plan treatment, check to see if treatment is working, or monitor the disease over time.\n","termDef":{"cde_id":2190,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure Hemoglobin Result Specified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2190&version=3.0"}},"her2_erbb2_percent_positive_ihc":{"description":"Classification to represent the number of positive HER2/ERBB2 cells in a specimen or sample.\n","termDef":{"cde_id":3086980,"cde_version":1.0,"source":"caDSR","term":"HER2 ERBB Positive Finding Cell Percentage Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3086980&version=1.0"}},"her2_erbb2_result_fish":{"description":"the type of outcome for HER2 as determined by an in situ hybridization (ISH) assay.\n","termDef":{"cde_id":2854089,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure HER2/neu in situ Hybridization Outcome Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2854089&version=1.0"}},"her2_erbb2_result_ihc":{"description":"Text term to signify the result of the medical procedure that involves testing a sample of blood or tissue for HER2 by histochemical localization of immunoreactive substances using labeled antibodies as reagents.\n","termDef":{"cde_id":2957563,"cde_version":2.0,"source":"caDSR","term":"Laboratory Procedure HER2/neu Immunohistochemistry Receptor Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2957563&version=2.0"}},"histone_family":{"description":"The text term used to describe the family, or classification of a group of basic proteins found in chromatin, called histones.\n","termDef":{"cde_id":6142511,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Histone Family Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142511&version=1.0"}},"histone_variant":{"description":"The text term used to describe a specific histone variants, which are proteins that substitute for the core canonical histones.\n","termDef":{"cde_id":6142515,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Histone Family Variant Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142515&version=1.0"}},"hiv_positive":{"description":"Text term to signify whether a physician has diagnosed HIV infection in a patient.\n","termDef":{"cde_id":4030799,"cde_version":1.0,"source":"caDSR","term":"Physician Diagnosed HIV Infection Personal Medical History Yes No Not Applicable Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4030799&version=1.0"}},"hpv_positive_type":{"description":"Text classification to represent the strain or type of human papillomavirus identified in an individual.\n","termDef":{"cde_id":2922649,"cde_version":1.0,"source":"caDSR","term":"Human Papillomavirus Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2922649&version=1.0"}},"hpv_status":{"description":"The findings of the oncogenic HPV.\n","termDef":{"cde_id":2230033,"cde_version":1.0,"source":"caDSR","term":"Oncogenic Human Papillomavirus Result Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2230033&version=1.0"}},"icd10_code":{"description":"The high-level icd10 classification of disease.\n","termDef":{"cde_id":null,"cde_version":null,"source":"CDC","term":"ICD10 Codes","term_url":"https://www.cdc.gov/nchs/icd/icd10cm.htm"}},"icd_10_code":{"description":"Alphanumeric value used to describe the  disease code from the tenth version of the International Classification of Disease (ICD-10).\n","termDef":{"cde_id":3226287,"cde_version":2.0,"source":"caDSR","term":"International Classification of Disease, Tenth Revision Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3226287&version=2.0"}},"id":"_terms","iga":{"description":"The numeric value, in mg/dL, for the amount of immunoglobulin type A (IgA) found in blood serum.\n","termDef":{"cde_id":64580,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure Serum Immunologic IgA Result Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64580&version=3.0"}},"igg":{"description":"The numeric value, in mg/dL, for the amount of immunoglobulin type G (IgG) found in blood serum.\n","termDef":{"cde_id":64581,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure Serum Immunologic IgG Result Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64581&version=3.0"}},"igl_kappa":{"description":"The patient's serum immunoglobulin light chain kappa value at a certain point in time.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"igl_lambda":{"description":"The patient's serum immunoglobulin light chain lambda value at a certain point in time.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"igm":{"description":"The numeric value, in mg/dL, for the amount of immunoglobulin type M (IgM) found in blood serum.\n","termDef":{"cde_id":64582,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure Serum Immunologic IgM Result Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64582&version=3.0"}},"includes_spike_ins":{"description":"Spike-in included?\n"},"index_date":{"description":"The reference or anchor date used during date obfuscation, where a single date is obscurred by creating one or more date ranges in relation to this date.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"initial_weight":{"description":"Numeric value that represents the initial weight of the sample, measured in milligrams.\n","termDef":{"cde_id":5432605,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Initial Weight Milligram Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432605&version=1.0"}},"inpc_grade":{"description":"Text term used to describe the classification of neuroblastic differentiation within neuroblastoma tumors, as defined by the International Neuroblastoma Pathology Classification (INPC).\n","termDef":{"cde_id":6133602,"cde_version":1.0,"source":"caDSR","term":"International Neuroblastoma Pathology Classification Grade Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133602&version=1.0"}},"inpc_histologic_group":{"description":"The text term used to describe the classification of neuroblastomas distinguishing between favorable and unfavorable histologic groups. The histologic score, defined by the International Neuroblastoma Pathology Classification (INPC), is based on age, mitosis-karyorrhexis index (MKI), stromal content and degree of tumor cell differentiation.\n","termDef":{"cde_id":4616372,"cde_version":1.0,"source":"caDSR","term":"International Neuroblastoma Pathology Classification Histology Score Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4616372&version=1.0"}},"inrg_stage":{"description":"The text term used to describe the staging classification of neuroblastic tumors, as defined by the International Neuroblastoma Risk Group (INRG).\n","termDef":{"cde_id":5777238,"cde_version":1.0,"source":"caDSR","term":"Patient International Neuroblastoma Risk Group Classification System Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5777238&version=1.0"}},"inss_stage":{"description":"Text term used to describe the staging classification of neuroblastic tumors, as defined by the International Neuroblastoma Staging System (INSS).\n","termDef":{"cde_id":6133603,"cde_version":1.0,"source":"caDSR","term":"International Neuroblastoma Staging System Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133603&version=1.0"}},"instrument_model":{"description":"Numeric value that represents the sample dimension that is greater than the shortest dimension and less than the longest dimension, measured in millimeters.\n","termDef":{"cde_id":5432604,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Intermediate Dimension Millimeter Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432604&version=1.0"}},"intermediate_dimension":{"description":"Intermediate dimension of the sample, in millimeters.\n"},"irs_group":{"description":"Text term used to describe the classification of rhabdomyosarcoma tumors, as defined by the Intergroup Rhabdomyosarcoma Study (IRS).\n","termDef":{"cde_id":6141658,"cde_version":1.0,"source":"caDSR","term":"Intergroup Rhabdomyosarcoma Study Group Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6141658&version=1.0"}},"irs_stage":{"description":"The text term used to describe the classification of rhabdomyosarcoma tumors, as defined by the Intergroup Rhabdomyosarcoma Study (IRS).\n","termDef":{"cde_id":5162089,"cde_version":1.0,"source":"caDSR","term":"Rhabdomyosarcoma Diagnosis Assessment Stage","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5162089&version=1.0"}},"is_ffpe":{"description":"Indicator to signify whether or not the tissue sample was fixed in formalin and embedded in paraffin (FFPE).\n","termDef":{"cde_id":4170557,"cde_version":1.0,"source":"caDSR","term":"Specimen Processing Formalin Fixed Paraffin Embedded Tissue Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4170557&version=1.0"}},"is_paired_end":{"description":"Are the reads paired end?\n"},"ishak_fibrosis_score":{"description":"The text term used to describe the classification of the histopathologic degree of liver damage.\n","termDef":{"cde_id":3182621,"cde_version":1.0,"source":"caDSR","term":"Liver Fibrosis Ishak Score Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3182621&version=1.0"}},"iss_stage":{"description":"The multiple myeloma disease stage at diagnosis.\n","termDef":{"cde_id":2465385,"cde_version":1.0,"source":"caDSR","term":"Multiple Myeloma Disease Stage Diagnosis Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2465385&version=1.0"}},"karnofsky_performance_status":{"description":"Text term used to describe the classification used of the functional capabilities of a person.\n","termDef":{"cde_id":2003853,"cde_version":4.2,"source":"caDSR","term":"Karnofsky Performance Status Score","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2003853&version=4.2"}},"lane_number":{"description":"The basic machine unit for sequencing. For Illumina machines, this reflects the physical lane number. Wrong or missing information may affect analysis results.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"last_known_disease_status":{"description":"Text term that describes the last known state or condition of an individual's neoplasm.\n","termDef":{"cde_id":5424231,"cde_version":1.0,"source":"caDSR","term":"Person Last Known Neoplasm Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2759550&version=1.0"}},"laterality":{"description":"For tumors in paired organs, designates the side on which the cancer originates.\n","termDef":{"cde_id":827,"cde_version":3.0,"source":"caDSR","term":"Primary Tumor Laterality","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=827&version=3.0"}},"ldh_level":{"description":"The 2 decimal place numeric laboratory value measured, assigned or computed related to the assessment of lactate dehydrogenase in a specimen. Measured in U/L.\n","termDef":{"cde_id":2798766,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Lactate Dehydrogenase Result  Integer::2 Decimal Place Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2798766&version=1.0"}},"ldh_level_at_diagnosis":{"description":"The 2 decimal place numeric laboratory value measured, assigned or computed related to the assessment of lactate dehydrogenase in a specimen.\n","termDef":{"cde_id":2798766,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Lactate Dehydrogenase Result Integer::2 Decimal Place Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2798766&version=1.0"}},"ldh_normal_range_upper":{"description":"The top value of the range of statistical characteristics that are supposed to represent accepted standard, non-pathological pattern for lactate dehydrogenase (units not specified).\n","termDef":{"cde_id":2597015,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Lactate Dehydrogenase Result Upper Limit of Normal Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2597015&version=1.0"}},"library_name":{"description":"Name of the library.\n"},"library_preparation_kit_catalog_number":{"description":"Catalog of Library Preparation Kit\n"},"library_preparation_kit_name":{"description":"Name of Library Preparation Kit\n"},"library_preparation_kit_vendor":{"description":"Vendor of Library Preparation Kit\n"},"library_preparation_kit_version":{"description":"Version of Library Preparation Kit\n"},"library_selection":{"description":"Library Selection Method\n"},"library_strand":{"description":"Library stranded-ness.\n"},"library_strategy":{"description":"Library strategy.\n"},"loci_abnormal_count":{"description":"Numeric value used to describe the number of loci determined to be abnormal.\n","termDef":{"cde_id":6074182,"cde_version":1.0,"source":"caDSR","term":"Abnormal Locus Testing Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6074182&version=1.0"}},"loci_count":{"description":"Numeric value used to describe the number of loci tested.\n","termDef":{"cde_id":6074183,"cde_version":1.0,"source":"caDSR","term":"Locus Testing Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6074183&version=1.0"}},"locus":{"description":"Alphanumeric value used to describe the locus of a specific genetic variant. Example: NM_001126114.\n","termDef":{"cde_id":6142506,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Locus Location Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142506&version=1.0"}},"longest_dimension":{"description":"Numeric value that represents the longest dimension of the sample, measured in millimeters.\n","termDef":{"cde_id":5432602,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Longest Dimension Millimeter Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432602&version=1.0"}},"lost_to_followup":{"description":"A yes/no indicator related to whether a patient was unable to be contacted for follow-up.\n","termDef":{"cde_id":61333,"cde_version":3.0,"source":"caDSR","term":"Patient Lost Follow-Up Ind-2","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=61333&version=3.0"}},"lymph_nodes_positive":{"description":"The number of lymph nodes involved with disease as determined by pathologic examination.\n","termDef":{"cde_id":89,"cde_version":3.0,"source":"caDSR","term":"Lymph Node(s) Positive Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=89&version=3.0"}},"lymphatic_invasion_present":{"description":"A yes/no indicator to ask if small or thin-walled vessel invasion is present, indicating lymphatic involvement\n","termDef":{"cde_id":64171,"cde_version":3.0,"source":"caDSR","term":"Lymphatic/Small vessel Invasion Ind","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64171&version=3.0"}},"m_protein":{"description":"The amount, in mg/dl, of monoclonal protein, a protein complex comprised of two heavy chains and two light chains, resulting from the medical procedure that involves testing a sample of blood, urine, or other substance from the body.\n","termDef":{"cde_id":64561,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure M Protein Outcome Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64561&version=3.0"}},"md5sum":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"medulloblastoma_molecular_classification":{"description":"The text term used to describe the classification of medulloblastoma tumors based on molecular features.\n","termDef":{"cde_id":6002209,"cde_version":1.0,"source":"caDSR","term":"Medulloblastoma Genetic Finding Subclass Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6002209&version=1.0"}},"menopause_status":{"description":"Text term used to describe the patient's menopause status.\n","termDef":{"cde_id":2434914,"cde_version":1.1,"source":"caDSR","term":"Patient Menopause Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2434914&version=1.1"}},"metastasis_at_diagnosis":{"description":"The text term used to describe the extent of metastatic disease present at diagnosis.\n","termDef":{"cde_id":6133614,"cde_version":1.0,"source":"caDSR","term":"Metastatic Disease at Diagnosis Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133614&version=1.0"}},"metastasis_at_diagnosis_site":{"description":"Text term to identify an anatomic site in which metastatic disease involvement is found.\n","termDef":{"cde_id":3029815,"cde_version":1.0,"source":"caDSR","term":"Metastatic Disease Anatomic Site Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3029815&version=1.0"}},"method_of_diagnosis":{"description":"The method used to initially the patient's diagnosis.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Method of Diagnosis","term_url":null}},"method_of_sample_procurement":{"description":"The method used to procure the sample used to extract analyte(s).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Method of Sample Procurement","term_url":null}},"micropapillary_features":{"description":"The yes/no/unknown indicator used to describe whether micropapillary features were determined to be present.\n","termDef":{"cde_id":6068784,"cde_version":1.0,"source":"caDSR","term":"Tumor Micropapillary Features Present Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6068784&version=1.0"}},"microsatellite_instability_abnormal":{"description":"The yes/no indicator to signify the status of a tumor for microsatellite instability.\n","termDef":{"cde_id":3123142,"cde_version":1.0,"source":"caDSR","term":"Microsatellite Instability Occurrence Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3123142&version=1.0"}},"mismatch_repair_mutation":{"description":"The yes/no/unknown indicator used to describe whether the mutation included in molecular testing was known to have an affect on the mismatch repair process.\n","termDef":{"cde_id":6142534,"cde_version":1.0,"source":"caDSR","term":"Gene Mutation Mismatch Repair Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142534&version=1.0"}},"mitosis_karyorrhexis_index":{"description":"Text term that represents the component of the International Neuroblastoma Pathology Classification (INPC) for mitosis-karyorrhexis index (MKI).\n","termDef":{"cde_id":4616412,"cde_version":1.0,"source":"caDSR","term":"International Neuroblastoma Pathology Classification Mitosis Karyorrhexis Index Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4616412&version=1.0"}},"molecular_analysis_method":{"description":"The text term used to describe the method used for molecular analysis.\n","termDef":{"cde_id":6142401,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Method Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142401&version=1.0"}},"molecular_consequence":{"description":"The text term used to describe the molecular consequence of genetic variation.\n","termDef":{"cde_id":6142403,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Outcome Consequence Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142403&version=1.0"}},"morphology":{"description":"The third edition of the International Classification of Diseases for Oncology, published in 2000 used principally in tumor and cancer registries for coding the site (topography) and the histology (morphology) of neoplasms. The study of the structure of the cells and their arrangement to constitute tissues and, finally, the association among these to form organs. In pathology, the microscopic process of identifying normal and abnormal morphologic characteristics in tissues, by employing various cytochemical and immunocytochemical stains. A system of numbered categories for representation of data.\n","termDef":{"cde_id":3226275,"cde_version":1.0,"source":"caDSR","term":"International Classification of Diseases for Oncology, Third Edition ICD-O-3 Histology Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3226275&version=1.0"}},"multiplex_barcode":{"description":"The barcode/index sequence used. Wrong or missing information may affect analysis results.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"new_event_anatomic_site":{"description":"Text term to specify the anatomic location of the return of tumor after treatment.\n","termDef":{"cde_id":3108271,"cde_version":2.0,"source":"caDSR","term":"New Neoplasm Event Occurrence Anatomic Site","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3108271&version=2.0"}},"new_event_type":{"description":"Text term to identify a new tumor event.\n","termDef":{"cde_id":3119721,"cde_version":1.0,"source":"caDSR","term":"New Neoplasm Event Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3119721&version=1.0"}},"no_matched_normal_low_pass_wgs":{"description":"There will be no matched normal low pass WGS aliquots for this case that can be used for variant calling purposes. The GDC may elect to use a single tumor calling pipeline to process this data.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"no_matched_normal_targeted_sequencing":{"description":"There will be no matched normal Targeted Sequencing aliquots for this case that can be used for variant calling purposes. The GDC may elect to use a single tumor calling pipeline to process this data.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"no_matched_normal_wgs":{"description":"There will be no matched normal WGS aliquots for this case that can be used for variant calling purposes. The GDC may elect to use a single tumor calling pipeline to process this data.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"no_matched_normal_wxs":{"description":"There will be no matched normal WXS aliquots for this case that can be used for variant calling purposes. The GDC may elect to use a single tumor calling pipeline to process this data.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"normal_tumor_genotype_snp_match":{"description":"Text term that represents whether or not the genotype of the normal tumor matches or if the data is not available.\n","termDef":{"cde_id":4588156,"cde_version":1.0,"source":"caDSR","term":"Normal Tumor Genotype Match Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4588156&version=1.0"}},"number_proliferating_cells":{"description":"Numeric value that represents the count of proliferating cells determined during pathologic review of the sample slide(s).\n","termDef":{"cde_id":5432636,"cde_version":1.0,"source":"caDSR","term":"Pathology Review Slide Proliferating Cell Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432636&version=1.0"}},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"oct_embedded":{"description":"Indicator of whether or not the sample was embedded in Optimal Cutting Temperature (OCT) compound.\n","termDef":{"cde_id":5432538,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Optimal Cutting Temperature Compound Embedding Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432538&version=1.0"}},"overall_survival":{"description":"Number of days between the date used for index and the patient's date of death or the date the patient was last known to be alive.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"pack_years_smoked":{"description":"Numeric computed value to represent lifetime tobacco exposure defined as number of cigarettes smoked per day x number of years smoked divided by 20.\n","termDef":{"cde_id":2955385,"cde_version":1.0,"source":"caDSR","term":"Person Cigarette Smoking History Pack Year Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2955385&version=1.0"}},"pancreatitis_onset_year":{"description":"Numeric value to represent the year that the patient was diagnosed with clinical chronic pancreatitis.\n","termDef":{"cde_id":3457763,"cde_version":1.0,"source":"caDSR","term":"Chronic Pancreatitis Diagnosis Year Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3457763&version=1.0"}},"passage_count":{"description":"Number of passages (splits) between the original tissue and this model.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"percent_eosinophil_infiltration":{"description":"Numeric value to represent the percentage of infiltration by eosinophils in a tumor sample or specimen.\n","termDef":{"cde_id":2897700,"cde_version":2.0,"source":"caDSR","term":"Specimen Eosinophilia Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2897700&version=2.0"}},"percent_gc_content":{"description":"The overall %GC of all bases in all sequences.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"%GC","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/1%20Basic%20Statistics.html"}},"percent_granulocyte_infiltration":{"description":"Numeric value to represent the percentage of infiltration by granulocytes in a tumor sample or specimen.\n","termDef":{"cde_id":2897705,"cde_version":2.0,"source":"caDSR","term":"Specimen Granulocyte Infiltration Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2897705&version=2.0"}},"percent_inflam_infiltration":{"description":"Numeric value to represent local response to cellular injury, marked by capillary dilatation, edema and leukocyte infiltration; clinically, inflammation is manifest by reddness, heat, pain, swelling and loss of function, with the need to heal damaged tissue.\n","termDef":{"cde_id":2897695,"cde_version":1.0,"source":"caDSR","term":"Specimen Inflammation Change Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2897695&version=1.0"}},"percent_lymphocyte_infiltration":{"description":"Numeric value to represent the percentage of infiltration by lymphocytes in a solid tissue normal sample or specimen.\n","termDef":{"cde_id":2897710,"cde_version":2.0,"source":"caDSR","term":"Specimen Lymphocyte Infiltration Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2897710&version=2.0"}},"percent_monocyte_infiltration":{"description":"Numeric value to represent the percentage of monocyte infiltration in a sample or specimen.\n","termDef":{"cde_id":5455535,"cde_version":1.0,"source":"caDSR","term":"Specimen Monocyte Infiltration Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5455535&version=1.0"}},"percent_necrosis":{"description":"Numeric value to represent the percentage of cell death in a malignant tumor sample or specimen.\n","termDef":{"cde_id":2841237,"cde_version":1.0,"source":"caDSR","term":"Malignant Neoplasm Necrosis Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2841237&version=1.0"}},"percent_neutrophil_infiltration":{"description":"Numeric value to represent the percentage of infiltration by neutrophils in a tumor sample or specimen.\n","termDef":{"cde_id":2841267,"cde_version":1.0,"source":"caDSR","term":"Malignant Neoplasm Neutrophil Infiltration Percentage Cell Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2841267&version=1.0"}},"percent_normal_cells":{"description":"Numeric value to represent the percentage of normal cell content in a malignant tumor sample or specimen.\n","termDef":{"cde_id":2841233,"cde_version":1.0,"source":"caDSR","term":"Malignant Neoplasm Normal Cell Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2841233&version=1.0"}},"percent_stromal_cells":{"description":"Numeric value to represent the percentage of reactive cells that are present in a malignant tumor sample or specimen but are not malignant such as fibroblasts, vascular structures, etc.\n","termDef":{"cde_id":2841241,"cde_version":1.0,"source":"caDSR","term":"Malignant Neoplasm Stromal Cell Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2841241&version=1.0"}},"percent_tumor_cells":{"description":"Numeric value that represents the percentage of infiltration by granulocytes in a sample.\n","termDef":{"cde_id":5432686,"cde_version":1.0,"source":"caDSR","term":"Specimen Tumor Cell Percentage Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432686&version=1.0"}},"percent_tumor_nuclei":{"description":"Numeric value to represent the percentage of tumor nuclei in a malignant neoplasm sample or specimen.\n","termDef":{"cde_id":2841225,"cde_version":1.0,"source":"caDSR","term":"Malignant Neoplasm Neoplasm Nucleus Percentage Cell Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2841225&version=1.0"}},"perineural_invasion_present":{"description":"a yes/no indicator to ask if perineural invasion or infiltration of tumor or cancer is present.\n","termDef":{"cde_id":64181,"cde_version":3.0,"source":"caDSR","term":"Tumor Perineural Invasion Ind","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64181&version=3.0"}},"peripancreatic_lymph_nodes_positive":{"description":"Enumerated numeric value or range of values used to describe the number of peripancreatic lymph nodes determined to be positive.\n","termDef":{"cde_id":5983082,"cde_version":2.0,"source":"caDSR","term":"Peripancreatic Lymph Node Positive Finding Range","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5983082&version=2.0"}},"peripancreatic_lymph_nodes_tested":{"description":"The total number of peripancreatic lymph nodes tested for the presence of pancreatic cancer cells.\n","termDef":{"cde_id":6050944,"cde_version":1.0,"source":"caDSR","term":"Peripancreatic Lymph Node Examined Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6050944&version=1.0"}},"platelet_count":{"description":"The absolute peripheral platelet count (in 1000/uL).\n","termDef":{"cde_id":58304,"cde_version":4.0,"source":"caDSR","term":"Laboratory Procedure Platelet Result Specified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=58304&version=4.0"}},"platform":{"description":"Name of the platform used to obtain data.\n"},"ploidy":{"description":"Text term used to describe the number of sets of homologous chromosomes.\n","termDef":{"cde_id":6142527,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Ploidy Result Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142527&version=1.0"}},"portion_number":{"description":"Numeric value that represents the sequential number assigned to a portion of the sample.\n","termDef":{"cde_id":5432711,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Portion Sequence Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432711&version=1.0"}},"portion_weight":{"description":"Numeric value that represents the sample portion weight, measured in milligrams.\n","termDef":{"cde_id":5432593,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Portion Weight Milligram Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432593&version=1.0"}},"premature_at_birth":{"description":"The yes/no/unknown indicator used to describe whether the patient was premature (less than 37 weeks gestation) at birth.\n","termDef":{"cde_id":6010765,"cde_version":1.0,"source":"caDSR","term":"Premature Infant Birth Status Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6010765&version=1.0"}},"preservation_method":{"description":"Text term that represents the method used to preserve the sample.\n","termDef":{"cde_id":5432521,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Preservation Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432521&version=1.0"}},"primary_diagnosis":{"description":"Text term for the structural pattern of cancer cells used to define a microscopic diagnosis.\n","termDef":{"cde_id":3081934,"cde_version":3.0,"source":"caDSR","term":"Neoplasm Histologic Type Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3081934&version=3.0"}},"primary_site":{"description":"The text term used to describe the general location of the malignant disease, as categorized by the World Health Organization's (WHO) International Classification of Diseases for Oncology (ICD-O).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Primary Site","term_url":null}},"prior_malignancy":{"description":"The yes/no/unknown indicator used to describe the patient's history of prior cancer diagnosis.\n","termDef":{"cde_id":3382736,"cde_version":2.0,"source":"caDSR","term":"Prior Cancer Diagnosis Occurrence Description Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3382736&version=2.0"}},"prior_treatment":{"description":"A yes/no/unknown/not applicable indicator related to the administration of therapeutic agents received before the body specimen was collected.\n","termDef":{"cde_id":4231463,"cde_version":1.0,"source":"caDSR","term":"Therapeutic Procedure Prior Specimen Collection Administered Yes No Unknown Not Applicable Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4231463&version=1.0"}},"progesterone_receptor_percent_positive_ihc":{"description":"Classification to represent Progesterone Receptor Positive results expressed as a percentage value.\n","termDef":{"cde_id":3128342,"cde_version":1.0,"source":"caDSR","term":"Progesterone Receptor Level Cell Percentage Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3128342&version=1.0"}},"progesterone_receptor_result_ihc":{"description":"Text term to represent the overall result of Progresterone Receptor (PR) testing.\n","termDef":{"cde_id":2957357,"cde_version":2.0,"source":"caDSR","term":"Breast Carcinoma Progesterone Receptor Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2957357&version=2.0"}},"progression_free_survival":{"description":"Number of days between the date used for index and the first date the patient is known to be free of disease progression.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"progression_free_survival_event":{"description":"The event used to define the patient's disease progression.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"progression_or_recurrence":{"description":"Yes/No/Unknown indicator to identify whether a patient has had a new tumor event after initial treatment.\n","termDef":{"cde_id":3121376,"cde_version":1.0,"source":"caDSR","term":"New Neoplasm Event Post Initial Therapy Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3121376&version=1.0"}},"progression_or_recurrence_anatomic_site":{"description":"Text term that describes the anatomic site of the progression or recurrent tumor or relapsed disease.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"progression_or_recurrence_type":{"description":"The text term used to describe the type of progressive or recurrent disease or relapsed disease.\n","termDef":{"cde_id":6142385,"cde_version":1.0,"source":"caDSR","term":"Progression or Recurrence Description Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142385&version=1.0"}},"project_id":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"qc_metric_state":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}},"race":{"description":"An arbitrary classification of a taxonomic group that is a division of a species. It usually arises as a consequence of geographical isolation within a species and is characterized by shared heredity, physical attributes and behavior, and in the case of humans, by common history, nationality, or geographic distribution. The provided values are based on the categories defined by the U.S. Office of Management and Business and used by the U.S. Census Bureau.\n","termDef":{"cde_id":2192199,"cde_version":1.0,"source":"caDSR","term":"Race Category Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2192199&version=1.0"}},"read_group_name":{"description":"The name of the read group.\n"},"read_length":{"description":"The length of the reads.\n"},"read_pair_number":{"description":"Denotes whether a submitted FASTQ file contains forward (R1) or reverse (R2) reads for paired-end sequencing.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"reflux_treatment":{"description":"The yes/no/unknown indicator used to describe whether the patient received reflux treatment.\n","termDef":{"cde_id":6133607,"cde_version":1.0,"source":"caDSR","term":"Gastroesophageal Reflux Disease Therapeutic Procedure Performed Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6133607&version=1.0"}},"reflux_treatment_type":{"description":"Text term used to describe the types of treatment used to manage gastroesophageal reflux disease (GERD).\n","termDef":{"cde_id":3440206,"cde_version":1.0,"source":"caDSR","term":"Gastroesophageal Reflux Disease Treatment Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3440206&version=1.0"}},"regimen_or_line_of_therapy":{"description":"The name of a regimen or line of therapy assigned to the patient.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Treatment Regimen or Line of Therapy","term_url":null}},"relationship_age_at_diagnosis":{"description":"The age (in years) when the patient's relative was first diagnosed. If the age is greater than 89 years, see 'relationship_age_at_diagnosis_gt89'.\n","termDef":{"cde_id":5300571,"cde_version":1.0,"source":"caDSR","term":"Relative Diagnosis Age Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5300571&version=1.0"}},"relationship_age_at_diagnosis_gt89":{"description":"Indicate whether 'The age (in years) when the patient's relative was first diagnosed' is greater than 89 years.\n","termDef":{"cde_id":5300571,"cde_version":1.0,"source":"caDSR","term":"Relative Diagnosis Age Value Greater than 89","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5300571&version=1.0"}},"relationship_type":{"description":"The subgroup that describes the state of connectedness between members of the unit of society organized around kinship ties.\n","termDef":{"cde_id":2690165,"cde_version":2.0,"source":"caDSR","term":"Family Member Relationship Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2690165&version=2.0"}},"relative_with_cancer_history":{"description":"Indicator to signify whether or not an individual's biological relative has been diagnosed with another type of cancer.\n","termDef":{"cde_id":3901752,"cde_version":1.0,"source":"caDSR","term":"Other Cancer Biological Relative History Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3901752&version=1.0"}},"residual_disease":{"description":"Text terms to describe the status of a tissue margin following surgical resection.\n","termDef":{"cde_id":2608702,"cde_version":1.0,"source":"caDSR","term":"Surgical Margin Resection Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2608702&version=1.0"}},"ribosomal_rna_28s_16s_ratio":{"description":"The 28S/18S ribosomal RNA band ratio used to assess the quality of total RNA.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"28s/18s Ribosomal RNA Ratio","term_url":null}},"risk_factor":{"description":"The text term used to describe a risk factor the patient had at the time of or prior to their diagnosis.\n","termDef":{"cde_id":6142389,"cde_version":1.0,"source":"caDSR","term":"Risk Factor Description Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142389&version=1.0"}},"rna_change":{"description":"Alphanumeric value used to describe the rna change for a specific genetic variant. Example: r.76a>c\n","termDef":{"cde_id":6142509,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure RNA Change Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142509&version=1.0"}},"sample_type":{"description":"Text term to describe the source of a biospecimen used for a laboratory test.\n","termDef":{"cde_id":3111302,"cde_version":2.0,"source":"caDSR","term":"Specimen Type Collection Biospecimen Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3111302&version=2.0"}},"sample_type_id":{"description":"The accompanying sample type id for the sample type.\n"},"second_gene_symbol":{"description":"The text term used to describe a secondary gene targeted or included in molecular analysis. For rearrangements, this is should represent the location of the variant.\n","termDef":{"cde_id":6142393,"cde_version":1.0,"source":"caDSR","term":"Molecular Analysis Secondary Gene Symbol Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142393&version=1.0"}},"section_location":{"description":"Tissue source of the slide.\n"},"selected_normal_low_pass_wgs":{"description":"Denotes which low-pass WGS normal aliquot to submitter prefers to use for variant calling. Only one normal per experimental strategy per case can be selected.\n"},"selected_normal_targeted_sequencing":{"description":"Denotes which targeted_sequencing normal aliquot to submitter prefers to use for variant calling. Only one normal per experimental strategy per case can be selected.\n"},"selected_normal_wgs":{"description":"Denotes which WGS normal aliquot to submitter prefers to use for variant calling. Only one normal per experimental strategy per case can be selected.\n"},"selected_normal_wxs":{"description":"Denotes which WXS normal aliquot to submitter prefers to use for variant calling. Only one normal per experimental strategy per case can be selected.\n"},"sequencing_center":{"description":"Name of the center that provided the sequence files.\n"},"shortest_dimension":{"description":"Numeric value that represents the shortest dimension of the sample, measured in millimeters.\n","termDef":{"cde_id":5432603,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Short Dimension Millimeter Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432603&version=1.0"}},"site_of_resection_or_biopsy":{"description":"The third edition of the International Classification of Diseases for Oncology, published in 2000, used principally in tumor and cancer registries for coding the site (topography) and the histology (morphology) of neoplasms. The description of an anatomical region or of a body part. Named locations of, or within, the body. A system of numbered categories for representation of data.\n","termDef":{"cde_id":3226281,"cde_version":1.0,"source":"caDSR","term":"International Classification of Diseases for Oncology, Third Edition ICD-O-3 Site Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3226281&version=1.0"}},"size_selection_range":{"description":"Range of size selection.\n"},"smoking_history":{"description":"Category describing current smoking status and smoking history as self-reported by a patient.\n","termDef":{"cde_id":2181650,"cde_version":1.0,"source":"caDSR","term":"Smoking History","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2181650&version=1.0"}},"smoking_intensity":{"description":"Numeric computed value to represent lifetime tobacco exposure defined as number of cigarettes smoked per day x number of years smoked divided by 20\n","termDef":{"cde_id":2955385,"cde_version":1.0,"source":"caDSR","term":"Person Cigarette Smoking History Pack Year Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2955385&version=1.0"}},"source_center":{"description":"Name of the center that provided the item.\n"},"specialized_molecular_test":{"description":"Text term used to describe a specific test that is not covered in the list of molecular analysis methods.\n","termDef":{"cde_id":6142526,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Specialized Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142526&version=1.0"}},"spectrophotometer_method":{"description":"Name of the method used to determine the concentration of purified nucleic acid within a solution.\n","termDef":{"cde_id":3008378,"cde_version":1.0,"source":"caDSR","term":"Purification Nucleic Acid Solution Concentration Determination Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3008378&version=1.0"}},"spike_ins_concentration":{"description":"Spike in concentration.\n"},"spike_ins_fasta":{"description":"Name of the FASTA file that contains the spike-in sequences.\n"},"state":{"description":"The current state of the object.\n"},"supratentorial_localization":{"description":"Text term to specify the location of the supratentorial tumor.\n","termDef":{"cde_id":3133891,"cde_version":1.0,"source":"caDSR","term":"Tumor Location Central Nervous System Tissue Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3133891&version=1.0"}},"synchronous_malignancy":{"description":"A yes/no/unknown indicator used to describe whether the patient had an additional malignant diagnosis at the same time the tumor used for sequencing was diagnosed. If both tumors were sequenced, both tumors would have synchronous malignancies.\n","termDef":{"cde_id":6142390,"cde_version":1.0,"source":"caDSR","term":"Malignant Disease Diagnosis Synchronous Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142390&version=1.0"}},"target_capture_kit":{"description":"Description that can uniquely identify a target capture kit. Suggested value is a combination of vendor, kit name, and kit version.\n"},"target_capture_kit_catalog_number":{"description":"Catalog of Target Capture Kit.\n"},"target_capture_kit_name":{"description":"Name of Target Capture Kit.\n"},"target_capture_kit_target_region":{"description":"Target Capture Kit BED file.\n"},"target_capture_kit_vendor":{"description":"Vendor of Target Capture Kit.\n"},"target_capture_kit_version":{"description":"Version of Target Capture Kit.\n"},"test_analyte_type":{"description":"The text term used to describe the type of analyte used for molecular testing.\n","termDef":{"cde_id":6142394,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Analyte Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142394&version=1.0"}},"test_result":{"description":"The text term used to describe the result of the molecular test. If the test result was a numeric value see test_value.\n","termDef":{"cde_id":6142397,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Outcome","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142397&version=1.0"}},"test_units":{"description":"The text term used to describe the units of the test value for a molecular test. This property is used in conjunction with test_value.\n","termDef":{"cde_id":6142525,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Outcome Unit of Measure","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142525&version=1.0"}},"test_value":{"description":"The text term or numeric value used to describe a sepcific result of a molecular test.\n","termDef":{"cde_id":6142524,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Outcome Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142524&version=1.0"}},"therapeutic_agents":{"description":"Text identification of the individual agent(s) used as part of a prior treatment regimen.\n","termDef":{"cde_id":2975232,"cde_version":1.0,"source":"caDSR","term":"Prior Therapy Regimen Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2975232&version=1.0"}},"time_between_clamping_and_freezing":{"description":"Numeric representation of the elapsed time between the surgical clamping of blood supply and freezing of the sample, measured in minutes.\n","termDef":{"cde_id":5432611,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Clamping and Freezing Elapsed Minute Time","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432611&version=1.0"}},"time_between_excision_and_freezing":{"description":"Numeric representation of the elapsed time between the excision and freezing of the sample, measured in minutes.\n","termDef":{"cde_id":5432612,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Excision and Freezing Elapsed Minute Time","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432612&version=1.0"}},"tissue_or_organ_of_origin":{"description":"Text term that describes the anatomic site of the tumor or disease.\n","termDef":{"cde_id":3427536,"cde_version":3.0,"source":"caDSR","term":"Tumor Disease Anatomic Site","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3427536&version=3.0"}},"tissue_type":{"description":"Text term that represents a description of the kind of tissue collected with respect to disease status or proximity to tumor tissue.\n","termDef":{"cde_id":5432687,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Description Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432687&version=1.0"}},"to_trim_adapter_sequence":{"description":"Does the user suggest adapter trimming?\n"},"tobacco_smoking_onset_year":{"description":"The year in which the participant began smoking.\n","termDef":{"cde_id":2228604,"cde_version":1.0,"source":"caDSR","term":"Started Smoking Year","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2228604&version=1.0"}},"tobacco_smoking_quit_year":{"description":"The year in which the participant quit smoking.\n","termDef":{"cde_id":2228610,"cde_version":1.0,"source":"caDSR","term":"Stopped Smoking Year","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2228610&version=1.0"}},"tobacco_smoking_status":{"description":"Category describing current smoking status and smoking history as self-reported by a patient.\n","termDef":{"cde_id":2181650,"cde_version":1.0,"source":"caDSR","term":"Patient Smoking History Category","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2181650&version=1.0"}},"total_protein":{"description":"The numeric value, in g/dL, for the results of the medical procedure that involves testing a sample of blood for total serum proteins, dissolved proteins of blood plasma, consisting mainly of albumins and globulins and include antibodies and blood- clotting proteins.\n","termDef":{"cde_id":2181536,"cde_version":1.0,"source":"caDSR","term":"Laboratory Procedure Total Serum Protein Outcome Unspecified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2181536&version=1.0"}},"total_sequences":{"description":"A count of the total number of sequences processed.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"Total Sequences","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/1%20Basic%20Statistics.html"}},"transcript":{"description":"Alphanumeric value used to describe the transcript of a specific genetic variant.\n","termDef":{"cde_id":6142465,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Transcript Location Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142465&version=1.0"}},"treatment_anatomic_site":{"description":"The anatomic site or field targeted by a treatment regimen or single agent therapy.\n","termDef":{"cde_id":5615611,"cde_version":1.0,"source":"caDSR","term":"Treatment Anatomic Site","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5615611&version=1.0"}},"treatment_intent_type":{"description":"Text term to identify the reason for the administration of a treatment regimen. [Manually-curated]\n","termDef":{"cde_id":2793511,"cde_version":1.0,"source":"caDSR","term":"Treatment Regimen Intent Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2793511&version=1.0"}},"treatment_or_therapy":{"description":"A yes/no/unknown/not applicable indicator related to the administration of therapeutic agents received before the body specimen was collected.\n","termDef":{"cde_id":4231463,"cde_version":1.0,"source":"caDSR","term":"Therapeutic Procedure Prior Specimen Collection Administered Yes No Unknown Not Applicable Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4231463&version=1.0"}},"treatment_outcome":{"description":"Text term that describes the patient's final outcome after the treatment was administered.\n","termDef":{"cde_id":5102383,"cde_version":1.0,"source":"caDSR","term":"Treatment Outcome Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5102383&version=1.0"}},"treatment_type":{"description":"Text term that describes the kind of treatment administered.\n","termDef":{"cde_id":5102381,"cde_version":1.0,"source":"caDSR","term":"Treatment Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5102381&version=1.0"}},"tumor_code":{"description":"Diagnostic tumor code of the tissue sample source.\n"},"tumor_code_id":{"description":"BCR-defined id code for the tumor sample.\n"},"tumor_confined_to_organ_of_origin":{"description":"The yes/no/unknown indicator used to describe whether the tumor is confined to the organ where it originated and did not spread to a proximal or distant location within the body.\n","termDef":{"cde_id":4925494,"cde_version":1.0,"source":"caDSR","term":"Tumor Mass Organ Origin Yes No Unknown Not Applicable Indicator","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4925494&version=1.0"}},"tumor_descriptor":{"description":"Text that describes the kind of disease present in the tumor specimen as related to a specific timepoint.\n","termDef":{"cde_id":3288124,"cde_version":1.0,"source":"caDSR","term":"Tumor Tissue Disease Description Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3288124&version=1.0"}},"tumor_grade":{"description":"Numeric value to express the degree of abnormality of cancer cells, a measure of differentiation and aggressiveness.\n","termDef":{"cde_id":2785839,"cde_version":2.0,"source":"caDSR","term":"Neoplasm Histologic Grade","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2785839&version=2.0"}},"tumor_largest_dimension_diameter":{"description":"Numeric value used to describe the maximum diameter or dimension of the primary tumor, measured in centimeters.\n","termDef":{"cde_id":64215,"cde_version":3.0,"source":"caDSR","term":"Tumor Largest Dimension Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64215&version=3.0"}},"tumor_stage":{"description":"The extent of a cancer in the body. Staging is usually based on the size of the tumor, whether lymph nodes contain cancer, and whether the cancer has spread from the original site to other parts of the body. The accepted values for tumor_stage depend on the tumor site, type, and accepted staging system. These items should accompany the tumor_stage value as associated metadata.\n","termDef":{"cde_id":"C16899","cde_version":null,"source":"NCIt","term":"Tumor Stage","term_url":"https://ncit.nci.nih.gov/ncitbrowser/pages/concept_details.jsf?dictionary=NCI%20Thesaurus&code=C16899"}},"variant_type":{"description":"The text term used to describe the type of genetic variation.\n","termDef":{"cde_id":6142402,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Genetic Variant Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142402&version=1.0"}},"vascular_invasion_present":{"description":"The yes/no indicator to ask if large vessel or venous invasion was detected by surgery or presence in a tumor specimen.\n","termDef":{"cde_id":64358,"cde_version":3.0,"source":"caDSR","term":"Tumor Vascular Invasion Ind-3","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=64358&version=3.0"}},"vascular_invasion_type":{"description":"Text term that represents the type of vascular tumor invasion.\n","termDef":{"cde_id":3168001,"cde_version":1.0,"source":"caDSR","term":"Vascular Tumor Cell Invasion Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3168001&version=1.0"}},"viral_hepatitis_serologies":{"description":"Text term that describes the kind of serological laboratory test used to determine the patient's hepatitus status.\n","termDef":{"cde_id":4395982,"cde_version":1.0,"source":"caDSR","term":"Viral Hepatitis Laboratory Procedure Serology Test Method Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4395982&version=1.0"}},"vital_status":{"description":"The survival state of the person registered on the protocol.\n","termDef":{"cde_id":5,"cde_version":5.0,"source":"caDSR","term":"Patient Vital Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5&version=5.0"}},"wbc":{"description":"The absolute peripheral white blood cell count (in 1000/uL).\n","termDef":{"cde_id":58312,"cde_version":3.0,"source":"caDSR","term":"Laboratory Procedure Leukocyte Result Specified Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=58312&version=3.0"}},"weeks_gestation_at_birth":{"description":"Numeric value used to describe the number of weeks starting  from the approximate date of the biological mother's last menstrual period and ending with the birth of the patient.\n","termDef":{"cde_id":2737369,"cde_version":1.0,"source":"caDSR","term":"Pregnancy Week Number Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2737369&version=1.0"}},"weight":{"description":"The weight of the patient measured in kilograms.\n","termDef":{"cde_id":651,"cde_version":4.0,"source":"caDSR","term":"Patient Weight Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=651&version=4.0"}},"well_number":{"description":"Numeric value that represents the the well location within a plate for the analyte or aliquot from the sample.\n","termDef":{"cde_id":5432613,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Analyte or Aliquot Plate Well Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432613&version=1.0"}},"wilms_tumor_histologic_subtype":{"description":"The text term used to describe the classification of Wilms tumors distinguishing between favorable and unfavorable histologic groups.\n","termDef":{"cde_id":4358735,"cde_version":1.0,"source":"caDSR","term":"Disease Histology Confirmation Favorable Status","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4358735&version=1.0"}},"workflow_type":{"description":"Generic name for the workflow used to analyze a data set.\n"},"year_of_birth":{"description":"Numeric value to represent the calendar year in which an individual was born.\n","termDef":{"cde_id":2896954,"cde_version":1.0,"source":"caDSR","term":"Year Birth Date Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2896954&version=1.0"}},"year_of_death":{"description":"Numeric value to represent the year of the death of an individual.\n","termDef":{"cde_id":2897030,"cde_version":1.0,"source":"caDSR","term":"Year Death Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2897030&version=1.0"}},"year_of_diagnosis":{"description":"Numeric value to represent the year of an individual's initial pathologic diagnosis of cancer.\n","termDef":{"cde_id":2896960,"cde_version":1.0,"source":"caDSR","term":"Year of initial pathologic diagnosis","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2896960&version=1.0"}},"years_smoked":{"description":"Numeric value (or unknown) to represent the number of years a person has been smoking.\n","termDef":{"cde_id":3137957,"cde_version":1.0,"source":"caDSR","term":"Person Smoking Duration Year Count","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=3137957&version=1.0"}},"zygosity":{"description":"The text term used to describe the zygosity of a specific genetic variant.\n","termDef":{"cde_id":6142510,"cde_version":1.0,"source":"caDSR","term":"Molecular Laboratory Procedure Genetic Zygosity Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=6142510&version=1.0"}}},"acknowledgement":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"Acknowledgement of an individual involved in a project.","id":"acknowledgement","links":[{"backref":"acknowledgements","label":"contribute_to","multiplicity":"many_to_many","name":"projects","required":true,"target_type":"project"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"acknowledgee":{"description":"The indvidiual or group being acknowledged by the project.","type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"projects":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"}]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","projects"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Acknowledgement","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"aligned_reads":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"data_file","description":"Data file containing aligned reads that are generated internally.","id":"aligned_reads","links":[{"exclusive":false,"required":true,"subgroup":[{"backref":"aligned_reads_files","label":"data_from","multiplicity":"many_to_one","name":"core_metadata_collections","required":false,"target_type":"core_metadata_collection"},{"backref":"aligned_reads_files","label":"data_from","multiplicity":"many_to_one","name":"alignment_workflows","required":false,"target_type":"alignment_workflow"},{"backref":"aligned_reads_files","label":"matched_to","multiplicity":"one_to_many","name":"submitted_unaligned_reads_files","required":false,"target_type":"submitted_unaligned_reads"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"alignment_workflows":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"core_metadata_collections":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_category":{"enum":["Raw Sequencing Data","Sequencing Data","Sequencing Reads"],"term":{"description":"Broad categorization of the contents of the data file.\n"}},"data_format":{"enum":["BAM","CRAM"],"term":{"description":"Format of the data files.\n"}},"data_type":{"enum":["Aligned Reads"],"term":{"description":"Specific content type of the data file.\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"experimental_strategy":{"enum":["Low Pass WGS","RNA-Seq","Total RNA-Seq","Validation","WGS","WXS","miRNA-Seq"],"term":{"description":"The sequencing strategy used to generate the data file.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"platform":{"enum":["Complete Genomics","Illumina","Ion Torrent","LS454","Other","PacBio","SOLiD"],"term":{"description":"Name of the platform used to obtain data.\n"}},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitted_unaligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","file_name","file_size","md5sum","data_category","data_type","data_format","experimental_strategy","platform"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime","file_state","error_type"],"title":"Aligned Reads","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"aligned_reads_index":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"index_file","description":"Data file containing the index for a set of aligned reads.","id":"aligned_reads_index","links":[{"backref":"aligned_reads_indexes","label":"derived_from","multiplicity":"one_to_one","name":"aligned_reads_files","required":false,"target_type":"aligned_reads"},{"exclusive":false,"required":true,"subgroup":[{"backref":"aligned_reads_indexes","label":"data_from","multiplicity":"many_to_one","name":"core_metadata_collections","required":false,"target_type":"core_metadata_collection"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"aligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"core_metadata_collections":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_category":{"enum":["Raw Sequencing Data","Sequencing Data","Sequencing Reads"],"term":{"description":"Broad categorization of the contents of the data file.\n"}},"data_format":{"enum":["BAI"],"term":{"description":"Format of the data files.\n"}},"data_type":{"enum":["Aligned Reads Index"],"term":{"description":"Specific content type of the data file.\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","file_name","file_size","md5sum","data_category","data_type","data_format"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime","file_state","error_type"],"title":"Aligned Reads Index","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"alignment_workflow":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"analysis","description":"Metadata for the alignment pipeline used to align reads in the GDC harmonization pipelines.","id":"alignment_workflow","links":[{"exclusive":true,"required":true,"subgroup":[{"backref":"alignment_workflows","label":"performed_on","multiplicity":"one_to_many","name":"submitted_unaligned_reads_files","required":false,"target_type":"submitted_unaligned_reads"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitted_unaligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_end_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_link":{"description":"Link to Github hash for the CWL workflow used.","type":"string"},"workflow_start_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_type":{"enum":["BWA-aln","BWA-mem","STAR","spinnaker"]},"workflow_version":{"description":"Major version for a GDC workflow.","type":"string"}},"required":["submitter_id","type","workflow_type"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Alignment Workflow","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"aliquot":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"biospecimen","description":"Pertaining to a portion of the whole; any one of two or more samples of something, of the same volume or weight.","id":"aliquot","links":[{"backref":"aliquots","label":"derived_from","multiplicity":"many_to_one","name":"samples","required":true,"target_type":"sample"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"a260_a280_ratio":{"term":{"description":"Numeric value that represents the sample ratio of nucleic acid absorbance at 260 nm and 280 nm, used to determine a measure of DNA purity.\n","termDef":{"cde_id":5432595,"cde_version":1.0,"source":"caDSR","term":"Nucleic Acid Absorbance at 260 And Absorbance at 280 DNA Purity Ratio Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432595&version=1.0"}},"type":"number"},"aliquot_quantity":{"term":{"description":"The quantity in micrograms (ug) of the aliquot(s) derived from the analyte(s) shipped for sequencing and characterization.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Aliquot Quantity","term_url":null}},"type":"number"},"aliquot_volume":{"term":{"description":"The volume in microliters (ml) of the aliquot(s) derived from the analyte(s) shipped for sequencing and characterization.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Aliquot Volume","term_url":null}},"type":"number"},"amount":{"term":{"description":"Weight in grams or volume in mL.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":"Biospecimen Aliquot Amount","term_url":null}},"type":"number"},"analyte_type":{"term":{"description":"Text term that represents the kind of molecular specimen analyte.\n","termDef":{"cde_id":2513915,"cde_version":2.0,"source":"caDSR","term":"Molecular Specimen Type Text Name","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2513915&version=2.0"}},"type":"string"},"analyte_type_id":{"enum":["D","E","G","H","R","S","T","W","X","Y"],"term":{"description":"A single letter code used to identify a type of molecular analyte.\n","termDef":{"cde_id":5432508,"cde_version":1.0,"source":"caDSR","term":"Molecular Analyte Identification Code","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432508&version=1.0"}}},"concentration":{"term":{"description":"Numeric value that represents the concentration of an analyte or aliquot extracted from the sample or sample portion, measured in milligrams per milliliter.\n","termDef":{"cde_id":5432594,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Analyte or Aliquot Extracted Concentration Milligram per Milliliter Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432594&version=1.0"}},"type":"number"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"samples":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"source_center":{"term":{"description":"Name of the center that provided the item.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","samples"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Aliquot","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"core_metadata_collection":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"Structured description of a collection of several datasets","id":"core_metadata_collection","links":[{"backref":"core_metadata_collections","label":"data_from","multiplicity":"many_to_one","name":"projects","required":true,"target_type":"project"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"contributor":{"description":"An entity responsible for making contributions to the resource. Examples of a Contributor include a person, an organization, or a service. Typically, the name of a Contributor should be used to indicate the entity.","type":"string"},"coverage":{"description":"The spatial or temporal topic of the resource, the spatial applicability of the resource, or the jurisdiction under which the resource is relevant. Spatial topic and spatial applicability may be a named place or a location specified by its geographic coordinates. Temporal topic may be a named period, date, or date range. A jurisdiction may be a named administrative entity or a geographic place to which the resource applies. Recommended best practice is to use a controlled vocabulary such as the Thesaurus of Geographic Names [TGN] (http-//www.getty.edu/research/tools/vocabulary/tgn/index.html). Where appropriate, named places or time periods can be used in preference to numeric identifiers such as sets of coordinates or date ranges.","type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"creator":{"description":"An entity primarily responsible for making the resource. Examples of a Creator include a person, an organization, or a service. Typically, the name of a Creator should be used to indicate the entity.","type":"string"},"data_type":{"description":"The nature or genre of the resource. Recommended best practice is to use a controlled vocabulary such as the DCMI Type Vocabulary [DCMITYPE]. To describe the file format, physical medium, or dimensions of the resource, use the Format element.","type":"string"},"date":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"description":{"description":"An account of the resource. Description may include but is not limited to- an abstract, a table of contents, a graphical representation, or a free-text account of the resource.","type":"string"},"format":{"description":"The file format, physical medium, or dimensions of the resource. Examples of dimensions include size and duration. Recommended best practice is to use a controlled vocabulary such as the list of Internet Media Types [MIME] (http-//www.iana.org/assignments/media-types/).","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"language":{"description":"A language of the resource. Recommended best practice is to use a controlled vocabulary such as RFC 4646 (http-//www.ietf.org/rfc/rfc4646.txt).","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"projects":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"}]},"publisher":{"description":"An entity responsible for making the resource available. Examples of a Publisher include a person, an organization, or a service. Typically, the name of a Publisher should be used to indicate the entity.","type":"string"},"relation":{"description":"A related resource. Recommended best practice is to identify the related resource by means of a string conforming to a formal identification system.","type":"string"},"rights":{"description":"Information about rights held in and over the resource. Typically, rights information includes a statement about various property rights associated with the resource, including intellectual property rights.","type":"string"},"source":{"description":"A related resource from which the described resource is derived. The described resource may be derived from the related resource in whole or in part. Recommended best practice is to identify the related resource by means of a string conforming to a formal identification system.","type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"subject":{"description":"The topic of the resource. Typically, the subject will be represented using keywords, key phrases, or classification codes. Recommended best practice is to use a controlled vocabulary.","type":"string"},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"title":{"description":"A name given to the resource. Typically, a Title will be a name by which the resource is formally known.","type":"string"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","projects"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Core Metadata Collection","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"data_release":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"internal","description":"Internal node to store different data releases.\n","id":"data_release","links":[{"backref":"data_releases","label":"describes","multiplicity":"many_to_one","name":"roots","required":true,"target_type":"root"}],"namespace":"http://gdc.nci.nih.gov","program":"*","project":"*","properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"major_version":{"description":"The number identifying the major version.\n","type":"integer"},"minor_version":{"description":"The number identifying the minor version.\n","type":"integer"},"name":{"description":"String representing release name.\n","type":"string"},"release_date":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"released":{"default":false,"description":"Indicates if it is the current release.\n","type":"boolean"},"roots":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"type":{"enum":["data_release"]},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["name","major_version","minor_version","type"],"submittable":false,"systemProperties":["id","created_datetime","updated_datetime"],"title":"Data Release","type":"object","uniqueKeys":[["id"]],"validators":null},"demographic":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"clinical","description":"Data for the characterization of the patient by means of segmenting the population (e.g.,characterization by age, sex, or race).","id":"demographic","links":[{"backref":"demographics","label":"describes","multiplicity":"one_to_one","name":"subjects","required":true,"target_type":"subject"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"age_range":{"description":"Range of ages for the subject. The age range should not include ages over 89 years.","type":"string"},"cause_of_death":{"description":"Text term to identify the cause of death for a patient.","type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"days_to_birth":{"description":"Time interval from a person\u2019s date of birth to the date of initial pathologic diagnosis, represented as a calculated negative number of days.","maximum":0,"minimum":-32872,"type":"integer"},"days_to_death":{"description":"Time interval from a person\u2019s date of death to the date of initial pathologic diagnosis, represented as a calculated number of days.","type":"integer"},"ethnicity":{"enum":["Unknown","hispanic or latino","not allowed to collect","not hispanic or latino","not reported"],"term":{"description":"An individual's self-described social and cultural grouping, specifically whether an individual describes themselves as Hispanic or Latino. The provided values are based on the categories defined by the U.S. Office of Management and Business and used by the U.S. Census Bureau.\n","termDef":{"cde_id":2192217,"cde_version":2.0,"source":"caDSR","term":"Ethnic Group Category Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2192217&version=2.0"}}},"gender":{"enum":["female","male","not reported","unknown","unspecified"],"term":{"description":"Text designations that identify gender. Gender is described as the assemblage of properties that distinguish people on the basis of their societal roles. [Explanatory Comment 1: Identification of gender is based upon self-report and may come from a form, questionnaire, interview, etc.]\n","termDef":{"cde_id":2200604,"cde_version":3.0,"source":"caDSR","term":"Person Gender Text Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2200604&version=3.0"}}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"race":{"enum":["Unknown","american indian or alaska native","asian","black or african american","native hawaiian or other pacific islander","not allowed to collect","not reported","other","white"],"term":{"description":"An arbitrary classification of a taxonomic group that is a division of a species. It usually arises as a consequence of geographical isolation within a species and is characterized by shared heredity, physical attributes and behavior, and in the case of humans, by common history, nationality, or geographic distribution. The provided values are based on the categories defined by the U.S. Office of Management and Business and used by the U.S. Census Bureau.\n","termDef":{"cde_id":2192199,"cde_version":1.0,"source":"caDSR","term":"Race Category Text","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2192199&version=1.0"}}},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"subjects":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"vital_status":{"description":"The survival state of the person registered on the protocol.","type":"string"},"year_of_birth":{"term":{"description":"Numeric value to represent the calendar year in which an individual was born.\n","termDef":{"cde_id":2896954,"cde_version":1.0,"source":"caDSR","term":"Year Birth Date Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2896954&version=1.0"}},"type":"number"},"year_of_death":{"term":{"description":"Numeric value to represent the year of the death of an individual.\n","termDef":{"cde_id":2897030,"cde_version":1.0,"source":"caDSR","term":"Year Death Number","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=2897030&version=1.0"}},"type":"number"}},"required":["submitter_id","type","subjects"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Demographic","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"diagnosis":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"clinical","description":"Data from the investigation, analysis and recognition of the presence and nature of disease, condition, or injury from expressed signs and symptoms; also, the scientific determination of any kind; the concise results of such an investigation.","id":"diagnosis","links":[{"backref":"diagnoses","label":"describes","multiplicity":"many_to_one","name":"subjects","required":true,"target_type":"subject"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"age_at_diagnosis":{"description":"Age at the time of diagnosis expressed in number of days since birth. If the age is greater than 32872 days (89 years), see 'age_at_diagnosis_gt89'.","maximum":32872,"minimum":0,"type":"integer"},"age_at_diagnosis_gt89":{"description":"Indicate whether the 'Age at the time of diagnosis expressed in number of days since birth' is greater than 32872 days (89 years).","enum":["No","Yes"]},"ajcc_clinical_m":{"description":"Extent of the distant metastasis for the cancer based on evidence obtained from the clinical assessment parameters determined prior to treatment.","type":"string"},"ajcc_clinical_n":{"description":"Extent of the regional lymph node involvement for the cancer based on evidence obtained from clinical assessment parameters determined prior to treatment.","type":"string"},"ajcc_clinical_stage":{"description":"Stage group determined from clinical information on the tumor (T), regional node (N) and metastases (M) and by grouping cases with similar prognosis for cancer.","type":"string"},"ajcc_clinical_t":{"description":"Extent of the primary cancer based on evidence obtained from clinical assessment parameters determined prior to treatment.","type":"string"},"ajcc_pathologic_m":{"description":"Code to represent the defined absence or presence of distant spread or metastases (M) to locations via vascular channels or lymphatics beyond the regional lymph nodes, using criteria established by the American Joint Committee on Cancer (AJCC).","type":"string"},"ajcc_pathologic_n":{"description":"The codes that represent the stage of cancer based on the nodes present (N stage) according to criteria based on multiple editions of the AJCC\u2019s Cancer Staging Manual.","type":"string"},"ajcc_pathologic_stage":{"description":"The extent of a cancer, especially whether the disease has spread from the original site to other parts of the body based on AJCC staging criteria.","type":"string"},"ajcc_pathologic_t":{"description":"Code of pathological T (primary tumor) to define the size or contiguous extension of the primary tumor (T), using staging criteria from the American Joint Committee on Cancer.","type":"string"},"ann_arbor_b_symptoms":{"description":"Text term to signify whether lymphoma B-symptoms are present as noted in the patient\u2019s medical record.","type":"string"},"ann_arbor_clinical_stage":{"description":"The classification of the clinically confirmed anatomic disease extent of lymphoma (Hodgkin\u2019s and Non-Hodgkin\u2019s) based on the Ann Arbor Staging System.","type":"string"},"ann_arbor_extranodal_involvement":{"description":"Indicator that identifies whether a patient with malignant lymphoma has lymphomatous involvement of an extranodal site.","type":"string"},"ann_arbor_pathologic_stage":{"description":"The classification of the pathologically confirmed anatomic disease extent of lymphoma (Hodgkin\u2019s and Non-Hodgkin\u2019s) based on the Ann Arbor Staging System.","type":"string"},"best_overall_response":{"description":"The best improvement achieved throughout the entire course of protocol treatment.","type":"string"},"burkitt_lymphoma_clinical_variant":{"description":"Burkitt\u2019s lymphoma categorization based on clinical features that differ from other forms of the same disease.","type":"string"},"cause_of_death":{"description":"Text term to identify the cause of death for a patient.","type":"string"},"circumferential_resection_margin":{"description":"A value in millimeters indicating the measured length between a malignant lesion of the colon or rectum and the nearest radial (or circumferential) border of tissue removed during cancer surgery.","type":"string"},"classification_of_tumor":{"description":"Text that describes the kind of disease present in the tumor specimen as related to a specific timepoint.","type":"string"},"colon_polyps_history":{"description":"Yes/No indicator to describe if the subject had a previous history of colon polyps as noted in the history/physical or previous endoscopic report(s).","type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"days_to_best_overall_response":{"description":"Number of days between the date used for index and the date of the patient\u2019s best overall response.","type":"string"},"days_to_birth":{"description":"Time interval from a person\u2019s date of birth to the date of initial pathologic diagnosis, represented as a calculated negative number of days.","maximum":0,"minimum":-32872,"type":"integer"},"days_to_death":{"description":"Time interval from a person\u2019s date of death to the date of initial pathologic diagnosis, represented as a calculated number of days.","type":"string"},"days_to_diagnosis":{"description":"Number of days between the date used for index and the date of diagnosis.","type":"string"},"days_to_hiv_diagnosis":{"description":"Time interval from the date of the initial pathologic diagnosis to the date of human immunodeficiency diagnosis, represented as a calculated number of days.","type":"string"},"days_to_last_follow_up":{"description":"Time interval from the date of late follow up to the date of initial pathologic diagnosis, represented as a calculated number of days.","type":"string"},"days_to_last_known_disease_status":{"description":"Time interval from the date of last follow up to the date of initial pathologic diagnosis, represented as a calculated number of days.","type":"string"},"days_to_new_event":{"description":"Time interval from the date of new tumor event including progression, recurrence and new primary malignancies to the date of initial pathologic diagnosis, represented as a calculated number number of days.","type":"string"},"days_to_recurrence":{"description":"Number of days between the date used for index and the date the patient was diagnosed with a recurrent malignancy.","type":"string"},"figo_stage":{"description":"The extent of a cervical or endometrial cancer within the body, especially whether the disease has spread from the original site to other parts of the body, as described by the International Federation of Gynecology and Obstetrics (FIGO) stages.","type":"string"},"hist_subtype1":{"description":"Subtype of the microscopic structure of tissues","type":"string"},"histology":{"description":"Result of the microscopic structure of tissues","type":"string"},"hiv_positive":{"description":"Text term to signify whether a physician has diagnosed HIV infection in a patient.","type":"string"},"hpv_positive_type":{"description":"Text classification to represent the strain or type of human papillomavirus identified in an individual.","type":"string"},"hpv_status":{"description":"The findings of the oncogenic HPV.","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"iss_stage":{"description":"The multiple myeloma disease stage at diagnosis.","type":"string"},"last_known_disease_status":{"description":"Text term that describes the last known state or condition of an individual\u2019s neoplasm.","type":"string"},"laterality":{"description":"For tumors in paired organs, designates the side on which the cancer originates.","type":"string"},"ldh_level_at_diagnosis":{"description":"The 2 decimal place numeric laboratory value measured, assigned or computed related to the assessment of lactate dehydrogenase in a specimen.","type":"string"},"ldh_normal_range_upper":{"description":"The top value of the range of statistical characteristics that are supposed to represent accepted standard, non-pathological pattern for lactate dehydrogenase (units not specified).","type":"string"},"lymph_nodes_positive":{"description":"The number of lymph nodes involved with disease as determined by pathologic examination.","type":"string"},"lymphatic_invasion_present":{"description":"A yes/no indicator to ask if small or thin-walled vessel invasion is present, indicating lymphatic involvement.","type":"string"},"method_of_diagnosis":{"description":"The method used to initially determine the patient\u2019s diagnosis.","type":"string"},"morphology":{"description":"The third edition of the International Classification of Diseases for Oncology, published in 2000 used principally in tumor and cancer registries for coding the site (topography) and the histology (morphology) or neoplasms. The study of the structure of the cells and their arrangement to constitute tissues and, finally, the association among these to form organs. In pathology, the microscopic process or identifying normal and abnormal morphologic characteristics in tissues, by employing various cytochemical and immunocytochemical stains. A system of numbered categories for representation of data.","type":"string"},"new_event_anatomic_site":{"description":"Text term to specify the anatomic location of the return of tumor after treatment.","type":"string"},"new_event_type":{"description":"Text term to identify a new tumor event.","type":"string"},"overall_survival":{"description":"Number of days between the date used for index and the patient\u2019s date of death or the date the patient was last known to be alive.","type":"string"},"perineural_invasion_present":{"description":"A yes/no indicator to ask if perineural invasion or inflitration of tumor or cancer is present.","type":"string"},"primary_diagnosis":{"description":"Text term for the structural pattern of cancer cells used to define a microscopic diagnosis.","type":"string"},"prior_malignancy":{"description":"Text term to describe the patient\u2019s history of prior cancer diagnosis and the spatial location of any previous cancer occurrence.","type":"string"},"prior_treatment":{"description":"A yes/no/unknown/not applicable indicator related to the administration of therapeutic agents received before the body specimen was collected.","type":"string"},"progression_free_survival":{"description":"Number of days between the date used for index and the first date the patient is known to be free of disease progression.","type":"string"},"progression_free_survival_event":{"description":"The event used to define the patient\u2019s disease progression.","type":"string"},"progression_or_recurrence":{"description":"Yes/No/Unknown indicator to identify whether a patient has had a new tumor event after initial treatment.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"residual_disease":{"description":"Text terms to describe the status of a tissue margin following surgical resection.","type":"string"},"site_of_resection_or_biopsy":{"description":"The third edition of the International Classification of Diseases for Oncology, published in 2000, used principally in tumor and cancer registries for coding the site (topography) and the histology (morphology) of neoplasms. The description of an anatomical region or of a body part. Named locations of, or within, the body. A system of numbered categories for representation of data.","type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"subjects":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"tissue_or_organ_of_origin":{"description":"Text term that describes the anatomic site of the tumor or disease.","type":"string"},"tumor_grade":{"description":"Numeric value to express the degree of abnormality of cancer cells, a measure of differentiation and aggressiveness.","type":"string"},"tumor_stage":{"description":"The extent of a cancer in the body. Staging is usually based on the size of the tumor, whether lymph nodes contain cancer, and whether the cancer has spread from the original site to other parts of the body. The accepted values for tumor_stage depend of the tumor site, type, and accepted staging system. These items should accompany the tumor_stage value as associated metadata.","type":"string"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"vascular_invasion_present":{"description":"The yes/no indicator to ask if large vessel or venous invasion was detected by surgery or presence in a tumor specimen.","type":"string"},"vital_status":{"description":"The survival state of the person registered on the protocol.","type":"string"},"year_of_diagnosis":{"description":"Numeric value to represent the year of an individual\u2019s initial pathologic diagnosis of cancer.","type":"string"}},"required":["submitter_id","type","subjects","last_known_disease_status","morphology","primary_diagnosis","progression_or_recurrence","site_of_resection_or_biopsy","tissue_or_organ_of_origin","tumor_grade","tumor_stage","vital_status"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Diagnosis","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"gene_expression":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"data_file","description":"Data file containing gene expression information generated internally by the GTEx.","id":"gene_expression","links":[{"exclusive":false,"required":true,"subgroup":[{"backref":"gene_expressions","label":"data_from","multiplicity":"many_to_one","name":"core_metadata_collections","required":false,"target_type":"core_metadata_collection"},{"backref":"gene_expressions","label":"data_from","multiplicity":"many_to_one","name":"rna_expression_workflows","required":false,"target_type":"rna_expression_workflow"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"core_metadata_collections":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_category":{"enum":["Transcriptome Profiling"],"term":{"description":"Broad categorization of the contents of the data file.\n"}},"data_format":{"enum":["CSV","GCT","GCTX","RES","TDF","TSV","TXT"],"term":{"description":"Format of the data files.\n"}},"data_type":{"enum":["Gene Expression Normalization","Gene Expression Quantification"],"term":{"description":"Specific content type of the data file.\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"experimental_strategy":{"enum":["Microarray","RNA-Seq","Total RNA-Seq"],"term":{"description":"The sequencing strategy used to generate the data file.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"rna_expression_workflows":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","file_name","file_size","md5sum","data_category","data_type","data_format","experimental_strategy"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime","file_state","error_type"],"title":"Gene Expression","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"germline_mutation_calling_workflow":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"analysis","description":"Metadata for the germline mutation calling pipeline used to call variants in the GDC DNA-Seq pipelines.\n","downloadable":false,"id":"germline_mutation_calling_workflow","links":[{"backref":"germline_mutation_calling_workflows","label":"performed_on","multiplicity":"one_to_many","name":"aligned_reads_files","required":true,"target_type":"aligned_reads"}],"namespace":"https://vpodc.org/","program":"*","project":"*","properties":{"aligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_end_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_link":{"description":"Link to Github hash for the CWL workflow used.","type":"string"},"workflow_start_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_type":{"enum":["HaplotypeCaller"],"term":{"description":"Generic name for the workflow used to analyze a data set.\n"}},"workflow_version":{"description":"Major version for a GDC workflow.","type":"string"}},"required":["submitter_id","workflow_link","workflow_type"],"submittable":false,"systemProperties":["id","project_id","created_datetime","updated_datetime","state"],"title":"Germline Mutation Calling Workflow","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"keyword":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"A keyword for a project.","id":"keyword","links":[{"backref":"keywords","label":"describe","multiplicity":"many_to_many","name":"projects","required":true,"target_type":"project"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"keyword_name":{"description":"The name of the keyword.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"projects":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"}]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","projects"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Keyword","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"metaschema":{"$schema":"http://json-schema.org/draft-04/schema#","allOf":[{"$ref":"http://json-schema.org/draft-04/schema#"}],"definitions":{"link":{"additionalProperties":false,"properties":{"backref":{"$ref":"#/field"},"label":{"$ref":"#/field"},"multiplicity":{"enum":["one_to_one","one_to_many","many_to_one","many_to_many"],"type":"string"},"name":{"$ref":"#/field"},"required":{"type":"boolean"},"target_type":{"$ref":"#/field"}},"required":["name","target_type","backref","label","multiplicity","required"],"type":"object"},"link_subgroup":{"properties":{"exclusive":{"type":"boolean"},"required":{"type":"boolean"},"subgroup":{"items":{"oneOf":[{"$ref":"#/definitions/link"},{"$ref":"#/definitions/link_subgroup"}]},"type":"array"}},"required":["exclusive","required","subgroup"]},"validator_def":{"properties":{"link_to_type":{"type":"string"},"multiplicity":{"enum":["one_to_one","one_to_many","many_to_one","many_to_many"],"type":"string"}},"required":["property","function"],"title":"Define a validator to be used on a property","type":"object"}},"field":{"pattern":"^[_a-zA-Z0-9]*$","type":"string"},"id":"metaschema","properties":{"category":{"$ref":"#/field","enum":["administrative","analysis","biospecimen","clinical","data","data_bundle","data_file","index_file","metadata_file","notation","qc_bundle","TBD"]},"links":{"items":{"oneOf":[{"$ref":"#/definitions/link"},{"$ref":"#/definitions/link_subgroup"}]},"title":"Define a link to other GDC entities","type":"array"},"properties":{"additionalProperties":false,"patternProperties":{"^[_a-zA-Z0-9]*$":{"type":"object"}},"type":"object"},"submittable":{"type":"boolean"},"system_properties":{"type":"array"},"unique_keys":{"items":{"items":{"type":"string"},"type":"array"},"type":"array"},"validators":{"items":{"$ref":"#/definitions/validator_def"},"type":["array","null"]}},"required":["category","program","project","uniqueKeys","links","validators","systemProperties","id"],"title":"GDC JSON schema extension"},"program":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"A broad framework of goals to be achieved. (NCIt C52647)\n","id":"program","links":[],"program":"*","project":"*","properties":{"dbgap_accession_number":{"description":"The dbgap accession number provided for the program.","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"name":{"description":"Full name/title of the program.","type":"string"},"type":{"type":"string"}},"required":["name","dbgap_accession_number"],"submittable":false,"systemProperties":["id"],"title":"Program","type":"object","uniqueKeys":[["id"],["name"]],"validators":null},"project":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","constraints":null,"description":"Any specifically defined piece of work that is undertaken or attempted to meet a single requirement. (NCIt C47885)\n","downloadable":false,"id":"project","links":[{"backref":"projects","label":"member_of","multiplicity":"many_to_one","name":"programs","required":true,"target_type":"program"}],"previous_version_downloadable":false,"program":"*","project":"*","properties":{"availability_mechanism":{"description":"Mechanism by which the project will be made avilable.","type":"string"},"availability_type":{"description":"Is the project open or restricted? Functionality unused in BMS instance.","enum":["Open","Restricted"]},"awg_review":{"default":false,"description":"Indicates that the project is an AWG project.\n","type":"boolean"},"code":{"description":"Unique identifier for the project.","type":"string"},"collaborators":{"description":"List of collaborators who have data read access to the project. Expressed as '{email}:{role1},{role2}' (actually just an email string for now). Modifying this field will change Arborist permissions.","item_type":"string","items":{"type":"string"},"type":"array"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"creator":{"description":"Username of user who created the project.","type":"string"},"data_provider":{"description":"List the name of the Vendor who is processing the data.","enum":["10x genomics","ABI","Active Motif","Adaptive","AltraBio","Asuragen","Baylor College Of Medicine","BBRC","Beijing Chaoyang Hospital, Capital Medical University","BGI","Biognosys","BLUEPRINT","BMA","BMS","Broad","Brooks","CGG","CGI","Cytapex","DDL","DFCI","EGA","Expression Analysis","Flagship Bioscience","Foundation Medicine","Genewiz","Genomics","GEO","GRC","Guardant","HCA","HTG Molecular","illumina","M2GEN","Medgenome","Moffitt","MSKCC","NIH","Novo Nordisk","Novogene - China","NYGC","Other","Parker Institute for Cancer Immunotherapy","PathAI INC","Personal Genome Diagnostic","Public","Q2 Expression Analysis","Qiagen","QPS","Rockefeller University","Second Genome Solutions","SGI","SRA","Stanford","Swift Biosciences","Tempus","TGEN","Tsinghua","U Lausanne","UCSD","UKBiobank/Regeneron","VCU","WUXI"]},"date_collected":{"description":"The date or date range in which the project data was collected.","type":"string"},"dbgap_accession_number":{"description":"The dbgap accession number provided for the project.","type":"string"},"disease_type":{"description":"Full name for the project","type":"string"},"experimental_strategy":{"description":"Describes the various Experimental Types a analysis can support.","enum":["Comparative Genomic Hybridization","Cytogenetics, NOS","DNA-Seq","Edge-Sequencing","Exploratory","FISH","Flow Cytometery","IHC","ISH","Karyotype","Microarray","Microsatellite Analysis","Not Reported","Nuclear Staining","RNA-Seq","RT-PCR","Sequencing - NOS","Targeted Proteome","Targeted Sequencing","WES","WGS","WXS","Other"]},"id":{"description":"UUID for the project.","pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"in_review":{"default":false,"description":"Indicates that the project is under review by the submitter. Upload and data modification is disabled.\n","type":"boolean"},"indication":{"description":"Describes the Type Indication tested for this Analysis.","enum":["Lung","Lung - NSCLC","Lung - NSCLC - Adenocarcinoma","Lung - NSCLC - Squamous Cell Carcinoma","Lung - NSCLC -Large Cell Carcinoma","Lung - NSCLC -Large Cell Neuroendocrine Tumors","Lung - SCLC","Lung - Mesothelimia","Melonoma","Renal","Bladder","CRC and MSI Tumors","Prostate","HCC","HCC - uninfected","HCC - HBV","HCC - HCV","GBM","GBM - MGMT Methylated","GBM - MGMT Un-Methylated","HEME - Hodgkin Lymphoma","HEME - Hodgkin Lymphoma - LHL","HEME - Hodgkin Lymphoma - MHL","HEME - Hodgkin Lymphoma - OHL","HEME - B Cell Non -Hodgkin Lymphoma","HEME - B Cell Non -Hodgkin Lymphoma - DLBCL","HEME - B Cell Non -Hodgkin Lymphoma - FL","HEME - B Cell Non -Hodgkin Lymphoma - OBL","HEME - B Cell Non -Hodgkin Lymphoma - PMBCL","HEME - T Cell Non -Hodgkin Lymphoma","HEME - T Cell Non -Hodgkin Lymphoma - CTCL","HEME - T Cell Non -Hodgkin Lymphoma - ONCTCL","HEME - T Cell Non -Hodgkin Lymphoma - OCTCL","HEME - T Cell Non -Hodgkin Lymphoma - PTCL","HEME - T Cell Non -Hodgkin Lymphoma - SCTCL","HEME - MM","HEME - LEUKEMIA","HEME - LEUKEMIA - AML","HEME - LEUKEMIA - CML","Fraction","Head and Neck","Gastric/Esophogeal","Other - Pediatric","Other - Ovarian","IOCC - Trials","Other - Viral","Other - Daratumab/Nivo Combo","Other - CNS","Custom","None"]},"intended_release_date":{"description":"Tracks a Project's intended release date.","type":"string"},"investigator_affiliation":{"description":"The investigator's affiliation with respect to a research institution.","type":"string"},"investigator_name":{"description":"Name of the principal investigator for the project.","type":"string"},"is_legacy":{"default":false,"description":"Indicates whether a project will appear in the Legacy Archive.\n","type":"string"},"lead_bi_analyst":{"description":"Lead Bioinformatics Analyst","type":"string"},"name":{"description":"Display name/brief description for the project.","type":"string"},"primary_site":{"description":"Primary site for the project","type":"string"},"programs":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}],"description":"Indicates that the project is logically part of the indicated project.\n"},"project_barcode":{"description":"Unique barcode identifier for the project.","type":"string"},"project_description":{"description":"Free flow description of the Project.","type":"string"},"project_type":{"description":"Describes the Type of the Project.","enum":["Clinical","Non Clinical"]},"releasable":{"default":false,"description":"A project can only be released by the user when `releasable` is true.\n","type":"boolean"},"release_requested":{"default":false,"description":"User requests that the GDC release the project. Release can only be requested if the project is releasable.\n","type":"boolean"},"released":{"default":false,"description":"To release a project is to tell the GDC to include all submitted entities in the next GDC index.\n","type":"boolean"},"request_submission":{"default":false,"description":"Indicates that the user has requested submission to the GDC for harmonization.\n","type":"boolean"},"state":{"default":"open","description":"The possible states a project can be in.  All but `open` are equivalent to some type of locked state.\n","enum":["open","review","submitted","processing","processed","closed","legacy"]},"submission_enabled":{"default":true,"description":"Indicates if submission to a project is allowed.\n","type":"boolean"},"support_id":{"description":"The ID of the source providing support/grant resources.","type":"string"},"support_source":{"description":"The name of source providing support/grant resources.","type":"string"},"therapeutic_area":{"description":"Describes the Therapeutic Areas Being Tested for in the Analysis.","enum":["Atherosclerosis NOS","Cardiovascular","Dermatology","Fibrosis - DA","Hematology","Immuno Sciences","Infectious Diseases - Discovery","Metabolic Diseases","NASH","Oncology","TBD - Discovery","Virology","Other"]},"trial":{"description":"Describes the Trial that was included for the analysis.","type":"string"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["type","code","name","state","programs","dbgap_accession_number","project_barcode","project_description","project_type","availability_type","investigator_name","creator"],"submittable":false,"systemProperties":["id","state","released","releasable","intended_release_date","created_datetime","updated_datetime"],"title":"Project","type":"object","uniqueKeys":[["id"],["code"]],"validators":null},"protocol":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"The formal plan of an experiment or research activity, including the objective, rationale, design, materials and methods for the conduct of the study; intervention description, and method of data analysis. (NCIt - C70817)","id":"protocol","links":[{"backref":"protocols","label":"derived_from","multiplicity":"many_to_many","name":"studies","required":true,"target_type":"study"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"acquisition_type":{"description":"Mass Spectrometry- Mass spectrometry acquisition method.","type":"string"},"alkylation_reagent":{"description":"Sample Preparation- Reagent used for alkylation.","type":"string"},"amount_on_column":{"description":"Liquid Chromatography- approximate mass with units.","type":"string"},"chromatographic_dimension":{"description":"Liquid Chromatography- dimension ordinal.","type":"integer"},"chromatography_dimensions_count":{"description":"Sample Preparation- Number of discrete chromatographic dimensions used.","type":"integer"},"chromatography_type":{"description":"Liquid Chromatography- General type of chromatography.","type":"string"},"collision_energy":{"description":"Mass Spectrometry- normalized collisions energy (%).","type":"string"},"column_inner_diameter":{"description":"Liquid Chromatography- with units.","type":"string"},"column_length":{"description":"Liquid Chromatography- with units.","type":"string"},"column_type":{"description":"Liquid Chromatography- Type of column used.","type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"dda_topn":{"description":"Mass Spectrometry- number of precursors sampled per cycle.","type":"string"},"dia_ims":{"description":"Mass Spectrometry- Uses ion mobility separation.","type":"boolean"},"dia_multiplexing":{"description":"Mass Spectrometry- Uses MSX.","type":"boolean"},"digestion_reagent":{"description":"Sample Preparation- Enzyme or reagent used for digestion. If multiple used list 2 separated by (;).","type":"string"},"dissociation_type":{"description":"Mass Spectrometry- gas phase dissociation type.","type":"string"},"document_name":{"description":"Sample Preparation- External Analytical sample protocol document name.","type":"string"},"enrichment_strategy":{"description":"Sample Preparation- Type of peptide or protein enrichment.","type":"string"},"fractions_produced_count":{"description":"Sample Preparation- Final number of fractions produced following any pooling, for example.","type":"string"},"gradient_length":{"description":"Liquid Chromatography- time with units.","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"instrument_make":{"description":"Mass Spectrometry- Manufacturer of instrument.","type":"string"},"instrument_model":{"description":"Mass Spectrometry- Model of instrument.","type":"string"},"instrument_serial_number":{"description":"Mass Spectrometry- serial number from instrument used in study.","type":"string"},"isobaric_labeling_reagent":{"description":"Sample Preparation- Reagent used for isobaric labeling.","type":"string"},"label_free_quantitation":{"description":"Sample Preparation- type of label free data analysis strategy proposed for this data.","type":"string"},"labeled_quantitation":{"description":"Sample Preparation- type of labeling used.","type":"string"},"labeling_strategy":{"description":"Sample Preparation- general strategy used for differential analysis.","type":"string"},"ms1_resolution":{"description":"Mass Spectrometry- MS1 resolution, typically at 400 m/z.","type":"integer"},"ms2_resolution":{"description":"Mass Spectrometry- MS2 resolution, typically at 400 m/z.","type":"integer"},"particle_size":{"description":"Liquid Chromatography- with units.","type":"string"},"particle_type":{"description":"Liquid Chromatography- manufacturer or brand name of particle if applicable.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"protocol_date":{"description":"Sample Preparation- External analytical sample protocol create or update date.","type":"string"},"protocol_document_name":{"description":"Liquid Chromatography- External chromatography protocol document name.","type":"string"},"protocol_name":{"description":"Sample Preparation- External Analytical sample protocol name.","type":"string"},"protocol_type":{"description":"Mass Spectrometry- Controlled Vocabulary can suggest new terms if needed.","type":"string"},"starting_amount":{"description":"Sample Preparation- Mass with units.","type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"studies":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","studies"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Protocol","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"read_group":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"biospecimen","description":"Sequencing reads from one lane of an NGS experiment.","id":"read_group","links":[{"backref":"read_groups","label":"derived_from","multiplicity":"many_to_one","name":"aliquots","required":true,"target_type":"aliquot"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"RIN":{"term":{"description":"A numerical assessment of the integrity of RNA based on the entire electrophoretic trace of the RNA sample including the presence or absence of degradation products.\n","termDef":{"cde_id":5278775,"cde_version":1.0,"source":"caDSR","term":"Biospecimen RNA Integrity Number Value","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5278775&version=1.0"}},"type":"number"},"adapter_name":{"term":{"description":"Name of the sequencing adapter.\n"},"type":"string"},"adapter_sequence":{"term":{"description":"Base sequence of the sequencing adapter.\n"},"type":"string"},"aliquots":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"base_caller_name":{"term":{"description":"Name of the base caller.\n"},"type":"string"},"base_caller_version":{"term":{"description":"Version of the base caller.\n"},"type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"experiment_name":{"term":{"description":"Submitter-defined name for the experiment.\n"},"type":"string"},"flow_cell_barcode":{"term":{"description":"Flow cell barcode. Wrong or missing information may affect analysis results.\n"},"type":"string"},"fragment_maximum_length":{"term":{"description":"Maximum length of the sequenced fragments (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"type":"integer"},"fragment_mean_length":{"term":{"description":"Mean length of the sequenced fragments (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"type":"number"},"fragment_minimum_length":{"term":{"description":"Minimum length of the sequenced fragments (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"type":"integer"},"fragment_standard_deviation_length":{"term":{"description":"Standard deviation of the sequenced fragments length (e.g., as predicted by Agilent Bioanalyzer).\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"type":"number"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"includes_spike_ins":{"term":{"description":"Spike-in included?\n"},"type":"boolean"},"instrument_model":{"enum":["454 GS FLX Titanium","AB SOLiD 2","AB SOLiD 3","AB SOLiD 4","Complete Genomics","Illumina Genome Analyzer II","Illumina Genome Analyzer IIx","Illumina HiSeq 2000","Illumina HiSeq 2500","Illumina HiSeq 4000","Illumina HiSeq X Five","Illumina HiSeq X Ten","Illumina MiSeq","Illumina NextSeq 500","Illumina NextSeq 550","Illumina NovaSeq 6000","Ion Torrent PGM","Ion Torrent Proton","Other","PacBio RS"],"term":{"description":"Numeric value that represents the sample dimension that is greater than the shortest dimension and less than the longest dimension, measured in millimeters.\n","termDef":{"cde_id":5432604,"cde_version":1.0,"source":"caDSR","term":"Tissue Sample Intermediate Dimension Millimeter Measurement","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432604&version=1.0"}}},"is_paired_end":{"term":{"description":"Are the reads paired end?\n"},"type":"boolean"},"lane_number":{"term":{"description":"The basic machine unit for sequencing. For Illumina machines, this reflects the physical lane number. Wrong or missing information may affect analysis results.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"type":"integer"},"library_name":{"term":{"description":"Name of the library.\n"},"type":"string"},"library_preparation_kit_catalog_number":{"term":{"description":"Catalog of Library Preparation Kit\n"},"type":"string"},"library_preparation_kit_name":{"term":{"description":"Name of Library Preparation Kit\n"},"type":"string"},"library_preparation_kit_vendor":{"term":{"description":"Vendor of Library Preparation Kit\n"},"type":"string"},"library_preparation_kit_version":{"term":{"description":"Version of Library Preparation Kit\n"},"type":"string"},"library_selection":{"enum":["Affinity Enrichment","Hybrid Selection","Other","PCR","Poly-T Enrichment","Random","miRNA Size Fractionation","rRNA Depletion"],"term":{"description":"Library Selection Method\n"}},"library_strand":{"enum":["First Stranded","Not Applicable","Second Stranded","Unstranded"],"term":{"description":"Library stranded-ness.\n"}},"library_strategy":{"enum":["Amplicon","Bisulfite-Seq","ChIP-Seq","Other","RNA-Seq","Targeted Sequencing","Validation","WGS","WXS","miRNA-Seq"],"term":{"description":"Library strategy.\n"}},"multiplex_barcode":{"term":{"description":"The barcode/index sequence used. Wrong or missing information may affect analysis results.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}},"type":"string"},"platform":{"enum":["Complete Genomics","Illumina","Ion Torrent","LS454","Other","PacBio","SOLiD"],"term":{"description":"Name of the platform used to obtain data.\n"}},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"read_group_name":{"description":"Read Group Name","type":"string"},"read_length":{"description":"Length of the reads","type":"integer"},"sequencing_center":{"term":{"description":"Name of the center that provided the sequence files.\n"},"type":"string"},"sequencing_date":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"size_selection_range":{"term":{"description":"Range of size selection.\n"},"type":"string"},"spike_ins_concentration":{"term":{"description":"Spike in concentration.\n"},"type":"string"},"spike_ins_fasta":{"term":{"description":"Name of the FASTA file that contains the spike-in sequences.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"target_capture_kit":{"enum":["Custom AmpliSeq Cancer Hotspot GENIE-MDA Augmented Panel v1 - 46 Genes","Custom GENIE-DFCI OncoPanel - 275 Genes","Custom GENIE-DFCI Oncopanel - 300 Genes","Custom GENIE-DFCI Oncopanel - 447 Genes","Custom HaloPlex DLBCL Panel - 370 Genes","Custom Ion AmpliSeq Hotspot GENIE-MOSC3 Augmented Panel - 74 Genes","Custom Large Construct Capture TARGET-OS Panel - 8 Genes","Custom MSK IMPACT Panel - 341 Genes","Custom MSK IMPACT Panel - 410 Genes","Custom MSK IMPACT Panel - 468 Genes","Custom Myeloid GENIE-VICC Panel - 37 Genes","Custom PGDX SureSelect CancerSelect VAREPOP-APOLLO Panel - 203 Genes","Custom PGDX SureSelect CancerSelect VAREPOP-APOLLO Panel - 88 Genes","Custom SeqCap EZ HGSC VCRome v2.1 ER Augmented v1","Custom SeqCap EZ HGSC VCRome v2.1 ER Augmented v2","Custom SeqCap EZ TARGET-OS Panel - 7.0 Mb","Custom Solid Tumor GENIE-VICC Panel - 34 Genes","Custom SureSelect CGCI-BLGSP Panel - 4.6 Mb","Custom SureSelect GENIE-UHN Panel - 555 Genes","Custom SureSelect TARGET-AML_NBL_WT Panel - 2.8 Mb","Foundation Medicine T5a Panel - 322 Genes","Foundation Medicine T7 Panel - 429 Genes","Ion AmpliSeq Cancer Hotspot Panel v2","Ion AmpliSeq Comprehensive Cancer Panel","Nextera Rapid Capture Exome v1.2","Not Applicable","SeqCap EZ HGSC VCRome v2.1","SureSelect Human All Exon v3","SureSelect Human All Exon v5","TruSeq Amplicon Cancer Panel","TruSeq Exome Enrichment - 62 Mb","TruSight Myeloid Sequencing Panel","Unknown"],"term":{"description":"Description that can uniquely identify a target capture kit. Suggested value is a combination of vendor, kit name, and kit version.\n"}},"to_trim_adapter_sequence":{"term":{"description":"Does the user suggest adapter trimming?\n"},"type":"boolean"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","aliquots"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Read Group","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"read_group_qc":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"analysis","description":"GDC QC run metadata.","id":"read_group_qc","links":[{"backref":"read_group_qcs","label":"generated_from","multiplicity":"many_to_one","name":"read_groups","required":true,"target_type":"read_group"},{"exclusive":true,"required":true,"subgroup":[{"backref":"read_group_qcs","label":"data_from","multiplicity":"one_to_many","name":"submitted_unaligned_reads_files","required":false,"target_type":"submitted_unaligned_reads"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"adapter_content":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"basic_statistics":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"encoding":{"term":{"description":"Version of ASCII encoding of quality values found in the file.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"Encoding","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/1%20Basic%20Statistics.html"}},"type":"string"},"fastq_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"kmer_content":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"overrepresented_sequences":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"per_base_n_content":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"per_base_sequence_content":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"per_base_sequence_quality":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"per_sequence_gc_content":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"per_sequence_quality_score":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"per_tile_sequence_quality":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"percent_aligned":{"description":"The percent of reads with at least one reported alignment.","maximum":100,"minimum":0,"type":"integer"},"percent_gc_content":{"maximum":100,"minimum":0,"term":{"description":"The overall %GC of all bases in all sequences.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"%GC","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/1%20Basic%20Statistics.html"}},"type":"integer"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"read_groups":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"sequence_duplication_levels":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"sequence_length_distribution":{"enum":["FAIL","PASS","WARN"],"term":{"description":"State classification given by FASTQC for the metric. Metric specific details about the states are available on their website.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"QC Metric State","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/"}}},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitted_unaligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"total_aligned_reads":{"description":"The total number of reads with at least one reported alignment.","type":"integer"},"total_sequences":{"term":{"description":"A count of the total number of sequences processed.\n","termDef":{"cde_id":null,"cde_version":null,"source":"FastQC","term":"Total Sequences","term_url":"http://www.bioinformatics.babraham.ac.uk/projects/fastqc/Help/3%20Analysis%20Modules/1%20Basic%20Statistics.html"}},"type":"integer"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_end_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_link":{"description":"Link to Github hash for the CWL workflow used.","type":"string"},"workflow_start_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_type":{"enum":["Read Group Quality Control"],"term":{"description":"Generic name for the workflow used to analyze a data set.\n"}},"workflow_version":{"description":"Major version for a GDC workflow.","type":"string"}},"required":["submitter_id","type","workflow_link","percent_gc_content","encoding","total_sequences","basic_statistics","per_base_sequence_quality","per_tile_sequence_quality","per_sequence_quality_score","per_base_sequence_content","per_sequence_gc_content","per_base_n_content","sequence_length_distribution","sequence_duplication_levels","overrepresented_sequences","adapter_content","kmer_content","read_groups"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Read Group QC","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"rna_expression_workflow":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"analysis","description":"Metadata for the RNA expression pipeline used to quantify RNA gene and exon expression from unharmonized or GDC harmonized data.","id":"rna_expression_workflow","links":[{"exclusive":true,"required":true,"subgroup":[{"backref":"rna_expression_workflows","label":"performed_on","multiplicity":"many_to_many","name":"aligned_reads_files","required":false,"target_type":"aligned_reads"},{"backref":"rna_expression_workflows","label":"performed_on","multiplicity":"many_to_many","name":"submitted_unaligned_reads_files","required":false,"target_type":"submitted_unaligned_reads"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"aligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitted_unaligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_end_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_link":{"description":"Link to Github hash for the CWL workflow used.","type":"string"},"workflow_start_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_type":{"enum":["ASE","Cufflinks","DEXSeq","Flux","HTSeq - Counts","HTSeq - FPKM","HTSeq - FPKM-UQ","Kallisto","RNASeQC","RSEM"],"term":{"description":"Generic name for the workflow used to analyze a data set.\n"}},"workflow_version":{"description":"Major version for a GDC workflow.","type":"string"}},"required":["submitter_id","type","workflow_type","workflow_link"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"RNA Expression Workflow","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"root":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"internal","constraints":null,"id":"root","links":[],"program":"*","project":"*","properties":{"id":{"enum":["root"]},"schema_version":{"type":"string"},"type":{"type":"string"}},"required":["type"],"root":"*","submittable":false,"systemProperties":["id"],"title":"Root","type":"object","uniqueKeys":[["id"]],"validators":null},"sample":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"biospecimen","description":"Any material sample taken from a biological entity for testing, diagnostic, propagation, treatment or research purposes, including a sample obtained from a living organism or taken from the biological object after halting of all its life functions. Biospecimen can contain one or more components including but not limited to cellular molecules, cells, tissues, organs, body fluids, embryos, and body excretory products.","id":"sample","links":[{"backref":"samples","label":"derived_from","multiplicity":"many_to_one","name":"subjects","required":true,"target_type":"subject"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"biospecimen_anatomic_site":{"enum":["Abdomen","Abdominal Wall","Acetabulum","Adenoid","Adipose","Adrenal","Alveolar Ridge","Amniotic Fluid","Ampulla Of Vater","Anal Sphincter","Ankle","Anorectum","Antecubital Fossa","Antrum","Anus","Aorta","Aortic Body","Appendix","Aqueous Fluid","Arm","Artery","Ascending Colon","Ascending Colon Hepatic Flexure","Auditory Canal","Autonomic Nervous System","Axilla","Back","Bile Duct","Bladder","Blood","Blood Vessel","Bone","Bone Marrow","Bowel","Brain","Brain Stem","Breast","Broad Ligament","Bronchiole","Bronchus","Brow","Buccal Cavity","Buccal Mucosa","Buttock","Calf","Capillary","Cardia","Carina","Carotid Artery","Carotid Body","Cartilage","Cecum","Cell-Line","Central Nervous System","Cerebellum","Cerebral Cortex","Cerebrospinal Fluid","Cerebrum","Cervical Spine","Cervix","Chest","Chest Wall","Chin","Clavicle","Clitoris","Colon","Colon - Mucosa Only","Common Duct","Conjunctiva","Connective Tissue","Dermal","Descending Colon","Diaphragm","Duodenum","Ear","Ear Canal","Ear, Pinna (External)","Effusion","Elbow","Endocrine Gland","Epididymis","Epidural Space","Esophagogastric Junction","Esophagus","Esophagus - Mucosa Only","Eye","Fallopian Tube","Femoral Artery","Femoral Vein","Femur","Fibroblasts","Fibula","Finger","Floor Of Mouth","Fluid","Foot","Forearm","Forehead","Foreskin","Frontal Cortex","Frontal Lobe","Fundus Of Stomach","Gallbladder","Ganglia","Gastroesophageal Junction","Gastrointestinal Tract","Groin","Gum","Hand","Hard Palate","Head & Neck","Head - Face Or Neck, Nos","Heart","Hepatic","Hepatic Duct","Hepatic Vein","Hip","Hippocampus","Humerus","Hypopharynx","Ileum","Ilium","Index Finger","Ischium","Islet Cells","Jaw","Jejunum","Joint","Kidney","Knee","Lacrimal Gland","Large Bowel","Laryngopharynx","Larynx","Leg","Leptomeninges","Ligament","Lip","Liver","Lumbar Spine","Lung","Lymph Node","Lymph Node(s) Axilla","Lymph Node(s) Cervical","Lymph Node(s) Distant","Lymph Node(s) Epitrochlear","Lymph Node(s) Femoral","Lymph Node(s) Hilar","Lymph Node(s) Iliac-Common","Lymph Node(s) Iliac-External","Lymph Node(s) Inguinal","Lymph Node(s) Internal Mammary","Lymph Node(s) Mammary","Lymph Node(s) Mesenteric","Lymph Node(s) Occipital","Lymph Node(s) Paraaortic","Lymph Node(s) Parotid","Lymph Node(s) Pelvic","Lymph Node(s) Popliteal","Lymph Node(s) Regional","Lymph Node(s) Retroperitoneal","Lymph Node(s) Scalene","Lymph Node(s) Splenic","Lymph Node(s) Subclavicular","Lymph Node(s) Submandibular","Lymph Node(s) Supraclavicular","Lymph Nodes(s) Mediastinal","Mandible","Maxilla","Mediastinal Soft Tissue","Mediastinum","Mesentery","Mesothelium","Middle Finger","Mitochondria","Muscle","Nails","Nasal Cavity","Nasal Soft Tissue","Nasopharynx","Neck","Nerve","Nerve(s) Cranial","Not Allowed To Collect","Not Reported","Occipital Cortex","Ocular Orbits","Omentum","Oral Cavity","Oral Cavity - Mucosa Only","Oropharynx","Other","Ovary","Palate","Pancreas","Paraspinal Ganglion","Parathyroid","Parotid Gland","Patella","Pelvis","Penis","Pericardium","Periorbital Soft Tissue","Peritoneal Cavity","Peritoneum","Pharynx","Pineal","Pineal Gland","Pituitary Gland","Placenta","Pleura","Popliteal Fossa","Prostate","Pylorus","Rectosigmoid Junction","Rectum","Retina","Retro-Orbital Region","Retroperitoneum","Rib","Ring Finger","Round Ligament","Sacrum","Salivary Gland","Scalp","Scapula","Sciatic Nerve","Scrotum","Seminal Vesicle","Shoulder","Sigmoid Colon","Sinus","Sinus(es), Maxillary","Skeletal Muscle","Skin","Skull","Small Bowel","Small Bowel - Mucosa Only","Small Finger","Soft Tissue","Spinal Column","Spinal Cord","Spleen","Splenic Flexure","Sternum","Stomach","Stomach - Mucosa Only","Subcutaneous Tissue","Synovium","Temporal Cortex","Tendon","Testis","Thigh","Thoracic Spine","Thorax","Throat","Thumb","Thymus","Thyroid","Tibia","Tongue","Tonsil","Tonsil (Pharyngeal)","Trachea / Major Bronchi","Transverse Colon","Trunk","Umbilical Cord","Unknown","Ureter","Urethra","Urinary Tract","Uterus","Uvula","Vagina","Vas Deferens","Vein","Venous","Vertebra","Vulva","White Blood Cells","Wrist"],"term":{"description":"Text term that represents the name of the primary disease site of the submitted tumor sample.\n","termDef":{"cde_id":4742851,"cde_version":1.0,"source":"caDSR","term":"Submitted Tumor Sample Primary Anatomic Site","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=4742851&version=1.0"}}},"cell_line_aliases":{"description":"Cell line alias name commonly used.","type":"string"},"cell_primary_name":{"description":"Cell line primary name kept in repository resource.","type":"string"},"composition":{"enum":["Bone Marrow Components","Bone Marrow Components NOS","Buccal Cells","Buffy Coat","Cell","Circulating Tumor Cell (CTC)","Control Analyte","Derived Cell Line","EBV Immortalized","Fibroblasts from Bone Marrow Normal","Granulocytes","Human Original Cells","Lymphocytes","Mononuclear Cells from Bone Marrow Normal","Not Allowed To Collect","Not Reported","Peripheral Blood Components NOS","Peripheral Blood Nucleated Cells","Peripheral Whole Blood","Plasma","Pleural Effusion","Saliva","Serum","Solid Tissue","Sputum","Unknown","Whole Bone Marrow"],"term":{"description":"Text term that represents the cellular composition of the sample.\n","termDef":{"cde_id":5432591,"cde_version":1.0,"source":"caDSR","term":"Biospecimen Cellular Composition Type","term_url":"https://cdebrowser.nci.nih.gov/cdebrowserClient/cdeBrowser.html#/search?publicId=5432591&version=1.0"}}},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"current_weight":{"description":"Numeric value that represents the current weight of the sample, measured in milligrams.","type":"number"},"days_to_collection":{"description":"Time interval from the date of biospecimen collection to the date of initial pathologic diagnosis, represented as a calculated number of days.","type":"integer"},"days_to_sample_procurement":{"description":"The number of days from the date the patient was diagnosed to the date of the procedure that produced the sample.","type":"integer"},"diagnosis_pathologically_confirmed":{"description":"The histologic description of tissue or cells confirmed by a pathology review of frozen or formalin fixed slide(s) completed after the diagnostic pathology review of the tumor sample used to extract analyte(s).","type":"string"},"freezing_method":{"description":"Text term that represents the method used for freezing the sample.","type":"string"},"gdc_project_id":{"description":"Project identifier associated with the sample at the genomic data commons.","type":"string"},"gdc_sample_id":{"description":"Sample identifier associated with the sample at the genomic data commons.","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"initial_weight":{"description":"Numeric value that represents the initial weight of the sample, measured in milligrams.","type":"number"},"intermediate_dimension":{"description":"Intermediate dimension of the sample, in millimeters.","type":"string"},"is_ffpe":{"description":"Indicator to signify whether or not the tissue sample was fixed in formalin and embedded in paraffin (FFPE).","type":"integer"},"longest_dimension":{"description":"Numeric value that represents the longest dimension of the sample, measured in millimeters.","type":"string"},"method_of_sample_procurement":{"description":"The method used to procure the sample used to extract analyte(s).","type":"string"},"notes":{"description":"Records of relationship to other cell line.","type":"string"},"oct_embedded":{"description":"Indicator of whether or not the sample was embedded in Optimal Cutting Temperature (OCT) compound.","type":"string"},"pathology_report_uuid":{"description":"UUID of the related pathology report.","type":"string"},"preservation_method":{"description":"Text term that represents the method used to preserve the sample.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"sample_type":{"description":"Characterization of the sample as either clinical or contrived.","enum":["Additional - New Primary","Additional Metastatic","Blood Derived Cancer - Bone Marrow, Post-treatment","Blood Derived Cancer - Peripheral Blood, Post-treatment","Blood Derived Normal","Bone Marrow Normal","Buccal Cell Normal","Cell Line Derived Xenograft Tissue","Cell Lines","Circulating Tumor Cell (CTC)","Clinical","Contrived","Control Analyte","DNA","EBV Immortalized Normal","FFPE Recurrent","FFPE Scrolls","Fibroblasts from Bone Marrow Normal","GenomePlex (Rubicon) Amplified DNA","Granulocytes","Human Tumor Original Cells","Metastatic","Mononuclear Cells from Bone Marrow Normal","Not Allowed To Collect","Not Reported","Pleural Effusion","Post neo-adjuvant therapy","Primary Blood Derived Cancer - Bone Marrow","Primary Blood Derived Cancer - Peripheral Blood","Primary Tumor","Primary Xenograft Tissue","RNA","Recurrent Blood Derived Cancer - Bone Marrow","Recurrent Blood Derived Cancer - Peripheral Blood","Recurrent Tumor","Repli-G (Qiagen) DNA","Repli-G X (Qiagen) DNA","Slides","Solid Tissue Normal","Total RNA","Unknown","Xenograft Tissue","cfDNA","ctDNA"]},"sample_type_id":{"description":"Code associated with the sample type.","type":"string"},"shortest_dimension":{"description":"Numeric value that represents the shortest dimension of the sample, measured in millimeters.","type":"string"},"source":{"description":"The name of primary source that the cell line is taken from.","type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"subjects":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"time_between_clamping_and_freezing":{"description":"Numeric representation of the elapsed time between the surgical clamping of blood supply and freezing of the sample, measured in minutes.","type":"string"},"time_between_excision_and_freezing":{"description":"Numeric representation of the elapsed time between the excision and freezing of the sample, measured in minutes.","type":"string"},"tissue_type":{"description":"Text term that represents a description of the kind of tissue collected with respect to disease status or proximity to tumor tissue.","type":"string"},"tumor_code":{"description":"Diagnostic tumor code of the tissue sample source.","type":"string"},"tumor_code_id":{"description":"BCR-defined id code for the tumor sample.","type":"string"},"tumor_descriptor":{"description":"Text that describes the kind of disease present in the tumor specimen as related to a specific timepoint.","type":"string"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","subjects","sample_type"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Sample","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"simple_germline_variation":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"data_file","description":"Data file containing simple germline variations called from aligned reads.\n","id":"simple_germline_variation","links":[{"exclusive":false,"required":true,"subgroup":[{"backref":"simple_germline_variations","label":"data_from","multiplicity":"many_to_one","name":"core_metadata_collections","required":false,"target_type":"core_metadata_collection"},{"backref":"simple_germline_variations","label":"data_from","multiplicity":"many_to_one","name":"germline_mutation_calling_workflows","required":false,"target_type":"germline_mutation_calling_workflow"},{"backref":"simple_germline_variations","label":"data_from","multiplicity":"many_to_many","name":"read_groups","required":false,"target_type":"read_group"},{"backref":"simple_germline_variations","label":"data_from","multiplicity":"many_to_many","name":"aligned_reads_files","required":false,"target_type":"aligned_reads"}]}],"namespace":"https://dcp.bionimbus.org/","program":"*","project":"*","properties":{"aligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"core_metadata_collections":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_category":{"enum":["Simple Nucleotide Variation"],"term":{"description":"Broad categorization of the contents of the data file.\n"}},"data_format":{"enum":["VCF"],"term":{"description":"Format of the data files.\n"}},"data_type":{"enum":["Simple Germline Variation"],"term":{"description":"Specific content type of the data file.\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"experimental_strategy":{"enum":["WGS","WXS","Low Pass WGS","Validation"],"term":{"description":"The sequencing strategy used to generate the data file.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"germline_mutation_calling_workflows":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"read_groups":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["type","submitter_id","file_name","file_size","md5sum","data_category","data_type","data_format","experimental_strategy"],"submittable":false,"systemProperties":["id","project_id","created_datetime","updated_datetime","state","file_state","error_type"],"title":"Simple Germline Variation","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"simple_somatic_mutation":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"data_file","description":"Data file containing simple somatic mutations, which have not been annotated or filtered, called from aligned reads.\n","downloadable":true,"id":"simple_somatic_mutation","links":[{"exclusive":false,"required":true,"subgroup":[{"backref":"simple_somatic_mutations","label":"data_from","multiplicity":"many_to_one","name":"core_metadata_collections","required":false,"target_type":"core_metadata_collection"}]},{"backref":"simple_somatic_mutations","label":"data_from","multiplicity":"many_to_one","name":"somatic_mutation_calling_workflows","required":false,"target_type":"somatic_mutation_calling_workflow"}],"namespace":"https://vpodc.org/","program":"*","project":"*","properties":{"core_metadata_collections":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_category":{"enum":["Combined Nucleotide Variation","Simple Nucleotide Variation"],"term":{"description":"Broad categorization of the contents of the data file.\n"}},"data_format":{"enum":["VCF"],"term":{"description":"Format of the data files.\n"}},"data_type":{"enum":["Raw CGI Variant","Raw Simple Somatic Mutation"],"term":{"description":"Specific content type of the data file.\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"experimental_strategy":{"enum":["WGS","WXS","Low Pass WGS","Validation","Targeted Sequencing"],"term":{"description":"The sequencing strategy used to generate the data file.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"somatic_mutation_calling_workflows":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","file_name","file_size","md5sum","data_category","data_type","data_format","experimental_strategy"],"submittable":false,"systemProperties":["id","project_id","created_datetime","updated_datetime","state","file_state","error_type"],"title":"Simple Somatic Mutation","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"somatic_mutation_calling_workflow":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"analysis","description":"Metadata for the somatic mutation calling pipeline used to call variants in the GDC DNA-Seq pipelines.\n","downloadable":false,"id":"somatic_mutation_calling_workflow","links":[{"backref":"somatic_mutation_calling_workflows","label":"performed_on","multiplicity":"one_to_many","name":"aligned_reads_files","required":true,"target_type":"aligned_reads"}],"namespace":"https://vpodc.org/","program":"*","project":"*","properties":{"aligned_reads_files":{"anyOf":[{"items":{"additionalProperties":true,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_end_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_link":{"description":"Link to Github hash for the CWL workflow used.","type":"string"},"workflow_start_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"workflow_type":{"enum":["MuSE","MuTect2","Pindel","SomaticSniper","VarScan2"],"term":{"description":"Generic name for the workflow used to analyze a data set.\n"}},"workflow_version":{"description":"Major version for a GDC workflow.","type":"string"}},"required":["submitter_id","workflow_link","workflow_type"],"submittable":false,"systemProperties":["id","project_id","created_datetime","updated_datetime","state"],"title":"Somatic Mutation Calling Workflow","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"study":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"A coordinated set of actions and observations designed to generate data, with the ultimate goal of discovery or hypothesis testing.","id":"study","links":[{"backref":"studies","label":"performed_for","multiplicity":"many_to_one","name":"projects","required":true,"target_type":"project"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"analytical_fraction":{"description":"Type of peptide or protein enrichment","type":"string"},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_description":{"description":"Brief description of the data being provided for this study. Free text","type":"string"},"experiment_type":{"description":"General strategy used for differential analysis","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"is_clinical_trial":{"description":"Flag that indicates whether this is a clinical trial study","type":"boolean"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"projects":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"code":{"type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"}},"type":"object"}]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"study_completeness":{"description":"Description of data status. 0=Descriptive data and results as originally received from the data provider. 1=Includes updates to the original data submission short of completeness. 2=Complete set of descriptive data and results, as ascertained by curator.","enum":["0","1","2"]},"study_description":{"description":"A brief description of the study being performed. Free text","type":"string"},"study_design":{"description":"Summary of the goals the study is designed to discover. General description of the study's place in relation to a clinical application.","type":"string"},"study_doi":{"description":"Digital object identifier (DOI) is a type of persistent identifier used to uniquely identify objects","type":"string"},"study_objective":{"description":"The general objective of the study. What the study hopes to discover or determine through testing.","type":"string"},"study_organization":{"description":"Name of the primary organization that oversees implementation of the study","type":"string"},"study_release_date":{"description":"Latest date when the study was shared","type":"string"},"study_release_version":{"description":"Latest version of study shared","type":"string"},"study_setup":{"description":"Category","type":"string"},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","study_description","projects"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Study","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"subject":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"administrative","description":"The collection of all data related to a specific subject in the context of a specific study.","id":"subject","links":[{"backref":"subjects","label":"member_of","multiplicity":"many_to_one","name":"studies","required":true,"target_type":"study"}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"days_to_lost_to_followup":{"description":"The number of days between the date used for index and to the data the patient was lost to follow-up.","type":"integer"},"disease_type":{"description":"Name of the disease for the subject.","type":"string"},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"index_date":{"description":"The reference or anchor date used during date obfuscation, where a single date is obscurred by creating one or more date ranges in relation to this date.","enum":["Diagnosis","First Patient Visit","Infection","Study Enrollment"]},"lost_to_followup":{"description":"A yes/no indicator related to whether a patient was unable to be contacted for follow-up.","type":"string"},"primary_site":{"description":"Primary site for the subject.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"species":{"description":"Taxonomic species of the subject.","enum":["Drosophila melanogaster","Homo sapiens","Mus musculus","Mustela putorius furo","Rattus rattus","Sus scrofa"]},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"strain":{"description":"A lower-level taxonomic rank used in microbiology or virology, plants and rodents, usually at the intraspecific level (within a species)","type":"string"},"studies":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"tissue_source_site_code":{"description":"A clinical site that collects and provides patient samples and clinical metadata for research use.","type":"string"},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","studies"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime"],"title":"Subject","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null},"submitted_unaligned_reads":{"$schema":"http://json-schema.org/draft-04/schema#","additionalProperties":false,"category":"data_file","description":"Data file containing unaligned reads that have not been GDC Harmonized.","id":"submitted_unaligned_reads","links":[{"exclusive":false,"required":true,"subgroup":[{"backref":"submitted_unaligned_reads_files","label":"data_from","multiplicity":"many_to_one","name":"core_metadata_collections","required":false,"target_type":"core_metadata_collection"},{"backref":"submitted_unaligned_reads_files","label":"data_from","multiplicity":"many_to_one","name":"read_groups","required":false,"target_type":"read_group"}]}],"namespace":"https://nci-crdc-demo.datacommons.io/","nodeTerms":null,"program":"*","project":"*","properties":{"core_metadata_collections":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"created_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}},"data_category":{"enum":["Raw Sequencing Data","Sequencing Data","Sequencing Reads"],"term":{"description":"Broad categorization of the contents of the data file.\n"}},"data_format":{"enum":["BAM","FASTA","FASTQ"],"term":{"description":"Format of the data files.\n"}},"data_type":{"enum":["Unaligned Reads"],"term":{"description":"Specific content type of the data file.\n"}},"error_type":{"enum":["file_size","file_format","md5sum"],"term":{"description":"Type of error for the data file object.\n"}},"experimental_strategy":{"enum":["ATAC-Seq","Bisulfite-Seq","ChIP-Seq","Low Pass WGS","RNA-Seq","Targeted Sequencing","WGS","WXS","miRNA-Seq"],"term":{"description":"The sequencing strategy used to generate the data file.\n"}},"file_name":{"term":{"description":"The name (or part of a name) of a file (of any type).\n"},"type":"string"},"file_size":{"term":{"description":"The size of the data file (object) in bytes.\n"},"type":"integer"},"file_state":{"default":"registered","enum":["registered","uploading","uploaded","validating","validated","submitted","processing","processed","released","error"],"term":{"description":"The current state of the data file object.\n"}},"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","systemAlias":"node_id","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"md5sum":{"pattern":"^[a-f0-9]{32}$","term":{"description":"The 128-bit hash value expressed as a 32 digit hexadecimal number (in lower case) used as a file's digital fingerprint.\n"},"type":"string"},"object_id":{"description":"The GUID of the object in the index service.","type":"string"},"project_id":{"term":{"description":"Unique ID for any specific defined piece of work that is undertaken or attempted to meet a single requirement.\n"},"type":"string"},"read_groups":{"anyOf":[{"items":{"additionalProperties":true,"maxItems":1,"minItems":1,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"},"type":"array"},{"additionalProperties":true,"properties":{"id":{"pattern":"^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$","term":{"description":"A 128-bit identifier. Depending on the mechanism used to generate it, it is either guaranteed to be different from all other UUIDs/GUIDs generated until 3400 AD or extremely likely to be different. Its relatively small size lends itself well to sorting, ordering, and hashing of all sorts, storing in databases, simple allocation, and ease of programming in general.\n","termDef":{"cde_id":"C54100","cde_version":null,"source":"NCIt","term":"Universally Unique Identifier","term_url":"https://ncit.nci.nih.gov/ncitbrowser/ConceptReport.jsp?dictionary=NCI_Thesaurus&version=16.02d&ns=NCI_Thesaurus&code=C54100"}},"type":"string"},"submitter_id":{"type":"string"}},"type":"object"}]},"read_pair_number":{"enum":["R1","R2"],"term":{"description":"Denotes whether a submitted FASTQ file contains forward (R1) or reverse (R2) reads for paired-end sequencing.\n","termDef":{"cde_id":null,"cde_version":null,"source":null,"term":null,"term_url":null}}},"state":{"default":"validated","downloadable":["uploaded","md5summed","validating","validated","error","invalid","released"],"oneOf":[{"enum":["uploading","uploaded","md5summing","md5summed","validating","error","invalid","suppressed","redacted","live"]},{"enum":["validated","submitted","released"]}],"public":["live"],"term":{"description":"The current state of the object.\n"}},"submitter_id":{"description":"A project-specific identifier for a node. This property is the calling card/nickname/alias for a unit of submission. It can be used in place of the UUID for identifying or recalling a node.\n","type":["string"]},"type":{"type":"string"},"updated_datetime":{"oneOf":[{"format":"date-time","type":"string"},{"type":"null"}],"term":{"description":"A combination of date and time of day in the form [-]CCYY-MM-DDThh:mm:ss[Z|(+|-)hh:mm]\n"}}},"required":["submitter_id","type","file_name","file_size","md5sum","data_category","data_type","data_format","experimental_strategy"],"submittable":true,"systemProperties":["id","project_id","state","created_datetime","updated_datetime","file_state","error_type"],"title":"Submitted Unaligned Reads","type":"object","uniqueKeys":[["id"],["project_id","submitter_id"]],"validators":null}};
